import{S as Eb,i as kb,s as Pb,e as n,k as p,w as h,t as r,M as Cb,c as a,d as o,m as c,a as s,x as g,h as l,b as i,N,f as $b,G as e,g as f,y as _,q as v,o as b,B as y,v as Db,L as fr}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as xb}from"../../../../chunks/Tip-hf-doc-builder.js";import{D as R}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as O}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as F}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as dr}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function jb(M){let u,P,w,$,C;return $=new O({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){u=n("p"),P=r("Examples:"),w=p(),h($.$$.fragment)},l(m){u=a(m,"P",{});var x=s(u);P=l(x,"Examples:"),x.forEach(o),w=c(m),g($.$$.fragment,m)},m(m,x){f(m,u,x),e(u,P),f(m,w,x),_($,m,x),C=!0},p:fr,i(m){C||(v($.$$.fragment,m),C=!0)},o(m){b($.$$.fragment,m),C=!1},d(m){m&&o(u),m&&o(w),y($,m)}}}function Nb(M){let u,P,w,$,C;return $=new O({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){u=n("p"),P=r("Examples:"),w=p(),h($.$$.fragment)},l(m){u=a(m,"P",{});var x=s(u);P=l(x,"Examples:"),x.forEach(o),w=c(m),g($.$$.fragment,m)},m(m,x){f(m,u,x),e(u,P),f(m,w,x),_($,m,x),C=!0},p:fr,i(m){C||(v($.$$.fragment,m),C=!0)},o(m){b($.$$.fragment,m),C=!1},d(m){m&&o(u),m&&o(w),y($,m)}}}function Sb(M){let u,P;return{c(){u=n("p"),P=r("This function is experimental and might change in the future.")},l(w){u=a(w,"P",{});var $=s(u);P=l($,"This function is experimental and might change in the future."),$.forEach(o)},m(w,$){f(w,u,$),e(u,P)},d(w){w&&o(u)}}}function Tb(M){let u,P,w,$,C,m,x,T;return{c(){u=n("p"),P=r("It is required to be logged in ("),w=n("code"),$=r("huggingface-cli login"),C=r(") when you want to use private or "),m=n("a"),x=r(`gated
models`),T=r("."),this.h()},l(E){u=a(E,"P",{});var D=s(u);P=l(D,"It is required to be logged in ("),w=a(D,"CODE",{});var I=s(w);$=l(I,"huggingface-cli login"),I.forEach(o),C=l(D,") when you want to use private or "),m=a(D,"A",{href:!0,rel:!0});var W=s(m);x=l(W,`gated
models`),W.forEach(o),T=l(D,"."),D.forEach(o),this.h()},h(){i(m,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),i(m,"rel","nofollow")},m(E,D){f(E,u,D),e(u,P),e(u,w),e(w,$),e(u,C),e(u,m),e(m,x),e(u,T)},d(E){E&&o(u)}}}function Ab(M){let u,P,w,$,C,m,x,T;return x=new O({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("sd-concepts-library/cat-toy")

prompt = "A <cat-toy> backpack"

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("cat-backpack.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;sd-concepts-library/cat-toy&quot;</span>)

prompt = <span class="hljs-string">&quot;A &lt;cat-toy&gt; backpack&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;cat-backpack.png&quot;</span>)`}}),{c(){u=n("p"),P=r("To load a textual inversion embedding vector in "),w=n("code"),$=r("diffusers"),C=r(" format:"),m=p(),h(x.$$.fragment)},l(E){u=a(E,"P",{});var D=s(u);P=l(D,"To load a textual inversion embedding vector in "),w=a(D,"CODE",{});var I=s(w);$=l(I,"diffusers"),I.forEach(o),C=l(D," format:"),D.forEach(o),m=c(E),g(x.$$.fragment,E)},m(E,D){f(E,u,D),e(u,P),e(u,w),e(w,$),e(u,C),f(E,m,D),_(x,E,D),T=!0},p:fr,i(E){T||(v(x.$$.fragment,E),T=!0)},o(E){b(x.$$.fragment,E),T=!1},d(E){E&&o(u),E&&o(m),y(x,E)}}}function Ib(M){let u,P,w,$,C,m,x,T;return x=new O({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("./charturnerv2.pt")

prompt = "charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details."

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("character.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;./charturnerv2.pt&quot;</span>)

prompt = <span class="hljs-string">&quot;charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details.&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;character.png&quot;</span>)`}}),{c(){u=n("p"),P=r("e.g. from "),w=n("a"),$=r("civitAI"),C=r(" and then load the vector locally:"),m=p(),h(x.$$.fragment),this.h()},l(E){u=a(E,"P",{});var D=s(u);P=l(D,"e.g. from "),w=a(D,"A",{href:!0,rel:!0});var I=s(w);$=l(I,"civitAI"),I.forEach(o),C=l(D," and then load the vector locally:"),D.forEach(o),m=c(E),g(x.$$.fragment,E),this.h()},h(){i(w,"href","https://civitai.com/models/3036?modelVersionId=9857"),i(w,"rel","nofollow")},m(E,D){f(E,u,D),e(u,P),e(u,w),e(w,$),e(u,C),f(E,m,D),_(x,E,D),T=!0},p:fr,i(E){T||(v(x.$$.fragment,E),T=!0)},o(E){b(x.$$.fragment,E),T=!1},d(E){E&&o(u),E&&o(m),y(x,E)}}}function Mb(M){let u,P,w,$,C;return $=new O({props:{code:`import jax
import numpy as np
import jax.numpy as jnp
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers.utils import load_image
from PIL import Image
from diffusers import FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


def image_grid(imgs, rows, cols):
    w, h = imgs[0].size
    grid = Image.new("RGB", size=(cols * w, rows * h))
    for i, img in enumerate(imgs):
        grid.paste(img, box=(i % cols * w, i // cols * h))
    return grid


def create_key(seed=0):
    return jax.random.PRNGKey(seed)


rng = create_key(0)

# get canny image
canny_image = load_image(
    "https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg"
)

prompts = "best quality, extremely detailed"
negative_prompts = "monochrome, lowres, bad anatomy, worst quality, low quality"

# load control net and stable diffusion v1-5
controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
    "lllyasviel/sd-controlnet-canny", from_pt=True, dtype=jnp.float32
)
pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, revision="flax", dtype=jnp.float32
)
params["controlnet"] = controlnet_params

num_samples = jax.device_count()
rng = jax.random.split(rng, jax.device_count())

prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

p_params = replicate(params)
prompt_ids = shard(prompt_ids)
negative_prompt_ids = shard(negative_prompt_ids)
processed_image = shard(processed_image)

output = pipe(
    prompt_ids=prompt_ids,
    image=processed_image,
    params=p_params,
    prng_seed=rng,
    num_inference_steps=50,
    neg_prompt_ids=negative_prompt_ids,
    jit=True,
).images

output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-3:])))
output_images = image_grid(output_images, num_samples // 4, 4)
output_images.save("generated_image.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">image_grid</span>(<span class="hljs-params">imgs, rows, cols</span>):
<span class="hljs-meta">... </span>    w, h = imgs[<span class="hljs-number">0</span>].size
<span class="hljs-meta">... </span>    grid = Image.new(<span class="hljs-string">&quot;RGB&quot;</span>, size=(cols * w, rows * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, img <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(imgs):
<span class="hljs-meta">... </span>        grid.paste(img, box=(i % cols * w, i // cols * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> grid


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">create_key</span>(<span class="hljs-params">seed=<span class="hljs-number">0</span></span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> jax.random.PRNGKey(seed)


<span class="hljs-meta">&gt;&gt;&gt; </span>rng = create_key(<span class="hljs-number">0</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompts = <span class="hljs-string">&quot;best quality, extremely detailed&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompts = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, revision=<span class="hljs-string">&quot;flax&quot;</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>params[<span class="hljs-string">&quot;controlnet&quot;</span>] = controlnet_params

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>rng = jax.random.split(rng, jax.device_count())

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

<span class="hljs-meta">&gt;&gt;&gt; </span>p_params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = shard(negative_prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = shard(processed_image)

<span class="hljs-meta">&gt;&gt;&gt; </span>output = pipe(
<span class="hljs-meta">... </span>    prompt_ids=prompt_ids,
<span class="hljs-meta">... </span>    image=processed_image,
<span class="hljs-meta">... </span>    params=p_params,
<span class="hljs-meta">... </span>    prng_seed=rng,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    neg_prompt_ids=negative_prompt_ids,
<span class="hljs-meta">... </span>    jit=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-<span class="hljs-number">3</span>:])))
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = image_grid(output_images, num_samples // <span class="hljs-number">4</span>, <span class="hljs-number">4</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images.save(<span class="hljs-string">&quot;generated_image.png&quot;</span>)`}}),{c(){u=n("p"),P=r("Examples:"),w=p(),h($.$$.fragment)},l(m){u=a(m,"P",{});var x=s(u);P=l(x,"Examples:"),x.forEach(o),w=c(m),g($.$$.fragment,m)},m(m,x){f(m,u,x),e(u,P),f(m,w,x),_($,m,x),C=!0},p:fr,i(m){C||(v($.$$.fragment,m),C=!0)},o(m){b($.$$.fragment,m),C=!1},d(m){m&&o(u),m&&o(w),y($,m)}}}function qb(M){let u,P,w,$,C,m,x,T,E,D,I,W,Ma,Mt,xp,qa,Ep,mr,qt,Lt,kp,Pp,ur,ln,Cp,hr,pn,Dp,gr,cn,La,jp,_r,Ne,Np,Ft,Sp,Tp,vr,dn,Ap,br,Se,Fa,Ot,Ip,Mp,Oa,Gt,qp,yr,de,Te,Ga,Ut,Lp,Ua,Fp,wr,Ae,za,fe,Ra,Op,Gp,Ha,Up,zp,fn,Rp,Hp,Wa,me,Ba,zt,Wp,Bp,Va,Ka,Vp,Kp,mn,Rt,Yp,$r,ue,Ie,Ya,Ht,Jp,Ja,Xp,xr,Me,Zp,Xa,Qp,ec,Er,qe,Za,Qa,es,tc,oc,ts,un,Wt,nc,hn,ac,sc,kr,Le,ic,Bt,rc,lc,Pr,Vt,Cr,gn,_n,sh,Dr,te,pc,os,cc,dc,vn,fc,mc,jr,bn,uc,Nr,Kt,Sr,yn,hc,Tr,Yt,Ar,wn,gc,Ir,Jt,Mr,$n,_c,qr,xn,En,ih,Lr,Fe,vc,kn,bc,yc,Fr,Xt,Or,Oe,wc,Pn,$c,xc,Gr,Zt,Ur,Cn,Ec,zr,Qt,Rr,Dn,kc,Hr,jn,Nn,rh,Wr,he,ns,Pc,Cc,Sn,Dc,jc,Br,ge,Ge,as,eo,Nc,ss,Sc,Vr,Ue,Tc,is,Ac,Ic,Kr,Tn,Mc,Yr,ze,qc,rs,Lc,Fc,Jr,_e,Re,ls,to,Oc,ps,Gc,Xr,An,Uc,Zr,In,lh,Qr,Mn,zc,el,oo,tl,qn,ph,ol,ve,He,cs,no,Rc,ds,Hc,nl,Ln,Wc,al,ao,ch,sl,Fn,Bc,il,so,rl,io,dh,ll,be,We,fs,ro,Vc,ms,Kc,pl,lo,cl,po,fh,dl,ye,Be,us,co,Yc,hs,Jc,fl,oe,Xc,fo,Zc,Qc,mo,ed,td,ml,On,gs,od,ul,we,Ve,_s,uo,nd,vs,ad,hl,ne,sd,bs,id,rd,ys,ld,pd,gl,Ke,cd,ws,dd,fd,_l,$e,Ye,$s,ho,md,xs,ud,vl,H,hd,Es,gd,_d,ks,vd,bd,go,yd,wd,bl,_o,yl,xe,Je,Ps,vo,$d,Cs,xd,wl,Xe,Ds,bo,js,Ed,kd,Ns,Pd,Cd,Ss,yo,Ts,Gn,Un,mh,Dd,As,zn,Rn,uh,$l,Ee,Ze,Is,wo,jd,Ms,Nd,xl,ae,Sd,qs,Td,Ad,Ls,Id,Md,El,Qe,qd,$o,Ld,Fd,kl,ke,et,Fs,xo,Od,Os,Gd,Pl,tt,Gs,B,Us,Ud,zd,zs,Rd,Hd,Rs,Wd,Bd,Hs,Vd,Kd,A,V,ot,Eo,Yd,Jd,Xd,Ws,Zd,Qd,Bs,ef,tf,Vs,Hn,nt,hh,of,Ks,Wn,Bn,gh,nf,K,at,ko,af,sf,rf,Ys,lf,pf,Js,cf,df,Xs,Vn,Kn,_h,ff,Zs,Yn,Jn,vh,mf,Y,st,Po,uf,hf,gf,Qs,_f,vf,ei,bf,yf,ti,Xn,Zn,bh,wf,oi,Qn,ea,yh,$f,J,it,Co,xf,Ef,kf,ni,Pf,Cf,ai,Df,jf,si,ta,oa,wh,Nf,ii,na,aa,$h,Sf,X,rt,Do,Tf,Af,If,ri,Mf,qf,jo,Lf,No,Ff,Of,Gf,li,sa,ia,xh,Uf,pi,ra,la,Eh,zf,Z,lt,So,Rf,Hf,Wf,ci,Bf,Vf,To,Kf,Ao,Yf,Jf,Xf,di,pa,ca,kh,Zf,fi,da,fa,Ph,Qf,Q,pt,Io,em,tm,om,mi,nm,am,ui,sm,im,hi,ma,ua,Ch,rm,gi,ha,ga,Dh,lm,ee,Mo,qo,pm,cm,_i,dm,fm,Lo,mm,Fo,um,hm,gm,vi,_a,va,jh,_m,bi,ba,ya,Nh,Cl,Pe,ct,yi,Oo,vm,wi,bm,Dl,k,Go,ym,$i,wm,$m,Uo,xm,wa,Em,km,Pm,xi,Cm,Dm,Ei,zo,ki,jm,Nm,$a,Sm,Tm,se,Ro,Am,Pi,Im,Mm,dt,qm,ie,Ho,Lm,Ci,Fm,Om,Di,Gm,Um,ft,Wo,zm,Bo,Rm,ji,Hm,Wm,Bm,re,Vo,Vm,Ni,Km,Ym,Si,Jm,Xm,mt,Ko,Zm,Yo,Qm,Ti,eu,tu,ou,G,Jo,nu,Ai,au,su,Ii,iu,ru,Mi,lu,pu,ut,cu,ht,Xo,du,qi,fu,mu,S,Zo,uu,Ce,hu,Li,gu,_u,Fi,vu,bu,yu,gt,wu,_t,$u,Oi,xu,Eu,vt,ku,Gi,Pu,Cu,bt,Du,yt,Qo,ju,U,Nu,Ui,Su,Tu,zi,Au,Iu,Ri,Mu,qu,Hi,Lu,Fu,Ou,wt,en,Gu,De,Uu,Wi,zu,Ru,Bi,Hu,Wu,jl,je,$t,Vi,tn,Bu,Ki,Vu,Nl,z,on,Ku,Yi,Yu,Ju,nn,Xu,Ji,Zu,Qu,eh,le,an,th,Xi,oh,nh,xt,Sl;return m=new F({}),Mt=new F({}),Ut=new F({}),Ht=new F({}),Vt=new O({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),Kt=new O({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),Yt=new O({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),Jt=new O({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),Xt=new O({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),Zt=new O({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),Qt=new O({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),eo=new F({}),to=new F({}),oo=new O({props:{code:`from diffusers.utils import load_image
from PIL import Image
import cv2
import numpy as np
from diffusers.utils import load_image

canny_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png"
)
canny_image = np.array(canny_image)

low_threshold = 100
high_threshold = 200

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

# zero out middle columns of image where pose will be overlayed
zero_start = canny_image.shape[1] // 4
zero_end = zero_start + canny_image.shape[1] // 2
canny_image[:, zero_start:zero_end] = 0

canny_image = canny_image[:, :, None]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=2)
canny_image = Image.fromarray(canny_image)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

canny_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png&quot;</span>
)
canny_image = np.array(canny_image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

<span class="hljs-comment"># zero out middle columns of image where pose will be overlayed</span>
zero_start = canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">4</span>
zero_end = zero_start + canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">2</span>
canny_image[:, zero_start:zero_end] = <span class="hljs-number">0</span>

canny_image = canny_image[:, :, <span class="hljs-literal">None</span>]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(canny_image)`}}),no=new F({}),so=new O({props:{code:`from controlnet_aux import OpenposeDetector
from diffusers.utils import load_image

openpose = OpenposeDetector.from_pretrained("lllyasviel/ControlNet")

openpose_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png"
)
openpose_image = openpose(openpose_image)`,highlighted:`<span class="hljs-keyword">from</span> controlnet_aux <span class="hljs-keyword">import</span> OpenposeDetector
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

openpose = OpenposeDetector.from_pretrained(<span class="hljs-string">&quot;lllyasviel/ControlNet&quot;</span>)

openpose_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png&quot;</span>
)
openpose_image = openpose(openpose_image)`}}),ro=new F({}),lo=new O({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
import torch

controlnet = [
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-openpose", torch_dtype=torch.float16),
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = "a giant standing in a fantasy landscape, best quality"
negative_prompt = "monochrome, lowres, bad anatomy, worst quality, low quality"

generator = torch.Generator(device="cpu").manual_seed(1)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=20,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[1.0, 0.8],
).images[0]

image.save("./multi_controlnet_output.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-keyword">import</span> torch

controlnet = [
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-openpose&quot;</span>, torch_dtype=torch.float16),
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;a giant standing in a fantasy landscape, best quality&quot;</span>
negative_prompt = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">1</span>)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=<span class="hljs-number">20</span>,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[<span class="hljs-number">1.0</span>, <span class="hljs-number">0.8</span>],
).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;./multi_controlnet_output.png&quot;</span>)`}}),co=new F({}),uo=new F({}),ho=new F({}),_o=new O({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny")
pipe = StableDiffusionControlNetPipeline.from_pretrained("runwayml/stable-diffusion-v1-5", controlnet=controlnet).to(
    "cuda"
)
image = pipe("", image=canny_image, guess_mode=True, guidance_scale=3.0).images[0]
image.save("guess_mode_generated.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>)
pipe = StableDiffusionControlNetPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet).to(
    <span class="hljs-string">&quot;cuda&quot;</span>
)
image = pipe(<span class="hljs-string">&quot;&quot;</span>, image=canny_image, guess_mode=<span class="hljs-literal">True</span>, guidance_scale=<span class="hljs-number">3.0</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;guess_mode_generated.png&quot;</span>)`}}),vo=new F({}),wo=new F({}),xo=new F({}),Oo=new F({}),Go=new R({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2555/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2555/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2555/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2555/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L152"}}),Ro=new R({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"},{name:"guess_mode",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2555/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guess_mode",description:`<strong>guess_mode</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
In this mode, the ControlNet encoder will try best to recognize the content of the input image even if
you remove all prompts. The <code>guidance_scale</code> between 3.0 and 5.0 is recommended.`,name:"guess_mode"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L741",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),dt=new dr({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[jb]},$$scope:{ctx:M}}}),Ho=new R({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/pipeline_utils.py#L1460"}}),Wo=new R({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/pipeline_utils.py#L1476"}}),Vo=new R({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L235"}}),Ko=new R({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L245"}}),Jo=new R({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/pipeline_utils.py#L1402"}}),ut=new dr({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Nb]},$$scope:{ctx:M}}}),Xo=new R({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/pipeline_utils.py#L1434"}}),Zo=new R({props:{name:"load_textual_inversion",anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"token",val:": typing.Optional[str] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like
<code>&quot;sd-concepts-library/low-poly-hd-logos-icons&quot;</code>.</li>
<li>A path to a <em>directory</em> containing textual inversion weights, e.g.
<code>./my_text_inversion_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.weight_name",description:`<strong>weight_name</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of a custom weight file. This should be used in two cases:</p>
<ul>
<li>The saved textual inversion file is in <code>diffusers</code> format, but was saved under a specific weight
name, such as <code>text_inv.bin</code>.</li>
<li>The saved textual inversion file is in the &#x201C;Automatic1111&#x201D; form.</li>
</ul>`,name:"weight_name"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/loaders.py#L368"}}),gt=new xb({props:{warning:!0,$$slots:{default:[Sb]},$$scope:{ctx:M}}}),_t=new xb({props:{$$slots:{default:[Tb]},$$scope:{ctx:M}}}),vt=new dr({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.example",$$slots:{default:[Ab]},$$scope:{ctx:M}}}),bt=new dr({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.load_textual_inversion.example-2",$$slots:{default:[Ib]},$$scope:{ctx:M}}}),Qo=new R({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L273"}}),en=new R({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L252"}}),tn=new F({}),on=new R({props:{name:"class diffusers.FlaxStableDiffusionControlNetPipeline",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"controlnet",val:": FlaxControlNetModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxControlNetModel">FlaxControlNetModel</a> &#x2014;
Provides additional conditioning to the unet during the denoising process.`,name:"controlnet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2555/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L119"}}),an=new R({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, array] = 1.0"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prompt_ids",description:`<strong>prompt_ids</strong> (<code>jnp.array</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt_ids"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>jnp.array</code>) &#x2014;
Array representing the ControlNet input condition. ControlNet use this input condition to generate
guidance to Unet.`,name:"image"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.params",description:"<strong>params</strong> (<code>Dict</code> or <code>FrozenDict</code>) &#x2014; Dictionary containing the model parameters/weights",name:"params"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prng_seed",description:"<strong>prng_seed</strong> (<code>jax.random.KeyArray</code> or <code>jax.Array</code>) &#x2014; Array containing random number generator key",name:"prng_seed"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>jnp.array</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L357",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),xt=new dr({props:{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[Mb]},$$scope:{ctx:M}}}),{c(){u=n("meta"),P=p(),w=n("h1"),$=n("a"),C=n("span"),h(m.$$.fragment),x=p(),T=n("span"),E=r("Text-to-Image Generation with ControlNet Conditioning"),D=p(),I=n("h2"),W=n("a"),Ma=n("span"),h(Mt.$$.fragment),xp=p(),qa=n("span"),Ep=r("Overview"),mr=p(),qt=n("p"),Lt=n("a"),kp=r("Adding Conditional Control to Text-to-Image Diffusion Models"),Pp=r(" by Lvmin Zhang and Maneesh Agrawala."),ur=p(),ln=n("p"),Cp=r("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),hr=p(),pn=n("p"),Dp=r("The abstract of the paper is the following:"),gr=p(),cn=n("p"),La=n("em"),jp=r("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),_r=p(),Ne=n("p"),Np=r("This model was contributed by the amazing community contributor "),Ft=n("a"),Sp=r("takuma104"),Tp=r(" \u2764\uFE0F ."),vr=p(),dn=n("p"),Ap=r("Resources:"),br=p(),Se=n("ul"),Fa=n("li"),Ot=n("a"),Ip=r("Paper"),Mp=p(),Oa=n("li"),Gt=n("a"),qp=r("Original Code"),yr=p(),de=n("h2"),Te=n("a"),Ga=n("span"),h(Ut.$$.fragment),Lp=p(),Ua=n("span"),Fp=r("Available Pipelines:"),wr=p(),Ae=n("table"),za=n("thead"),fe=n("tr"),Ra=n("th"),Op=r("Pipeline"),Gp=p(),Ha=n("th"),Up=r("Tasks"),zp=p(),fn=n("th"),Rp=r("Demo"),Hp=p(),Wa=n("tbody"),me=n("tr"),Ba=n("td"),zt=n("a"),Wp=r("StableDiffusionControlNetPipeline"),Bp=p(),Va=n("td"),Ka=n("em"),Vp=r("Text-to-Image Generation with ControlNet Conditioning"),Kp=p(),mn=n("td"),Rt=n("a"),Yp=r("Colab Example"),$r=p(),ue=n("h2"),Ie=n("a"),Ya=n("span"),h(Ht.$$.fragment),Jp=p(),Ja=n("span"),Xp=r("Usage example"),xr=p(),Me=n("p"),Zp=r("In the following we give a simple example of how to use a "),Xa=n("em"),Qp=r("ControlNet"),ec=r(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Er=p(),qe=n("ul"),Za=n("li"),Qa=n("ol"),es=n("li"),tc=r("Take an image and run it through a pre-conditioning processor."),oc=p(),ts=n("li"),un=n("ol"),Wt=n("li"),nc=r("Run the pre-processed image through the "),hn=n("a"),ac=r("StableDiffusionControlNetPipeline"),sc=r("."),kr=p(),Le=n("p"),ic=r("Let\u2019s have a look at a simple example using the "),Bt=n("a"),rc=r("Canny Edge ControlNet"),lc=r("."),Pr=p(),h(Vt.$$.fragment),Cr=p(),gn=n("p"),_n=n("img"),Dr=p(),te=n("p"),pc=r("Next, we process the image to get the canny image. This is step "),os=n("em"),cc=r("1."),dc=r(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),vn=n("a"),fc=r("official checkpoints"),mc=r(" for more information about other models."),jr=p(),bn=n("p"),uc=r("First, we need to install opencv:"),Nr=p(),h(Kt.$$.fragment),Sr=p(),yn=n("p"),hc=r("Next, let\u2019s also install all required Hugging Face libraries:"),Tr=p(),h(Yt.$$.fragment),Ar=p(),wn=n("p"),gc=r("Then we can retrieve the canny edges of the image."),Ir=p(),h(Jt.$$.fragment),Mr=p(),$n=n("p"),_c=r("Let\u2019s take a look at the processed image."),qr=p(),xn=n("p"),En=n("img"),Lr=p(),Fe=n("p"),vc=r("Now, we load the official "),kn=n("a"),bc=r("Stable Diffusion 1.5 Model"),yc=r(" as well as the ControlNet for canny edges."),Fr=p(),h(Xt.$$.fragment),Or=p(),Oe=n("p"),wc=r("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),Pn=n("a"),$c=r("UniPCMultistepScheduler"),xc=r("."),Gr=p(),h(Zt.$$.fragment),Ur=p(),Cn=n("p"),Ec=r("Finally, we can run the pipeline:"),zr=p(),h(Qt.$$.fragment),Rr=p(),Dn=n("p"),kc=r("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),Hr=p(),jn=n("p"),Nn=n("img"),Wr=p(),he=n("p"),ns=n("strong"),Pc=r("Note"),Cc=r(": To see how to run all other ControlNet checkpoints, please have a look at "),Sn=n("a"),Dc=r("ControlNet with Stable Diffusion 1.5"),jc=r("."),Br=p(),ge=n("h2"),Ge=n("a"),as=n("span"),h(eo.$$.fragment),Nc=p(),ss=n("span"),Sc=r("Combining multiple conditionings"),Vr=p(),Ue=n("p"),Tc=r("Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),is=n("code"),Ac=r("__call__"),Ic=r("."),Kr=p(),Tn=n("p"),Mc=r("When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Yr=p(),ze=n("p"),qc=r("It can also be helpful to vary the "),rs=n("code"),Lc=r("controlnet_conditioning_scales"),Fc=r(" to emphasize one conditioning over the other."),Jr=p(),_e=n("h3"),Re=n("a"),ls=n("span"),h(to.$$.fragment),Oc=p(),ps=n("span"),Gc=r("Canny conditioning"),Xr=p(),An=n("p"),Uc=r("The original image:"),Zr=p(),In=n("img"),Qr=p(),Mn=n("p"),zc=r("Prepare the conditioning:"),el=p(),h(oo.$$.fragment),tl=p(),qn=n("img"),ol=p(),ve=n("h3"),He=n("a"),cs=n("span"),h(no.$$.fragment),Rc=p(),ds=n("span"),Hc=r("Openpose conditioning"),nl=p(),Ln=n("p"),Wc=r("The original image:"),al=p(),ao=n("img"),sl=p(),Fn=n("p"),Bc=r("Prepare the conditioning:"),il=p(),h(so.$$.fragment),rl=p(),io=n("img"),ll=p(),be=n("h3"),We=n("a"),fs=n("span"),h(ro.$$.fragment),Vc=p(),ms=n("span"),Kc=r("Running ControlNet with multiple conditionings"),pl=p(),h(lo.$$.fragment),cl=p(),po=n("img"),dl=p(),ye=n("h3"),Be=n("a"),us=n("span"),h(co.$$.fragment),Yc=p(),hs=n("span"),Jc=r("Guess Mode"),fl=p(),oe=n("p"),Xc=r("Guess Mode is "),fo=n("a"),Zc=r("a ControlNet feature that was implemented"),Qc=r(" after the publication of "),mo=n("a"),ed=r("the paper"),td=r(". The description states:"),ml=p(),On=n("blockquote"),gs=n("p"),od=r("In this mode, the ControlNet encoder will try best to recognize the content of the input control map, like depth map, edge map, scribbles, etc, even if you remove all prompts."),ul=p(),we=n("h4"),Ve=n("a"),_s=n("span"),h(uo.$$.fragment),nd=p(),vs=n("span"),ad=r("The core implementation:"),hl=p(),ne=n("p"),sd=r("It adjusts the scale of the output residuals from ControlNet by a fixed ratio depending on the block depth. The shallowest DownBlock corresponds to "),bs=n("code"),id=r("0.1"),rd=r(". As the blocks get deeper, the scale increases exponentially, and the scale for the output of the MidBlock becomes "),ys=n("code"),ld=r("1.0"),pd=r("."),gl=p(),Ke=n("p"),cd=r("Since the core implementation is just this, "),ws=n("strong"),dd=r("it does not have any impact on prompt conditioning"),fd=r(". While it is common to use it without specifying any prompts, it is also possible to provide prompts if desired."),_l=p(),$e=n("h4"),Ye=n("a"),$s=n("span"),h(ho.$$.fragment),md=p(),xs=n("span"),ud=r("Usage:"),vl=p(),H=n("p"),hd=r("Just specify "),Es=n("code"),gd=r("guess_mode=True"),_d=r(" in the pipe() function. A "),ks=n("code"),vd=r("guidance_scale"),bd=r(" between 3.0 and 5.0 is "),go=n("a"),yd=r("recommended"),wd=r("."),bl=p(),h(_o.$$.fragment),yl=p(),xe=n("h4"),Je=n("a"),Ps=n("span"),h(vo.$$.fragment),$d=p(),Cs=n("span"),xd=r("Output image comparison:"),wl=r(`

Canny Control Example
`),Xe=n("table"),Ds=n("thead"),bo=n("tr"),js=n("th"),Ed=r("no guess_mode with prompt"),kd=p(),Ns=n("th"),Pd=r("guess_mode without prompt"),Cd=p(),Ss=n("tbody"),yo=n("tr"),Ts=n("td"),Gn=n("a"),Un=n("img"),Dd=p(),As=n("td"),zn=n("a"),Rn=n("img"),$l=p(),Ee=n("h2"),Ze=n("a"),Is=n("span"),h(wo.$$.fragment),jd=p(),Ms=n("span"),Nd=r("Available checkpoints"),xl=p(),ae=n("p"),Sd=r("ControlNet requires a "),qs=n("em"),Td=r("control image"),Ad=r(" in addition to the text-to-image "),Ls=n("em"),Id=r("prompt"),Md=r(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),El=p(),Qe=n("p"),qd=r("All checkpoints can be found under the authors\u2019 namespace "),$o=n("a"),Ld=r("lllyasviel"),Fd=r("."),kl=p(),ke=n("h3"),et=n("a"),Fs=n("span"),h(xo.$$.fragment),Od=p(),Os=n("span"),Gd=r("ControlNet with Stable Diffusion 1.5"),Pl=p(),tt=n("table"),Gs=n("thead"),B=n("tr"),Us=n("th"),Ud=r("Model Name"),zd=p(),zs=n("th"),Rd=r("Control Image Overview"),Hd=p(),Rs=n("th"),Wd=r("Control Image Example"),Bd=p(),Hs=n("th"),Vd=r("Generated Image Example"),Kd=p(),A=n("tbody"),V=n("tr"),ot=n("td"),Eo=n("a"),Yd=r("lllyasviel/sd-controlnet-canny"),Jd=n("br"),Xd=p(),Ws=n("em"),Zd=r("Trained with canny edge detection"),Qd=p(),Bs=n("td"),ef=r("A monochrome image with white edges on a black background."),tf=p(),Vs=n("td"),Hn=n("a"),nt=n("img"),of=p(),Ks=n("td"),Wn=n("a"),Bn=n("img"),nf=p(),K=n("tr"),at=n("td"),ko=n("a"),af=r("lllyasviel/sd-controlnet-depth"),sf=n("br"),rf=p(),Ys=n("em"),lf=r("Trained with Midas depth estimation"),pf=p(),Js=n("td"),cf=r("A grayscale image with black representing deep areas and white representing shallow areas."),df=p(),Xs=n("td"),Vn=n("a"),Kn=n("img"),ff=p(),Zs=n("td"),Yn=n("a"),Jn=n("img"),mf=p(),Y=n("tr"),st=n("td"),Po=n("a"),uf=r("lllyasviel/sd-controlnet-hed"),hf=n("br"),gf=p(),Qs=n("em"),_f=r("Trained with HED edge detection (soft edge)"),vf=p(),ei=n("td"),bf=r("A monochrome image with white soft edges on a black background."),yf=p(),ti=n("td"),Xn=n("a"),Zn=n("img"),wf=p(),oi=n("td"),Qn=n("a"),ea=n("img"),$f=p(),J=n("tr"),it=n("td"),Co=n("a"),xf=r("lllyasviel/sd-controlnet-mlsd"),Ef=n("br"),kf=p(),ni=n("em"),Pf=r("Trained with M-LSD line detection"),Cf=p(),ai=n("td"),Df=r("A monochrome image composed only of white straight lines on a black background."),jf=p(),si=n("td"),ta=n("a"),oa=n("img"),Nf=p(),ii=n("td"),na=n("a"),aa=n("img"),Sf=p(),X=n("tr"),rt=n("td"),Do=n("a"),Tf=r("lllyasviel/sd-controlnet-normal"),Af=n("br"),If=p(),ri=n("em"),Mf=r("Trained with normal map"),qf=p(),jo=n("td"),Lf=r("A "),No=n("a"),Ff=r("normal mapped"),Of=r(" image."),Gf=p(),li=n("td"),sa=n("a"),ia=n("img"),Uf=p(),pi=n("td"),ra=n("a"),la=n("img"),zf=p(),Z=n("tr"),lt=n("td"),So=n("a"),Rf=r("lllyasviel/sd-controlnet-openpose"),Hf=n("br"),Wf=p(),ci=n("em"),Bf=r("Trained with OpenPose bone image"),Vf=p(),To=n("td"),Kf=r("A "),Ao=n("a"),Yf=r("OpenPose bone"),Jf=r(" image."),Xf=p(),di=n("td"),pa=n("a"),ca=n("img"),Zf=p(),fi=n("td"),da=n("a"),fa=n("img"),Qf=p(),Q=n("tr"),pt=n("td"),Io=n("a"),em=r("lllyasviel/sd-controlnet-scribble"),tm=n("br"),om=p(),mi=n("em"),nm=r("Trained with human scribbles"),am=p(),ui=n("td"),sm=r("A hand-drawn monochrome image with white outlines on a black background."),im=p(),hi=n("td"),ma=n("a"),ua=n("img"),rm=p(),gi=n("td"),ha=n("a"),ga=n("img"),lm=p(),ee=n("tr"),Mo=n("td"),qo=n("a"),pm=r("lllyasviel/sd-controlnet-seg"),cm=n("br"),_i=n("em"),dm=r("Trained with semantic segmentation"),fm=p(),Lo=n("td"),mm=r("An "),Fo=n("a"),um=r("ADE20K"),hm=r("\u2019s segmentation protocol image."),gm=p(),vi=n("td"),_a=n("a"),va=n("img"),_m=p(),bi=n("td"),ba=n("a"),ya=n("img"),Cl=p(),Pe=n("h2"),ct=n("a"),yi=n("span"),h(Oo.$$.fragment),vm=p(),wi=n("span"),bm=r("StableDiffusionControlNetPipeline"),Dl=p(),k=n("div"),h(Go.$$.fragment),ym=p(),$i=n("p"),wm=r("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),$m=p(),Uo=n("p"),xm=r("This model inherits from "),wa=n("a"),Em=r("DiffusionPipeline"),km=r(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Pm=p(),xi=n("p"),Cm=r("In addition the pipeline inherits the following loading methods:"),Dm=p(),Ei=n("ul"),zo=n("li"),ki=n("em"),jm=r("Textual-Inversion"),Nm=r(": "),$a=n("a"),Sm=r("loaders.TextualInversionLoaderMixin.load_textual_inversion()"),Tm=p(),se=n("div"),h(Ro.$$.fragment),Am=p(),Pi=n("p"),Im=r("Function invoked when calling the pipeline for generation."),Mm=p(),h(dt.$$.fragment),qm=p(),ie=n("div"),h(Ho.$$.fragment),Lm=p(),Ci=n("p"),Fm=r("Enable sliced attention computation."),Om=p(),Di=n("p"),Gm=r(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Um=p(),ft=n("div"),h(Wo.$$.fragment),zm=p(),Bo=n("p"),Rm=r("Disable sliced attention computation. If "),ji=n("code"),Hm=r("enable_attention_slicing"),Wm=r(` was previously invoked, this method will go
back to computing attention in one step.`),Bm=p(),re=n("div"),h(Vo.$$.fragment),Vm=p(),Ni=n("p"),Km=r("Enable sliced VAE decoding."),Ym=p(),Si=n("p"),Jm=r(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Xm=p(),mt=n("div"),h(Ko.$$.fragment),Zm=p(),Yo=n("p"),Qm=r("Disable sliced VAE decoding. If "),Ti=n("code"),eu=r("enable_vae_slicing"),tu=r(` was previously invoked, this method will go back to
computing decoding in one step.`),ou=p(),G=n("div"),h(Jo.$$.fragment),nu=p(),Ai=n("p"),au=r("Enable memory efficient attention as implemented in xformers."),su=p(),Ii=n("p"),iu=r(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),ru=p(),Mi=n("p"),lu=r(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),pu=p(),h(ut.$$.fragment),cu=p(),ht=n("div"),h(Xo.$$.fragment),du=p(),qi=n("p"),fu=r("Disable memory efficient attention as implemented in xformers."),mu=p(),S=n("div"),h(Zo.$$.fragment),uu=p(),Ce=n("p"),hu=r("Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),Li=n("code"),gu=r("diffusers"),_u=r(` and
`),Fi=n("code"),vu=r("Automatic1111"),bu=r(" formats are supported (see example below)."),yu=p(),h(gt.$$.fragment),wu=p(),h(_t.$$.fragment),$u=p(),Oi=n("p"),xu=r("Example:"),Eu=p(),h(vt.$$.fragment),ku=p(),Gi=n("p"),Pu=r("To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),Cu=p(),h(bt.$$.fragment),Du=p(),yt=n("div"),h(Qo.$$.fragment),ju=p(),U=n("p"),Nu=r(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ui=n("code"),Su=r("enable_sequential_cpu_offload"),Tu=r(", this method moves one whole model at a time to the GPU when its "),zi=n("code"),Au=r("forward"),Iu=r(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ri=n("code"),Mu=r("enable_sequential_cpu_offload"),qu=r(", but performance is much better due to the iterative execution of the "),Hi=n("code"),Lu=r("unet"),Fu=r("."),Ou=p(),wt=n("div"),h(en.$$.fragment),Gu=p(),De=n("p"),Uu=r(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Wi=n("code"),zu=r("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Ru=r("forward"),Bi=n("code"),Hu=r("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Wu=r("enable_model_cpu_offload`, but performance is lower."),jl=p(),je=n("h2"),$t=n("a"),Vi=n("span"),h(tn.$$.fragment),Bu=p(),Ki=n("span"),Vu=r("FlaxStableDiffusionControlNetPipeline"),Nl=p(),z=n("div"),h(on.$$.fragment),Ku=p(),Yi=n("p"),Yu=r("Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),Ju=p(),nn=n("p"),Xu=r("This model inherits from "),Ji=n("code"),Zu=r("FlaxDiffusionPipeline"),Qu=r(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),eh=p(),le=n("div"),h(an.$$.fragment),th=p(),Xi=n("p"),oh=r("Function invoked when calling the pipeline for generation."),nh=p(),h(xt.$$.fragment),this.h()},l(t){const d=Cb('[data-svelte="svelte-1phssyn"]',document.head);u=a(d,"META",{name:!0,content:!0}),d.forEach(o),P=c(t),w=a(t,"H1",{class:!0});var sn=s(w);$=a(sn,"A",{id:!0,class:!0,href:!0});var Zi=s($);C=a(Zi,"SPAN",{});var Qi=s(C);g(m.$$.fragment,Qi),Qi.forEach(o),Zi.forEach(o),x=c(sn),T=a(sn,"SPAN",{});var er=s(T);E=l(er,"Text-to-Image Generation with ControlNet Conditioning"),er.forEach(o),sn.forEach(o),D=c(t),I=a(t,"H2",{class:!0});var rn=s(I);W=a(rn,"A",{id:!0,class:!0,href:!0});var tr=s(W);Ma=a(tr,"SPAN",{});var or=s(Ma);g(Mt.$$.fragment,or),or.forEach(o),tr.forEach(o),xp=c(rn),qa=a(rn,"SPAN",{});var Sh=s(qa);Ep=l(Sh,"Overview"),Sh.forEach(o),rn.forEach(o),mr=c(t),qt=a(t,"P",{});var ah=s(qt);Lt=a(ah,"A",{href:!0,rel:!0});var Th=s(Lt);kp=l(Th,"Adding Conditional Control to Text-to-Image Diffusion Models"),Th.forEach(o),Pp=l(ah," by Lvmin Zhang and Maneesh Agrawala."),ah.forEach(o),ur=c(t),ln=a(t,"P",{});var Ah=s(ln);Cp=l(Ah,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Ah.forEach(o),hr=c(t),pn=a(t,"P",{});var Ih=s(pn);Dp=l(Ih,"The abstract of the paper is the following:"),Ih.forEach(o),gr=c(t),cn=a(t,"P",{});var Mh=s(cn);La=a(Mh,"EM",{});var qh=s(La);jp=l(qh,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),qh.forEach(o),Mh.forEach(o),_r=c(t),Ne=a(t,"P",{});var Tl=s(Ne);Np=l(Tl,"This model was contributed by the amazing community contributor "),Ft=a(Tl,"A",{href:!0,rel:!0});var Lh=s(Ft);Sp=l(Lh,"takuma104"),Lh.forEach(o),Tp=l(Tl," \u2764\uFE0F ."),Tl.forEach(o),vr=c(t),dn=a(t,"P",{});var Fh=s(dn);Ap=l(Fh,"Resources:"),Fh.forEach(o),br=c(t),Se=a(t,"UL",{});var Al=s(Se);Fa=a(Al,"LI",{});var Oh=s(Fa);Ot=a(Oh,"A",{href:!0,rel:!0});var Gh=s(Ot);Ip=l(Gh,"Paper"),Gh.forEach(o),Oh.forEach(o),Mp=c(Al),Oa=a(Al,"LI",{});var Uh=s(Oa);Gt=a(Uh,"A",{href:!0,rel:!0});var zh=s(Gt);qp=l(zh,"Original Code"),zh.forEach(o),Uh.forEach(o),Al.forEach(o),yr=c(t),de=a(t,"H2",{class:!0});var Il=s(de);Te=a(Il,"A",{id:!0,class:!0,href:!0});var Rh=s(Te);Ga=a(Rh,"SPAN",{});var Hh=s(Ga);g(Ut.$$.fragment,Hh),Hh.forEach(o),Rh.forEach(o),Lp=c(Il),Ua=a(Il,"SPAN",{});var Wh=s(Ua);Fp=l(Wh,"Available Pipelines:"),Wh.forEach(o),Il.forEach(o),wr=c(t),Ae=a(t,"TABLE",{});var Ml=s(Ae);za=a(Ml,"THEAD",{});var Bh=s(za);fe=a(Bh,"TR",{});var xa=s(fe);Ra=a(xa,"TH",{});var Vh=s(Ra);Op=l(Vh,"Pipeline"),Vh.forEach(o),Gp=c(xa),Ha=a(xa,"TH",{});var Kh=s(Ha);Up=l(Kh,"Tasks"),Kh.forEach(o),zp=c(xa),fn=a(xa,"TH",{align:!0});var Yh=s(fn);Rp=l(Yh,"Demo"),Yh.forEach(o),xa.forEach(o),Bh.forEach(o),Hp=c(Ml),Wa=a(Ml,"TBODY",{});var Jh=s(Wa);me=a(Jh,"TR",{});var Ea=s(me);Ba=a(Ea,"TD",{});var Xh=s(Ba);zt=a(Xh,"A",{href:!0,rel:!0});var Zh=s(zt);Wp=l(Zh,"StableDiffusionControlNetPipeline"),Zh.forEach(o),Xh.forEach(o),Bp=c(Ea),Va=a(Ea,"TD",{});var Qh=s(Va);Ka=a(Qh,"EM",{});var eg=s(Ka);Vp=l(eg,"Text-to-Image Generation with ControlNet Conditioning"),eg.forEach(o),Qh.forEach(o),Kp=c(Ea),mn=a(Ea,"TD",{align:!0});var tg=s(mn);Rt=a(tg,"A",{href:!0,rel:!0});var og=s(Rt);Yp=l(og,"Colab Example"),og.forEach(o),tg.forEach(o),Ea.forEach(o),Jh.forEach(o),Ml.forEach(o),$r=c(t),ue=a(t,"H2",{class:!0});var ql=s(ue);Ie=a(ql,"A",{id:!0,class:!0,href:!0});var ng=s(Ie);Ya=a(ng,"SPAN",{});var ag=s(Ya);g(Ht.$$.fragment,ag),ag.forEach(o),ng.forEach(o),Jp=c(ql),Ja=a(ql,"SPAN",{});var sg=s(Ja);Xp=l(sg,"Usage example"),sg.forEach(o),ql.forEach(o),xr=c(t),Me=a(t,"P",{});var Ll=s(Me);Zp=l(Ll,"In the following we give a simple example of how to use a "),Xa=a(Ll,"EM",{});var ig=s(Xa);Qp=l(ig,"ControlNet"),ig.forEach(o),ec=l(Ll,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Ll.forEach(o),Er=c(t),qe=a(t,"UL",{});var Fl=s(qe);Za=a(Fl,"LI",{});var rg=s(Za);Qa=a(rg,"OL",{});var lg=s(Qa);es=a(lg,"LI",{});var pg=s(es);tc=l(pg,"Take an image and run it through a pre-conditioning processor."),pg.forEach(o),lg.forEach(o),rg.forEach(o),oc=c(Fl),ts=a(Fl,"LI",{});var cg=s(ts);un=a(cg,"OL",{start:!0});var dg=s(un);Wt=a(dg,"LI",{});var Ol=s(Wt);nc=l(Ol,"Run the pre-processed image through the "),hn=a(Ol,"A",{href:!0});var fg=s(hn);ac=l(fg,"StableDiffusionControlNetPipeline"),fg.forEach(o),sc=l(Ol,"."),Ol.forEach(o),dg.forEach(o),cg.forEach(o),Fl.forEach(o),kr=c(t),Le=a(t,"P",{});var Gl=s(Le);ic=l(Gl,"Let\u2019s have a look at a simple example using the "),Bt=a(Gl,"A",{href:!0,rel:!0});var mg=s(Bt);rc=l(mg,"Canny Edge ControlNet"),mg.forEach(o),lc=l(Gl,"."),Gl.forEach(o),Pr=c(t),g(Vt.$$.fragment,t),Cr=c(t),gn=a(t,"P",{});var ug=s(gn);_n=a(ug,"IMG",{src:!0,alt:!0}),ug.forEach(o),Dr=c(t),te=a(t,"P",{});var ka=s(te);pc=l(ka,"Next, we process the image to get the canny image. This is step "),os=a(ka,"EM",{});var hg=s(os);cc=l(hg,"1."),hg.forEach(o),dc=l(ka," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),vn=a(ka,"A",{href:!0});var gg=s(vn);fc=l(gg,"official checkpoints"),gg.forEach(o),mc=l(ka," for more information about other models."),ka.forEach(o),jr=c(t),bn=a(t,"P",{});var _g=s(bn);uc=l(_g,"First, we need to install opencv:"),_g.forEach(o),Nr=c(t),g(Kt.$$.fragment,t),Sr=c(t),yn=a(t,"P",{});var vg=s(yn);hc=l(vg,"Next, let\u2019s also install all required Hugging Face libraries:"),vg.forEach(o),Tr=c(t),g(Yt.$$.fragment,t),Ar=c(t),wn=a(t,"P",{});var bg=s(wn);gc=l(bg,"Then we can retrieve the canny edges of the image."),bg.forEach(o),Ir=c(t),g(Jt.$$.fragment,t),Mr=c(t),$n=a(t,"P",{});var yg=s($n);_c=l(yg,"Let\u2019s take a look at the processed image."),yg.forEach(o),qr=c(t),xn=a(t,"P",{});var wg=s(xn);En=a(wg,"IMG",{src:!0,alt:!0}),wg.forEach(o),Lr=c(t),Fe=a(t,"P",{});var Ul=s(Fe);vc=l(Ul,"Now, we load the official "),kn=a(Ul,"A",{href:!0});var $g=s(kn);bc=l($g,"Stable Diffusion 1.5 Model"),$g.forEach(o),yc=l(Ul," as well as the ControlNet for canny edges."),Ul.forEach(o),Fr=c(t),g(Xt.$$.fragment,t),Or=c(t),Oe=a(t,"P",{});var zl=s(Oe);wc=l(zl,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),Pn=a(zl,"A",{href:!0});var xg=s(Pn);$c=l(xg,"UniPCMultistepScheduler"),xg.forEach(o),xc=l(zl,"."),zl.forEach(o),Gr=c(t),g(Zt.$$.fragment,t),Ur=c(t),Cn=a(t,"P",{});var Eg=s(Cn);Ec=l(Eg,"Finally, we can run the pipeline:"),Eg.forEach(o),zr=c(t),g(Qt.$$.fragment,t),Rr=c(t),Dn=a(t,"P",{});var kg=s(Dn);kc=l(kg,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),kg.forEach(o),Hr=c(t),jn=a(t,"P",{});var Pg=s(jn);Nn=a(Pg,"IMG",{src:!0,alt:!0}),Pg.forEach(o),Wr=c(t),he=a(t,"P",{});var nr=s(he);ns=a(nr,"STRONG",{});var Cg=s(ns);Pc=l(Cg,"Note"),Cg.forEach(o),Cc=l(nr,": To see how to run all other ControlNet checkpoints, please have a look at "),Sn=a(nr,"A",{href:!0});var Dg=s(Sn);Dc=l(Dg,"ControlNet with Stable Diffusion 1.5"),Dg.forEach(o),jc=l(nr,"."),nr.forEach(o),Br=c(t),ge=a(t,"H2",{class:!0});var Rl=s(ge);Ge=a(Rl,"A",{id:!0,class:!0,href:!0});var jg=s(Ge);as=a(jg,"SPAN",{});var Ng=s(as);g(eo.$$.fragment,Ng),Ng.forEach(o),jg.forEach(o),Nc=c(Rl),ss=a(Rl,"SPAN",{});var Sg=s(ss);Sc=l(Sg,"Combining multiple conditionings"),Sg.forEach(o),Rl.forEach(o),Vr=c(t),Ue=a(t,"P",{});var Hl=s(Ue);Tc=l(Hl,"Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),is=a(Hl,"CODE",{});var Tg=s(is);Ac=l(Tg,"__call__"),Tg.forEach(o),Ic=l(Hl,"."),Hl.forEach(o),Kr=c(t),Tn=a(t,"P",{});var Ag=s(Tn);Mc=l(Ag,"When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Ag.forEach(o),Yr=c(t),ze=a(t,"P",{});var Wl=s(ze);qc=l(Wl,"It can also be helpful to vary the "),rs=a(Wl,"CODE",{});var Ig=s(rs);Lc=l(Ig,"controlnet_conditioning_scales"),Ig.forEach(o),Fc=l(Wl," to emphasize one conditioning over the other."),Wl.forEach(o),Jr=c(t),_e=a(t,"H3",{class:!0});var Bl=s(_e);Re=a(Bl,"A",{id:!0,class:!0,href:!0});var Mg=s(Re);ls=a(Mg,"SPAN",{});var qg=s(ls);g(to.$$.fragment,qg),qg.forEach(o),Mg.forEach(o),Oc=c(Bl),ps=a(Bl,"SPAN",{});var Lg=s(ps);Gc=l(Lg,"Canny conditioning"),Lg.forEach(o),Bl.forEach(o),Xr=c(t),An=a(t,"P",{});var Fg=s(An);Uc=l(Fg,"The original image:"),Fg.forEach(o),Zr=c(t),In=a(t,"IMG",{src:!0}),Qr=c(t),Mn=a(t,"P",{});var Og=s(Mn);zc=l(Og,"Prepare the conditioning:"),Og.forEach(o),el=c(t),g(oo.$$.fragment,t),tl=c(t),qn=a(t,"IMG",{src:!0}),ol=c(t),ve=a(t,"H3",{class:!0});var Vl=s(ve);He=a(Vl,"A",{id:!0,class:!0,href:!0});var Gg=s(He);cs=a(Gg,"SPAN",{});var Ug=s(cs);g(no.$$.fragment,Ug),Ug.forEach(o),Gg.forEach(o),Rc=c(Vl),ds=a(Vl,"SPAN",{});var zg=s(ds);Hc=l(zg,"Openpose conditioning"),zg.forEach(o),Vl.forEach(o),nl=c(t),Ln=a(t,"P",{});var Rg=s(Ln);Wc=l(Rg,"The original image:"),Rg.forEach(o),al=c(t),ao=a(t,"IMG",{src:!0,width:!0}),sl=c(t),Fn=a(t,"P",{});var Hg=s(Fn);Bc=l(Hg,"Prepare the conditioning:"),Hg.forEach(o),il=c(t),g(so.$$.fragment,t),rl=c(t),io=a(t,"IMG",{src:!0,width:!0}),ll=c(t),be=a(t,"H3",{class:!0});var Kl=s(be);We=a(Kl,"A",{id:!0,class:!0,href:!0});var Wg=s(We);fs=a(Wg,"SPAN",{});var Bg=s(fs);g(ro.$$.fragment,Bg),Bg.forEach(o),Wg.forEach(o),Vc=c(Kl),ms=a(Kl,"SPAN",{});var Vg=s(ms);Kc=l(Vg,"Running ControlNet with multiple conditionings"),Vg.forEach(o),Kl.forEach(o),pl=c(t),g(lo.$$.fragment,t),cl=c(t),po=a(t,"IMG",{src:!0,width:!0}),dl=c(t),ye=a(t,"H3",{class:!0});var Yl=s(ye);Be=a(Yl,"A",{id:!0,class:!0,href:!0});var Kg=s(Be);us=a(Kg,"SPAN",{});var Yg=s(us);g(co.$$.fragment,Yg),Yg.forEach(o),Kg.forEach(o),Yc=c(Yl),hs=a(Yl,"SPAN",{});var Jg=s(hs);Jc=l(Jg,"Guess Mode"),Jg.forEach(o),Yl.forEach(o),fl=c(t),oe=a(t,"P",{});var Pa=s(oe);Xc=l(Pa,"Guess Mode is "),fo=a(Pa,"A",{href:!0,rel:!0});var Xg=s(fo);Zc=l(Xg,"a ControlNet feature that was implemented"),Xg.forEach(o),Qc=l(Pa," after the publication of "),mo=a(Pa,"A",{href:!0,rel:!0});var Zg=s(mo);ed=l(Zg,"the paper"),Zg.forEach(o),td=l(Pa,". The description states:"),Pa.forEach(o),ml=c(t),On=a(t,"BLOCKQUOTE",{});var Qg=s(On);gs=a(Qg,"P",{});var e_=s(gs);od=l(e_,"In this mode, the ControlNet encoder will try best to recognize the content of the input control map, like depth map, edge map, scribbles, etc, even if you remove all prompts."),e_.forEach(o),Qg.forEach(o),ul=c(t),we=a(t,"H4",{class:!0});var Jl=s(we);Ve=a(Jl,"A",{id:!0,class:!0,href:!0});var t_=s(Ve);_s=a(t_,"SPAN",{});var o_=s(_s);g(uo.$$.fragment,o_),o_.forEach(o),t_.forEach(o),nd=c(Jl),vs=a(Jl,"SPAN",{});var n_=s(vs);ad=l(n_,"The core implementation:"),n_.forEach(o),Jl.forEach(o),hl=c(t),ne=a(t,"P",{});var Ca=s(ne);sd=l(Ca,"It adjusts the scale of the output residuals from ControlNet by a fixed ratio depending on the block depth. The shallowest DownBlock corresponds to "),bs=a(Ca,"CODE",{});var a_=s(bs);id=l(a_,"0.1"),a_.forEach(o),rd=l(Ca,". As the blocks get deeper, the scale increases exponentially, and the scale for the output of the MidBlock becomes "),ys=a(Ca,"CODE",{});var s_=s(ys);ld=l(s_,"1.0"),s_.forEach(o),pd=l(Ca,"."),Ca.forEach(o),gl=c(t),Ke=a(t,"P",{});var Xl=s(Ke);cd=l(Xl,"Since the core implementation is just this, "),ws=a(Xl,"STRONG",{});var i_=s(ws);dd=l(i_,"it does not have any impact on prompt conditioning"),i_.forEach(o),fd=l(Xl,". While it is common to use it without specifying any prompts, it is also possible to provide prompts if desired."),Xl.forEach(o),_l=c(t),$e=a(t,"H4",{class:!0});var Zl=s($e);Ye=a(Zl,"A",{id:!0,class:!0,href:!0});var r_=s(Ye);$s=a(r_,"SPAN",{});var l_=s($s);g(ho.$$.fragment,l_),l_.forEach(o),r_.forEach(o),md=c(Zl),xs=a(Zl,"SPAN",{});var p_=s(xs);ud=l(p_,"Usage:"),p_.forEach(o),Zl.forEach(o),vl=c(t),H=a(t,"P",{});var Et=s(H);hd=l(Et,"Just specify "),Es=a(Et,"CODE",{});var c_=s(Es);gd=l(c_,"guess_mode=True"),c_.forEach(o),_d=l(Et," in the pipe() function. A "),ks=a(Et,"CODE",{});var d_=s(ks);vd=l(d_,"guidance_scale"),d_.forEach(o),bd=l(Et," between 3.0 and 5.0 is "),go=a(Et,"A",{href:!0,rel:!0});var f_=s(go);yd=l(f_,"recommended"),f_.forEach(o),wd=l(Et,"."),Et.forEach(o),bl=c(t),g(_o.$$.fragment,t),yl=c(t),xe=a(t,"H4",{class:!0});var Ql=s(xe);Je=a(Ql,"A",{id:!0,class:!0,href:!0});var m_=s(Je);Ps=a(m_,"SPAN",{});var u_=s(Ps);g(vo.$$.fragment,u_),u_.forEach(o),m_.forEach(o),$d=c(Ql),Cs=a(Ql,"SPAN",{});var h_=s(Cs);xd=l(h_,"Output image comparison:"),h_.forEach(o),Ql.forEach(o),wl=l(t,`

Canny Control Example
`),Xe=a(t,"TABLE",{});var ep=s(Xe);Ds=a(ep,"THEAD",{});var g_=s(Ds);bo=a(g_,"TR",{});var tp=s(bo);js=a(tp,"TH",{});var __=s(js);Ed=l(__,"no guess_mode with prompt"),__.forEach(o),kd=c(tp),Ns=a(tp,"TH",{});var v_=s(Ns);Pd=l(v_,"guess_mode without prompt"),v_.forEach(o),tp.forEach(o),g_.forEach(o),Cd=c(ep),Ss=a(ep,"TBODY",{});var b_=s(Ss);yo=a(b_,"TR",{});var op=s(yo);Ts=a(op,"TD",{});var y_=s(Ts);Gn=a(y_,"A",{href:!0});var w_=s(Gn);Un=a(w_,"IMG",{width:!0,src:!0}),w_.forEach(o),y_.forEach(o),Dd=c(op),As=a(op,"TD",{});var $_=s(As);zn=a($_,"A",{href:!0});var x_=s(zn);Rn=a(x_,"IMG",{width:!0,src:!0}),x_.forEach(o),$_.forEach(o),op.forEach(o),b_.forEach(o),ep.forEach(o),$l=c(t),Ee=a(t,"H2",{class:!0});var np=s(Ee);Ze=a(np,"A",{id:!0,class:!0,href:!0});var E_=s(Ze);Is=a(E_,"SPAN",{});var k_=s(Is);g(wo.$$.fragment,k_),k_.forEach(o),E_.forEach(o),jd=c(np),Ms=a(np,"SPAN",{});var P_=s(Ms);Nd=l(P_,"Available checkpoints"),P_.forEach(o),np.forEach(o),xl=c(t),ae=a(t,"P",{});var Da=s(ae);Sd=l(Da,"ControlNet requires a "),qs=a(Da,"EM",{});var C_=s(qs);Td=l(C_,"control image"),C_.forEach(o),Ad=l(Da," in addition to the text-to-image "),Ls=a(Da,"EM",{});var D_=s(Ls);Id=l(D_,"prompt"),D_.forEach(o),Md=l(Da,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Da.forEach(o),El=c(t),Qe=a(t,"P",{});var ap=s(Qe);qd=l(ap,"All checkpoints can be found under the authors\u2019 namespace "),$o=a(ap,"A",{href:!0,rel:!0});var j_=s($o);Ld=l(j_,"lllyasviel"),j_.forEach(o),Fd=l(ap,"."),ap.forEach(o),kl=c(t),ke=a(t,"H3",{class:!0});var sp=s(ke);et=a(sp,"A",{id:!0,class:!0,href:!0});var N_=s(et);Fs=a(N_,"SPAN",{});var S_=s(Fs);g(xo.$$.fragment,S_),S_.forEach(o),N_.forEach(o),Od=c(sp),Os=a(sp,"SPAN",{});var T_=s(Os);Gd=l(T_,"ControlNet with Stable Diffusion 1.5"),T_.forEach(o),sp.forEach(o),Pl=c(t),tt=a(t,"TABLE",{});var ip=s(tt);Gs=a(ip,"THEAD",{});var A_=s(Gs);B=a(A_,"TR",{});var kt=s(B);Us=a(kt,"TH",{});var I_=s(Us);Ud=l(I_,"Model Name"),I_.forEach(o),zd=c(kt),zs=a(kt,"TH",{});var M_=s(zs);Rd=l(M_,"Control Image Overview"),M_.forEach(o),Hd=c(kt),Rs=a(kt,"TH",{});var q_=s(Rs);Wd=l(q_,"Control Image Example"),q_.forEach(o),Bd=c(kt),Hs=a(kt,"TH",{});var L_=s(Hs);Vd=l(L_,"Generated Image Example"),L_.forEach(o),kt.forEach(o),A_.forEach(o),Kd=c(ip),A=a(ip,"TBODY",{});var q=s(A);V=a(q,"TR",{});var Pt=s(V);ot=a(Pt,"TD",{});var ar=s(ot);Eo=a(ar,"A",{href:!0,rel:!0});var F_=s(Eo);Yd=l(F_,"lllyasviel/sd-controlnet-canny"),F_.forEach(o),Jd=a(ar,"BR",{}),Xd=c(ar),Ws=a(ar,"EM",{});var O_=s(Ws);Zd=l(O_,"Trained with canny edge detection"),O_.forEach(o),ar.forEach(o),Qd=c(Pt),Bs=a(Pt,"TD",{});var G_=s(Bs);ef=l(G_,"A monochrome image with white edges on a black background."),G_.forEach(o),tf=c(Pt),Vs=a(Pt,"TD",{});var U_=s(Vs);Hn=a(U_,"A",{href:!0});var z_=s(Hn);nt=a(z_,"IMG",{width:!0,style:!0,src:!0}),z_.forEach(o),U_.forEach(o),of=c(Pt),Ks=a(Pt,"TD",{});var R_=s(Ks);Wn=a(R_,"A",{href:!0});var H_=s(Wn);Bn=a(H_,"IMG",{width:!0,src:!0}),H_.forEach(o),R_.forEach(o),Pt.forEach(o),nf=c(q),K=a(q,"TR",{});var Ct=s(K);at=a(Ct,"TD",{});var sr=s(at);ko=a(sr,"A",{href:!0,rel:!0});var W_=s(ko);af=l(W_,"lllyasviel/sd-controlnet-depth"),W_.forEach(o),sf=a(sr,"BR",{}),rf=c(sr),Ys=a(sr,"EM",{});var B_=s(Ys);lf=l(B_,"Trained with Midas depth estimation"),B_.forEach(o),sr.forEach(o),pf=c(Ct),Js=a(Ct,"TD",{});var V_=s(Js);cf=l(V_,"A grayscale image with black representing deep areas and white representing shallow areas."),V_.forEach(o),df=c(Ct),Xs=a(Ct,"TD",{});var K_=s(Xs);Vn=a(K_,"A",{href:!0});var Y_=s(Vn);Kn=a(Y_,"IMG",{width:!0,src:!0}),Y_.forEach(o),K_.forEach(o),ff=c(Ct),Zs=a(Ct,"TD",{});var J_=s(Zs);Yn=a(J_,"A",{href:!0});var X_=s(Yn);Jn=a(X_,"IMG",{width:!0,src:!0}),X_.forEach(o),J_.forEach(o),Ct.forEach(o),mf=c(q),Y=a(q,"TR",{});var Dt=s(Y);st=a(Dt,"TD",{});var ir=s(st);Po=a(ir,"A",{href:!0,rel:!0});var Z_=s(Po);uf=l(Z_,"lllyasviel/sd-controlnet-hed"),Z_.forEach(o),hf=a(ir,"BR",{}),gf=c(ir),Qs=a(ir,"EM",{});var Q_=s(Qs);_f=l(Q_,"Trained with HED edge detection (soft edge)"),Q_.forEach(o),ir.forEach(o),vf=c(Dt),ei=a(Dt,"TD",{});var ev=s(ei);bf=l(ev,"A monochrome image with white soft edges on a black background."),ev.forEach(o),yf=c(Dt),ti=a(Dt,"TD",{});var tv=s(ti);Xn=a(tv,"A",{href:!0});var ov=s(Xn);Zn=a(ov,"IMG",{width:!0,src:!0}),ov.forEach(o),tv.forEach(o),wf=c(Dt),oi=a(Dt,"TD",{});var nv=s(oi);Qn=a(nv,"A",{href:!0});var av=s(Qn);ea=a(av,"IMG",{width:!0,src:!0}),av.forEach(o),nv.forEach(o),Dt.forEach(o),$f=c(q),J=a(q,"TR",{});var jt=s(J);it=a(jt,"TD",{});var rr=s(it);Co=a(rr,"A",{href:!0,rel:!0});var sv=s(Co);xf=l(sv,"lllyasviel/sd-controlnet-mlsd"),sv.forEach(o),Ef=a(rr,"BR",{}),kf=c(rr),ni=a(rr,"EM",{});var iv=s(ni);Pf=l(iv,"Trained with M-LSD line detection"),iv.forEach(o),rr.forEach(o),Cf=c(jt),ai=a(jt,"TD",{});var rv=s(ai);Df=l(rv,"A monochrome image composed only of white straight lines on a black background."),rv.forEach(o),jf=c(jt),si=a(jt,"TD",{});var lv=s(si);ta=a(lv,"A",{href:!0});var pv=s(ta);oa=a(pv,"IMG",{width:!0,src:!0}),pv.forEach(o),lv.forEach(o),Nf=c(jt),ii=a(jt,"TD",{});var cv=s(ii);na=a(cv,"A",{href:!0});var dv=s(na);aa=a(dv,"IMG",{width:!0,src:!0}),dv.forEach(o),cv.forEach(o),jt.forEach(o),Sf=c(q),X=a(q,"TR",{});var Nt=s(X);rt=a(Nt,"TD",{});var lr=s(rt);Do=a(lr,"A",{href:!0,rel:!0});var fv=s(Do);Tf=l(fv,"lllyasviel/sd-controlnet-normal"),fv.forEach(o),Af=a(lr,"BR",{}),If=c(lr),ri=a(lr,"EM",{});var mv=s(ri);Mf=l(mv,"Trained with normal map"),mv.forEach(o),lr.forEach(o),qf=c(Nt),jo=a(Nt,"TD",{});var rp=s(jo);Lf=l(rp,"A "),No=a(rp,"A",{href:!0,rel:!0});var uv=s(No);Ff=l(uv,"normal mapped"),uv.forEach(o),Of=l(rp," image."),rp.forEach(o),Gf=c(Nt),li=a(Nt,"TD",{});var hv=s(li);sa=a(hv,"A",{href:!0});var gv=s(sa);ia=a(gv,"IMG",{width:!0,src:!0}),gv.forEach(o),hv.forEach(o),Uf=c(Nt),pi=a(Nt,"TD",{});var _v=s(pi);ra=a(_v,"A",{href:!0});var vv=s(ra);la=a(vv,"IMG",{width:!0,src:!0}),vv.forEach(o),_v.forEach(o),Nt.forEach(o),zf=c(q),Z=a(q,"TR",{});var St=s(Z);lt=a(St,"TD",{});var pr=s(lt);So=a(pr,"A",{href:!0,rel:!0});var bv=s(So);Rf=l(bv,"lllyasviel/sd-controlnet-openpose"),bv.forEach(o),Hf=a(pr,"BR",{}),Wf=c(pr),ci=a(pr,"EM",{});var yv=s(ci);Bf=l(yv,"Trained with OpenPose bone image"),yv.forEach(o),pr.forEach(o),Vf=c(St),To=a(St,"TD",{});var lp=s(To);Kf=l(lp,"A "),Ao=a(lp,"A",{href:!0,rel:!0});var wv=s(Ao);Yf=l(wv,"OpenPose bone"),wv.forEach(o),Jf=l(lp," image."),lp.forEach(o),Xf=c(St),di=a(St,"TD",{});var $v=s(di);pa=a($v,"A",{href:!0});var xv=s(pa);ca=a(xv,"IMG",{width:!0,src:!0}),xv.forEach(o),$v.forEach(o),Zf=c(St),fi=a(St,"TD",{});var Ev=s(fi);da=a(Ev,"A",{href:!0});var kv=s(da);fa=a(kv,"IMG",{width:!0,src:!0}),kv.forEach(o),Ev.forEach(o),St.forEach(o),Qf=c(q),Q=a(q,"TR",{});var Tt=s(Q);pt=a(Tt,"TD",{});var cr=s(pt);Io=a(cr,"A",{href:!0,rel:!0});var Pv=s(Io);em=l(Pv,"lllyasviel/sd-controlnet-scribble"),Pv.forEach(o),tm=a(cr,"BR",{}),om=c(cr),mi=a(cr,"EM",{});var Cv=s(mi);nm=l(Cv,"Trained with human scribbles"),Cv.forEach(o),cr.forEach(o),am=c(Tt),ui=a(Tt,"TD",{});var Dv=s(ui);sm=l(Dv,"A hand-drawn monochrome image with white outlines on a black background."),Dv.forEach(o),im=c(Tt),hi=a(Tt,"TD",{});var jv=s(hi);ma=a(jv,"A",{href:!0});var Nv=s(ma);ua=a(Nv,"IMG",{width:!0,src:!0}),Nv.forEach(o),jv.forEach(o),rm=c(Tt),gi=a(Tt,"TD",{});var Sv=s(gi);ha=a(Sv,"A",{href:!0});var Tv=s(ha);ga=a(Tv,"IMG",{width:!0,src:!0}),Tv.forEach(o),Sv.forEach(o),Tt.forEach(o),lm=c(q),ee=a(q,"TR",{});var At=s(ee);Mo=a(At,"TD",{});var pp=s(Mo);qo=a(pp,"A",{href:!0,rel:!0});var Av=s(qo);pm=l(Av,"lllyasviel/sd-controlnet-seg"),Av.forEach(o),cm=a(pp,"BR",{}),_i=a(pp,"EM",{});var Iv=s(_i);dm=l(Iv,"Trained with semantic segmentation"),Iv.forEach(o),pp.forEach(o),fm=c(At),Lo=a(At,"TD",{});var cp=s(Lo);mm=l(cp,"An "),Fo=a(cp,"A",{href:!0,rel:!0});var Mv=s(Fo);um=l(Mv,"ADE20K"),Mv.forEach(o),hm=l(cp,"\u2019s segmentation protocol image."),cp.forEach(o),gm=c(At),vi=a(At,"TD",{});var qv=s(vi);_a=a(qv,"A",{href:!0});var Lv=s(_a);va=a(Lv,"IMG",{width:!0,src:!0}),Lv.forEach(o),qv.forEach(o),_m=c(At),bi=a(At,"TD",{});var Fv=s(bi);ba=a(Fv,"A",{href:!0});var Ov=s(ba);ya=a(Ov,"IMG",{width:!0,src:!0}),Ov.forEach(o),Fv.forEach(o),At.forEach(o),q.forEach(o),ip.forEach(o),Cl=c(t),Pe=a(t,"H2",{class:!0});var dp=s(Pe);ct=a(dp,"A",{id:!0,class:!0,href:!0});var Gv=s(ct);yi=a(Gv,"SPAN",{});var Uv=s(yi);g(Oo.$$.fragment,Uv),Uv.forEach(o),Gv.forEach(o),vm=c(dp),wi=a(dp,"SPAN",{});var zv=s(wi);bm=l(zv,"StableDiffusionControlNetPipeline"),zv.forEach(o),dp.forEach(o),Dl=c(t),k=a(t,"DIV",{class:!0});var j=s(k);g(Go.$$.fragment,j),ym=c(j),$i=a(j,"P",{});var Rv=s($i);wm=l(Rv,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Rv.forEach(o),$m=c(j),Uo=a(j,"P",{});var fp=s(Uo);xm=l(fp,"This model inherits from "),wa=a(fp,"A",{href:!0});var Hv=s(wa);Em=l(Hv,"DiffusionPipeline"),Hv.forEach(o),km=l(fp,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),fp.forEach(o),Pm=c(j),xi=a(j,"P",{});var Wv=s(xi);Cm=l(Wv,"In addition the pipeline inherits the following loading methods:"),Wv.forEach(o),Dm=c(j),Ei=a(j,"UL",{});var Bv=s(Ei);zo=a(Bv,"LI",{});var mp=s(zo);ki=a(mp,"EM",{});var Vv=s(ki);jm=l(Vv,"Textual-Inversion"),Vv.forEach(o),Nm=l(mp,": "),$a=a(mp,"A",{href:!0});var Kv=s($a);Sm=l(Kv,"loaders.TextualInversionLoaderMixin.load_textual_inversion()"),Kv.forEach(o),mp.forEach(o),Bv.forEach(o),Tm=c(j),se=a(j,"DIV",{class:!0});var ja=s(se);g(Ro.$$.fragment,ja),Am=c(ja),Pi=a(ja,"P",{});var Yv=s(Pi);Im=l(Yv,"Function invoked when calling the pipeline for generation."),Yv.forEach(o),Mm=c(ja),g(dt.$$.fragment,ja),ja.forEach(o),qm=c(j),ie=a(j,"DIV",{class:!0});var Na=s(ie);g(Ho.$$.fragment,Na),Lm=c(Na),Ci=a(Na,"P",{});var Jv=s(Ci);Fm=l(Jv,"Enable sliced attention computation."),Jv.forEach(o),Om=c(Na),Di=a(Na,"P",{});var Xv=s(Di);Gm=l(Xv,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Xv.forEach(o),Na.forEach(o),Um=c(j),ft=a(j,"DIV",{class:!0});var up=s(ft);g(Wo.$$.fragment,up),zm=c(up),Bo=a(up,"P",{});var hp=s(Bo);Rm=l(hp,"Disable sliced attention computation. If "),ji=a(hp,"CODE",{});var Zv=s(ji);Hm=l(Zv,"enable_attention_slicing"),Zv.forEach(o),Wm=l(hp,` was previously invoked, this method will go
back to computing attention in one step.`),hp.forEach(o),up.forEach(o),Bm=c(j),re=a(j,"DIV",{class:!0});var Sa=s(re);g(Vo.$$.fragment,Sa),Vm=c(Sa),Ni=a(Sa,"P",{});var Qv=s(Ni);Km=l(Qv,"Enable sliced VAE decoding."),Qv.forEach(o),Ym=c(Sa),Si=a(Sa,"P",{});var eb=s(Si);Jm=l(eb,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),eb.forEach(o),Sa.forEach(o),Xm=c(j),mt=a(j,"DIV",{class:!0});var gp=s(mt);g(Ko.$$.fragment,gp),Zm=c(gp),Yo=a(gp,"P",{});var _p=s(Yo);Qm=l(_p,"Disable sliced VAE decoding. If "),Ti=a(_p,"CODE",{});var tb=s(Ti);eu=l(tb,"enable_vae_slicing"),tb.forEach(o),tu=l(_p,` was previously invoked, this method will go back to
computing decoding in one step.`),_p.forEach(o),gp.forEach(o),ou=c(j),G=a(j,"DIV",{class:!0});var pe=s(G);g(Jo.$$.fragment,pe),nu=c(pe),Ai=a(pe,"P",{});var ob=s(Ai);au=l(ob,"Enable memory efficient attention as implemented in xformers."),ob.forEach(o),su=c(pe),Ii=a(pe,"P",{});var nb=s(Ii);iu=l(nb,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),nb.forEach(o),ru=c(pe),Mi=a(pe,"P",{});var ab=s(Mi);lu=l(ab,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),ab.forEach(o),pu=c(pe),g(ut.$$.fragment,pe),pe.forEach(o),cu=c(j),ht=a(j,"DIV",{class:!0});var vp=s(ht);g(Xo.$$.fragment,vp),du=c(vp),qi=a(vp,"P",{});var sb=s(qi);fu=l(sb,"Disable memory efficient attention as implemented in xformers."),sb.forEach(o),vp.forEach(o),mu=c(j),S=a(j,"DIV",{class:!0});var L=s(S);g(Zo.$$.fragment,L),uu=c(L),Ce=a(L,"P",{});var Ta=s(Ce);hu=l(Ta,"Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),Li=a(Ta,"CODE",{});var ib=s(Li);gu=l(ib,"diffusers"),ib.forEach(o),_u=l(Ta,` and
`),Fi=a(Ta,"CODE",{});var rb=s(Fi);vu=l(rb,"Automatic1111"),rb.forEach(o),bu=l(Ta," formats are supported (see example below)."),Ta.forEach(o),yu=c(L),g(gt.$$.fragment,L),wu=c(L),g(_t.$$.fragment,L),$u=c(L),Oi=a(L,"P",{});var lb=s(Oi);xu=l(lb,"Example:"),lb.forEach(o),Eu=c(L),g(vt.$$.fragment,L),ku=c(L),Gi=a(L,"P",{});var pb=s(Gi);Pu=l(pb,"To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),pb.forEach(o),Cu=c(L),g(bt.$$.fragment,L),L.forEach(o),Du=c(j),yt=a(j,"DIV",{class:!0});var bp=s(yt);g(Qo.$$.fragment,bp),ju=c(bp),U=a(bp,"P",{});var ce=s(U);Nu=l(ce,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Ui=a(ce,"CODE",{});var cb=s(Ui);Su=l(cb,"enable_sequential_cpu_offload"),cb.forEach(o),Tu=l(ce,", this method moves one whole model at a time to the GPU when its "),zi=a(ce,"CODE",{});var db=s(zi);Au=l(db,"forward"),db.forEach(o),Iu=l(ce,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ri=a(ce,"CODE",{});var fb=s(Ri);Mu=l(fb,"enable_sequential_cpu_offload"),fb.forEach(o),qu=l(ce,", but performance is much better due to the iterative execution of the "),Hi=a(ce,"CODE",{});var mb=s(Hi);Lu=l(mb,"unet"),mb.forEach(o),Fu=l(ce,"."),ce.forEach(o),bp.forEach(o),Ou=c(j),wt=a(j,"DIV",{class:!0});var yp=s(wt);g(en.$$.fragment,yp),Gu=c(yp),De=a(yp,"P",{});var Aa=s(De);Uu=l(Aa,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Wi=a(Aa,"CODE",{});var ub=s(Wi);zu=l(ub,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),ub.forEach(o),Ru=l(Aa,"forward"),Bi=a(Aa,"CODE",{});var hb=s(Bi);Hu=l(hb,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),hb.forEach(o),Wu=l(Aa,"enable_model_cpu_offload`, but performance is lower."),Aa.forEach(o),yp.forEach(o),j.forEach(o),jl=c(t),je=a(t,"H2",{class:!0});var wp=s(je);$t=a(wp,"A",{id:!0,class:!0,href:!0});var gb=s($t);Vi=a(gb,"SPAN",{});var _b=s(Vi);g(tn.$$.fragment,_b),_b.forEach(o),gb.forEach(o),Bu=c(wp),Ki=a(wp,"SPAN",{});var vb=s(Ki);Vu=l(vb,"FlaxStableDiffusionControlNetPipeline"),vb.forEach(o),wp.forEach(o),Nl=c(t),z=a(t,"DIV",{class:!0});var It=s(z);g(on.$$.fragment,It),Ku=c(It),Yi=a(It,"P",{});var bb=s(Yi);Yu=l(bb,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),bb.forEach(o),Ju=c(It),nn=a(It,"P",{});var $p=s(nn);Xu=l($p,"This model inherits from "),Ji=a($p,"CODE",{});var yb=s(Ji);Zu=l(yb,"FlaxDiffusionPipeline"),yb.forEach(o),Qu=l($p,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),$p.forEach(o),eh=c(It),le=a(It,"DIV",{class:!0});var Ia=s(le);g(an.$$.fragment,Ia),th=c(Ia),Xi=a(Ia,"P",{});var wb=s(Xi);oh=l(wb,"Function invoked when calling the pipeline for generation."),wb.forEach(o),nh=c(Ia),g(xt.$$.fragment,Ia),Ia.forEach(o),It.forEach(o),this.h()},h(){i(u,"name","hf:doc:metadata"),i(u,"content",JSON.stringify(Lb)),i($,"id","texttoimage-generation-with-controlnet-conditioning"),i($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i($,"href","#texttoimage-generation-with-controlnet-conditioning"),i(w,"class","relative group"),i(W,"id","overview"),i(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(W,"href","#overview"),i(I,"class","relative group"),i(Lt,"href","https://arxiv.org/abs/2302.05543"),i(Lt,"rel","nofollow"),i(Ft,"href","https://huggingface.co/takuma104"),i(Ft,"rel","nofollow"),i(Ot,"href","https://arxiv.org/abs/2302.05543"),i(Ot,"rel","nofollow"),i(Gt,"href","https://github.com/lllyasviel/ControlNet"),i(Gt,"rel","nofollow"),i(Te,"id","available-pipelines"),i(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Te,"href","#available-pipelines"),i(de,"class","relative group"),i(fn,"align","center"),i(zt,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),i(zt,"rel","nofollow"),i(Rt,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),i(Rt,"rel","nofollow"),i(mn,"align","center"),i(Ie,"id","usage-example"),i(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ie,"href","#usage-example"),i(ue,"class","relative group"),i(hn,"href","/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),i(un,"start","2"),i(Bt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(Bt,"rel","nofollow"),N(_n.src,sh="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||i(_n,"src",sh),i(_n,"alt","img"),i(vn,"href","#controlnet-with-stable-diffusion-1.5"),N(En.src,ih="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||i(En,"src",ih),i(En,"alt","img"),i(kn,"href","runwayml/stable-diffusion-v1-5"),i(Pn,"href","/docs/diffusers/pr_2555/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),N(Nn.src,rh="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||i(Nn,"src",rh),i(Nn,"alt","img"),i(Sn,"href","#controlnet-with-stable-diffusion-1.5"),i(Ge,"id","combining-multiple-conditionings"),i(Ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ge,"href","#combining-multiple-conditionings"),i(ge,"class","relative group"),i(Re,"id","canny-conditioning"),i(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Re,"href","#canny-conditioning"),i(_e,"class","relative group"),N(In.src,lh="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png")||i(In,"src",lh),N(qn.src,ph="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/landscape_canny_masked.png")||i(qn,"src",ph),i(He,"id","openpose-conditioning"),i(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(He,"href","#openpose-conditioning"),i(ve,"class","relative group"),N(ao.src,ch="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png")||i(ao,"src",ch),i(ao,"width","600"),N(io.src,dh="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/person_pose.png")||i(io,"src",dh),i(io,"width","600"),i(We,"id","running-controlnet-with-multiple-conditionings"),i(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(We,"href","#running-controlnet-with-multiple-conditionings"),i(be,"class","relative group"),N(po.src,fh="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/multi_controlnet_output.png")||i(po,"src",fh),i(po,"width","600"),i(Be,"id","guess-mode"),i(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Be,"href","#guess-mode"),i(ye,"class","relative group"),i(fo,"href","https://github.com/lllyasviel/ControlNet#guess-mode--non-prompt-mode"),i(fo,"rel","nofollow"),i(mo,"href","https://arxiv.org/abs/2302.05543"),i(mo,"rel","nofollow"),i(Ve,"id","the-core-implementation"),i(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ve,"href","#the-core-implementation"),i(we,"class","relative group"),i(Ye,"id","usage"),i(Ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ye,"href","#usage"),i($e,"class","relative group"),i(go,"href","https://github.com/lllyasviel/ControlNet#guess-mode--non-prompt-mode"),i(go,"rel","nofollow"),i(Je,"id","output-image-comparison"),i(Je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Je,"href","#output-image-comparison"),i(xe,"class","relative group"),i(Un,"width","128"),N(Un.src,mh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0.png")||i(Un,"src",mh),i(Gn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0.png"),i(Rn,"width","128"),N(Rn.src,uh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0_gm.png")||i(Rn,"src",uh),i(zn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare_guess_mode/output_images/diffusers/output_bird_canny_0_gm.png"),i(Ze,"id","available-checkpoints"),i(Ze,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ze,"href","#available-checkpoints"),i(Ee,"class","relative group"),i($o,"href","https://huggingface.co/lllyasviel"),i($o,"rel","nofollow"),i(et,"id","controlnet-with-stable-diffusion-15"),i(et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(et,"href","#controlnet-with-stable-diffusion-15"),i(ke,"class","relative group"),i(Eo,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(Eo,"rel","nofollow"),i(nt,"width","64"),$b(nt,"margin","0"),$b(nt,"padding","0"),N(nt.src,hh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||i(nt,"src",hh),i(Hn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),i(Bn,"width","64"),N(Bn.src,gh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||i(Bn,"src",gh),i(Wn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),i(ko,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),i(ko,"rel","nofollow"),i(Kn,"width","64"),N(Kn.src,_h="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||i(Kn,"src",_h),i(Vn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),i(Jn,"width","64"),N(Jn.src,vh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||i(Jn,"src",vh),i(Yn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),i(Po,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),i(Po,"rel","nofollow"),i(Zn,"width","64"),N(Zn.src,bh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||i(Zn,"src",bh),i(Xn,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),i(ea,"width","64"),N(ea.src,yh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||i(ea,"src",yh),i(Qn,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),i(Co,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),i(Co,"rel","nofollow"),i(oa,"width","64"),N(oa.src,wh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||i(oa,"src",wh),i(ta,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),i(aa,"width","64"),N(aa.src,$h="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||i(aa,"src",$h),i(na,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),i(Do,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),i(Do,"rel","nofollow"),i(No,"href","https://en.wikipedia.org/wiki/Normal_mapping"),i(No,"rel","nofollow"),i(ia,"width","64"),N(ia.src,xh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||i(ia,"src",xh),i(sa,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),i(la,"width","64"),N(la.src,Eh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||i(la,"src",Eh),i(ra,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),i(So,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),i(So,"rel","nofollow"),i(Ao,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),i(Ao,"rel","nofollow"),i(ca,"width","64"),N(ca.src,kh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||i(ca,"src",kh),i(pa,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),i(fa,"width","64"),N(fa.src,Ph="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||i(fa,"src",Ph),i(da,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),i(Io,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),i(Io,"rel","nofollow"),i(ua,"width","64"),N(ua.src,Ch="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||i(ua,"src",Ch),i(ma,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),i(ga,"width","64"),N(ga.src,Dh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||i(ga,"src",Dh),i(ha,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),i(qo,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),i(qo,"rel","nofollow"),i(Fo,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),i(Fo,"rel","nofollow"),i(va,"width","64"),N(va.src,jh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||i(va,"src",jh),i(_a,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),i(ya,"width","64"),N(ya.src,Nh="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||i(ya,"src",Nh),i(ba,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),i(ct,"id","diffusers.StableDiffusionControlNetPipeline"),i(ct,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ct,"href","#diffusers.StableDiffusionControlNetPipeline"),i(Pe,"class","relative group"),i(wa,"href","/docs/diffusers/pr_2555/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),i($a,"href","/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.load_textual_inversion"),i(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($t,"id","diffusers.FlaxStableDiffusionControlNetPipeline"),i($t,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i($t,"href","#diffusers.FlaxStableDiffusionControlNetPipeline"),i(je,"class","relative group"),i(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,u),f(t,P,d),f(t,w,d),e(w,$),e($,C),_(m,C,null),e(w,x),e(w,T),e(T,E),f(t,D,d),f(t,I,d),e(I,W),e(W,Ma),_(Mt,Ma,null),e(I,xp),e(I,qa),e(qa,Ep),f(t,mr,d),f(t,qt,d),e(qt,Lt),e(Lt,kp),e(qt,Pp),f(t,ur,d),f(t,ln,d),e(ln,Cp),f(t,hr,d),f(t,pn,d),e(pn,Dp),f(t,gr,d),f(t,cn,d),e(cn,La),e(La,jp),f(t,_r,d),f(t,Ne,d),e(Ne,Np),e(Ne,Ft),e(Ft,Sp),e(Ne,Tp),f(t,vr,d),f(t,dn,d),e(dn,Ap),f(t,br,d),f(t,Se,d),e(Se,Fa),e(Fa,Ot),e(Ot,Ip),e(Se,Mp),e(Se,Oa),e(Oa,Gt),e(Gt,qp),f(t,yr,d),f(t,de,d),e(de,Te),e(Te,Ga),_(Ut,Ga,null),e(de,Lp),e(de,Ua),e(Ua,Fp),f(t,wr,d),f(t,Ae,d),e(Ae,za),e(za,fe),e(fe,Ra),e(Ra,Op),e(fe,Gp),e(fe,Ha),e(Ha,Up),e(fe,zp),e(fe,fn),e(fn,Rp),e(Ae,Hp),e(Ae,Wa),e(Wa,me),e(me,Ba),e(Ba,zt),e(zt,Wp),e(me,Bp),e(me,Va),e(Va,Ka),e(Ka,Vp),e(me,Kp),e(me,mn),e(mn,Rt),e(Rt,Yp),f(t,$r,d),f(t,ue,d),e(ue,Ie),e(Ie,Ya),_(Ht,Ya,null),e(ue,Jp),e(ue,Ja),e(Ja,Xp),f(t,xr,d),f(t,Me,d),e(Me,Zp),e(Me,Xa),e(Xa,Qp),e(Me,ec),f(t,Er,d),f(t,qe,d),e(qe,Za),e(Za,Qa),e(Qa,es),e(es,tc),e(qe,oc),e(qe,ts),e(ts,un),e(un,Wt),e(Wt,nc),e(Wt,hn),e(hn,ac),e(Wt,sc),f(t,kr,d),f(t,Le,d),e(Le,ic),e(Le,Bt),e(Bt,rc),e(Le,lc),f(t,Pr,d),_(Vt,t,d),f(t,Cr,d),f(t,gn,d),e(gn,_n),f(t,Dr,d),f(t,te,d),e(te,pc),e(te,os),e(os,cc),e(te,dc),e(te,vn),e(vn,fc),e(te,mc),f(t,jr,d),f(t,bn,d),e(bn,uc),f(t,Nr,d),_(Kt,t,d),f(t,Sr,d),f(t,yn,d),e(yn,hc),f(t,Tr,d),_(Yt,t,d),f(t,Ar,d),f(t,wn,d),e(wn,gc),f(t,Ir,d),_(Jt,t,d),f(t,Mr,d),f(t,$n,d),e($n,_c),f(t,qr,d),f(t,xn,d),e(xn,En),f(t,Lr,d),f(t,Fe,d),e(Fe,vc),e(Fe,kn),e(kn,bc),e(Fe,yc),f(t,Fr,d),_(Xt,t,d),f(t,Or,d),f(t,Oe,d),e(Oe,wc),e(Oe,Pn),e(Pn,$c),e(Oe,xc),f(t,Gr,d),_(Zt,t,d),f(t,Ur,d),f(t,Cn,d),e(Cn,Ec),f(t,zr,d),_(Qt,t,d),f(t,Rr,d),f(t,Dn,d),e(Dn,kc),f(t,Hr,d),f(t,jn,d),e(jn,Nn),f(t,Wr,d),f(t,he,d),e(he,ns),e(ns,Pc),e(he,Cc),e(he,Sn),e(Sn,Dc),e(he,jc),f(t,Br,d),f(t,ge,d),e(ge,Ge),e(Ge,as),_(eo,as,null),e(ge,Nc),e(ge,ss),e(ss,Sc),f(t,Vr,d),f(t,Ue,d),e(Ue,Tc),e(Ue,is),e(is,Ac),e(Ue,Ic),f(t,Kr,d),f(t,Tn,d),e(Tn,Mc),f(t,Yr,d),f(t,ze,d),e(ze,qc),e(ze,rs),e(rs,Lc),e(ze,Fc),f(t,Jr,d),f(t,_e,d),e(_e,Re),e(Re,ls),_(to,ls,null),e(_e,Oc),e(_e,ps),e(ps,Gc),f(t,Xr,d),f(t,An,d),e(An,Uc),f(t,Zr,d),f(t,In,d),f(t,Qr,d),f(t,Mn,d),e(Mn,zc),f(t,el,d),_(oo,t,d),f(t,tl,d),f(t,qn,d),f(t,ol,d),f(t,ve,d),e(ve,He),e(He,cs),_(no,cs,null),e(ve,Rc),e(ve,ds),e(ds,Hc),f(t,nl,d),f(t,Ln,d),e(Ln,Wc),f(t,al,d),f(t,ao,d),f(t,sl,d),f(t,Fn,d),e(Fn,Bc),f(t,il,d),_(so,t,d),f(t,rl,d),f(t,io,d),f(t,ll,d),f(t,be,d),e(be,We),e(We,fs),_(ro,fs,null),e(be,Vc),e(be,ms),e(ms,Kc),f(t,pl,d),_(lo,t,d),f(t,cl,d),f(t,po,d),f(t,dl,d),f(t,ye,d),e(ye,Be),e(Be,us),_(co,us,null),e(ye,Yc),e(ye,hs),e(hs,Jc),f(t,fl,d),f(t,oe,d),e(oe,Xc),e(oe,fo),e(fo,Zc),e(oe,Qc),e(oe,mo),e(mo,ed),e(oe,td),f(t,ml,d),f(t,On,d),e(On,gs),e(gs,od),f(t,ul,d),f(t,we,d),e(we,Ve),e(Ve,_s),_(uo,_s,null),e(we,nd),e(we,vs),e(vs,ad),f(t,hl,d),f(t,ne,d),e(ne,sd),e(ne,bs),e(bs,id),e(ne,rd),e(ne,ys),e(ys,ld),e(ne,pd),f(t,gl,d),f(t,Ke,d),e(Ke,cd),e(Ke,ws),e(ws,dd),e(Ke,fd),f(t,_l,d),f(t,$e,d),e($e,Ye),e(Ye,$s),_(ho,$s,null),e($e,md),e($e,xs),e(xs,ud),f(t,vl,d),f(t,H,d),e(H,hd),e(H,Es),e(Es,gd),e(H,_d),e(H,ks),e(ks,vd),e(H,bd),e(H,go),e(go,yd),e(H,wd),f(t,bl,d),_(_o,t,d),f(t,yl,d),f(t,xe,d),e(xe,Je),e(Je,Ps),_(vo,Ps,null),e(xe,$d),e(xe,Cs),e(Cs,xd),f(t,wl,d),f(t,Xe,d),e(Xe,Ds),e(Ds,bo),e(bo,js),e(js,Ed),e(bo,kd),e(bo,Ns),e(Ns,Pd),e(Xe,Cd),e(Xe,Ss),e(Ss,yo),e(yo,Ts),e(Ts,Gn),e(Gn,Un),e(yo,Dd),e(yo,As),e(As,zn),e(zn,Rn),f(t,$l,d),f(t,Ee,d),e(Ee,Ze),e(Ze,Is),_(wo,Is,null),e(Ee,jd),e(Ee,Ms),e(Ms,Nd),f(t,xl,d),f(t,ae,d),e(ae,Sd),e(ae,qs),e(qs,Td),e(ae,Ad),e(ae,Ls),e(Ls,Id),e(ae,Md),f(t,El,d),f(t,Qe,d),e(Qe,qd),e(Qe,$o),e($o,Ld),e(Qe,Fd),f(t,kl,d),f(t,ke,d),e(ke,et),e(et,Fs),_(xo,Fs,null),e(ke,Od),e(ke,Os),e(Os,Gd),f(t,Pl,d),f(t,tt,d),e(tt,Gs),e(Gs,B),e(B,Us),e(Us,Ud),e(B,zd),e(B,zs),e(zs,Rd),e(B,Hd),e(B,Rs),e(Rs,Wd),e(B,Bd),e(B,Hs),e(Hs,Vd),e(tt,Kd),e(tt,A),e(A,V),e(V,ot),e(ot,Eo),e(Eo,Yd),e(ot,Jd),e(ot,Xd),e(ot,Ws),e(Ws,Zd),e(V,Qd),e(V,Bs),e(Bs,ef),e(V,tf),e(V,Vs),e(Vs,Hn),e(Hn,nt),e(V,of),e(V,Ks),e(Ks,Wn),e(Wn,Bn),e(A,nf),e(A,K),e(K,at),e(at,ko),e(ko,af),e(at,sf),e(at,rf),e(at,Ys),e(Ys,lf),e(K,pf),e(K,Js),e(Js,cf),e(K,df),e(K,Xs),e(Xs,Vn),e(Vn,Kn),e(K,ff),e(K,Zs),e(Zs,Yn),e(Yn,Jn),e(A,mf),e(A,Y),e(Y,st),e(st,Po),e(Po,uf),e(st,hf),e(st,gf),e(st,Qs),e(Qs,_f),e(Y,vf),e(Y,ei),e(ei,bf),e(Y,yf),e(Y,ti),e(ti,Xn),e(Xn,Zn),e(Y,wf),e(Y,oi),e(oi,Qn),e(Qn,ea),e(A,$f),e(A,J),e(J,it),e(it,Co),e(Co,xf),e(it,Ef),e(it,kf),e(it,ni),e(ni,Pf),e(J,Cf),e(J,ai),e(ai,Df),e(J,jf),e(J,si),e(si,ta),e(ta,oa),e(J,Nf),e(J,ii),e(ii,na),e(na,aa),e(A,Sf),e(A,X),e(X,rt),e(rt,Do),e(Do,Tf),e(rt,Af),e(rt,If),e(rt,ri),e(ri,Mf),e(X,qf),e(X,jo),e(jo,Lf),e(jo,No),e(No,Ff),e(jo,Of),e(X,Gf),e(X,li),e(li,sa),e(sa,ia),e(X,Uf),e(X,pi),e(pi,ra),e(ra,la),e(A,zf),e(A,Z),e(Z,lt),e(lt,So),e(So,Rf),e(lt,Hf),e(lt,Wf),e(lt,ci),e(ci,Bf),e(Z,Vf),e(Z,To),e(To,Kf),e(To,Ao),e(Ao,Yf),e(To,Jf),e(Z,Xf),e(Z,di),e(di,pa),e(pa,ca),e(Z,Zf),e(Z,fi),e(fi,da),e(da,fa),e(A,Qf),e(A,Q),e(Q,pt),e(pt,Io),e(Io,em),e(pt,tm),e(pt,om),e(pt,mi),e(mi,nm),e(Q,am),e(Q,ui),e(ui,sm),e(Q,im),e(Q,hi),e(hi,ma),e(ma,ua),e(Q,rm),e(Q,gi),e(gi,ha),e(ha,ga),e(A,lm),e(A,ee),e(ee,Mo),e(Mo,qo),e(qo,pm),e(Mo,cm),e(Mo,_i),e(_i,dm),e(ee,fm),e(ee,Lo),e(Lo,mm),e(Lo,Fo),e(Fo,um),e(Lo,hm),e(ee,gm),e(ee,vi),e(vi,_a),e(_a,va),e(ee,_m),e(ee,bi),e(bi,ba),e(ba,ya),f(t,Cl,d),f(t,Pe,d),e(Pe,ct),e(ct,yi),_(Oo,yi,null),e(Pe,vm),e(Pe,wi),e(wi,bm),f(t,Dl,d),f(t,k,d),_(Go,k,null),e(k,ym),e(k,$i),e($i,wm),e(k,$m),e(k,Uo),e(Uo,xm),e(Uo,wa),e(wa,Em),e(Uo,km),e(k,Pm),e(k,xi),e(xi,Cm),e(k,Dm),e(k,Ei),e(Ei,zo),e(zo,ki),e(ki,jm),e(zo,Nm),e(zo,$a),e($a,Sm),e(k,Tm),e(k,se),_(Ro,se,null),e(se,Am),e(se,Pi),e(Pi,Im),e(se,Mm),_(dt,se,null),e(k,qm),e(k,ie),_(Ho,ie,null),e(ie,Lm),e(ie,Ci),e(Ci,Fm),e(ie,Om),e(ie,Di),e(Di,Gm),e(k,Um),e(k,ft),_(Wo,ft,null),e(ft,zm),e(ft,Bo),e(Bo,Rm),e(Bo,ji),e(ji,Hm),e(Bo,Wm),e(k,Bm),e(k,re),_(Vo,re,null),e(re,Vm),e(re,Ni),e(Ni,Km),e(re,Ym),e(re,Si),e(Si,Jm),e(k,Xm),e(k,mt),_(Ko,mt,null),e(mt,Zm),e(mt,Yo),e(Yo,Qm),e(Yo,Ti),e(Ti,eu),e(Yo,tu),e(k,ou),e(k,G),_(Jo,G,null),e(G,nu),e(G,Ai),e(Ai,au),e(G,su),e(G,Ii),e(Ii,iu),e(G,ru),e(G,Mi),e(Mi,lu),e(G,pu),_(ut,G,null),e(k,cu),e(k,ht),_(Xo,ht,null),e(ht,du),e(ht,qi),e(qi,fu),e(k,mu),e(k,S),_(Zo,S,null),e(S,uu),e(S,Ce),e(Ce,hu),e(Ce,Li),e(Li,gu),e(Ce,_u),e(Ce,Fi),e(Fi,vu),e(Ce,bu),e(S,yu),_(gt,S,null),e(S,wu),_(_t,S,null),e(S,$u),e(S,Oi),e(Oi,xu),e(S,Eu),_(vt,S,null),e(S,ku),e(S,Gi),e(Gi,Pu),e(S,Cu),_(bt,S,null),e(k,Du),e(k,yt),_(Qo,yt,null),e(yt,ju),e(yt,U),e(U,Nu),e(U,Ui),e(Ui,Su),e(U,Tu),e(U,zi),e(zi,Au),e(U,Iu),e(U,Ri),e(Ri,Mu),e(U,qu),e(U,Hi),e(Hi,Lu),e(U,Fu),e(k,Ou),e(k,wt),_(en,wt,null),e(wt,Gu),e(wt,De),e(De,Uu),e(De,Wi),e(Wi,zu),e(De,Ru),e(De,Bi),e(Bi,Hu),e(De,Wu),f(t,jl,d),f(t,je,d),e(je,$t),e($t,Vi),_(tn,Vi,null),e(je,Bu),e(je,Ki),e(Ki,Vu),f(t,Nl,d),f(t,z,d),_(on,z,null),e(z,Ku),e(z,Yi),e(Yi,Yu),e(z,Ju),e(z,nn),e(nn,Xu),e(nn,Ji),e(Ji,Zu),e(nn,Qu),e(z,eh),e(z,le),_(an,le,null),e(le,th),e(le,Xi),e(Xi,oh),e(le,nh),_(xt,le,null),Sl=!0},p(t,[d]){const sn={};d&2&&(sn.$$scope={dirty:d,ctx:t}),dt.$set(sn);const Zi={};d&2&&(Zi.$$scope={dirty:d,ctx:t}),ut.$set(Zi);const Qi={};d&2&&(Qi.$$scope={dirty:d,ctx:t}),gt.$set(Qi);const er={};d&2&&(er.$$scope={dirty:d,ctx:t}),_t.$set(er);const rn={};d&2&&(rn.$$scope={dirty:d,ctx:t}),vt.$set(rn);const tr={};d&2&&(tr.$$scope={dirty:d,ctx:t}),bt.$set(tr);const or={};d&2&&(or.$$scope={dirty:d,ctx:t}),xt.$set(or)},i(t){Sl||(v(m.$$.fragment,t),v(Mt.$$.fragment,t),v(Ut.$$.fragment,t),v(Ht.$$.fragment,t),v(Vt.$$.fragment,t),v(Kt.$$.fragment,t),v(Yt.$$.fragment,t),v(Jt.$$.fragment,t),v(Xt.$$.fragment,t),v(Zt.$$.fragment,t),v(Qt.$$.fragment,t),v(eo.$$.fragment,t),v(to.$$.fragment,t),v(oo.$$.fragment,t),v(no.$$.fragment,t),v(so.$$.fragment,t),v(ro.$$.fragment,t),v(lo.$$.fragment,t),v(co.$$.fragment,t),v(uo.$$.fragment,t),v(ho.$$.fragment,t),v(_o.$$.fragment,t),v(vo.$$.fragment,t),v(wo.$$.fragment,t),v(xo.$$.fragment,t),v(Oo.$$.fragment,t),v(Go.$$.fragment,t),v(Ro.$$.fragment,t),v(dt.$$.fragment,t),v(Ho.$$.fragment,t),v(Wo.$$.fragment,t),v(Vo.$$.fragment,t),v(Ko.$$.fragment,t),v(Jo.$$.fragment,t),v(ut.$$.fragment,t),v(Xo.$$.fragment,t),v(Zo.$$.fragment,t),v(gt.$$.fragment,t),v(_t.$$.fragment,t),v(vt.$$.fragment,t),v(bt.$$.fragment,t),v(Qo.$$.fragment,t),v(en.$$.fragment,t),v(tn.$$.fragment,t),v(on.$$.fragment,t),v(an.$$.fragment,t),v(xt.$$.fragment,t),Sl=!0)},o(t){b(m.$$.fragment,t),b(Mt.$$.fragment,t),b(Ut.$$.fragment,t),b(Ht.$$.fragment,t),b(Vt.$$.fragment,t),b(Kt.$$.fragment,t),b(Yt.$$.fragment,t),b(Jt.$$.fragment,t),b(Xt.$$.fragment,t),b(Zt.$$.fragment,t),b(Qt.$$.fragment,t),b(eo.$$.fragment,t),b(to.$$.fragment,t),b(oo.$$.fragment,t),b(no.$$.fragment,t),b(so.$$.fragment,t),b(ro.$$.fragment,t),b(lo.$$.fragment,t),b(co.$$.fragment,t),b(uo.$$.fragment,t),b(ho.$$.fragment,t),b(_o.$$.fragment,t),b(vo.$$.fragment,t),b(wo.$$.fragment,t),b(xo.$$.fragment,t),b(Oo.$$.fragment,t),b(Go.$$.fragment,t),b(Ro.$$.fragment,t),b(dt.$$.fragment,t),b(Ho.$$.fragment,t),b(Wo.$$.fragment,t),b(Vo.$$.fragment,t),b(Ko.$$.fragment,t),b(Jo.$$.fragment,t),b(ut.$$.fragment,t),b(Xo.$$.fragment,t),b(Zo.$$.fragment,t),b(gt.$$.fragment,t),b(_t.$$.fragment,t),b(vt.$$.fragment,t),b(bt.$$.fragment,t),b(Qo.$$.fragment,t),b(en.$$.fragment,t),b(tn.$$.fragment,t),b(on.$$.fragment,t),b(an.$$.fragment,t),b(xt.$$.fragment,t),Sl=!1},d(t){o(u),t&&o(P),t&&o(w),y(m),t&&o(D),t&&o(I),y(Mt),t&&o(mr),t&&o(qt),t&&o(ur),t&&o(ln),t&&o(hr),t&&o(pn),t&&o(gr),t&&o(cn),t&&o(_r),t&&o(Ne),t&&o(vr),t&&o(dn),t&&o(br),t&&o(Se),t&&o(yr),t&&o(de),y(Ut),t&&o(wr),t&&o(Ae),t&&o($r),t&&o(ue),y(Ht),t&&o(xr),t&&o(Me),t&&o(Er),t&&o(qe),t&&o(kr),t&&o(Le),t&&o(Pr),y(Vt,t),t&&o(Cr),t&&o(gn),t&&o(Dr),t&&o(te),t&&o(jr),t&&o(bn),t&&o(Nr),y(Kt,t),t&&o(Sr),t&&o(yn),t&&o(Tr),y(Yt,t),t&&o(Ar),t&&o(wn),t&&o(Ir),y(Jt,t),t&&o(Mr),t&&o($n),t&&o(qr),t&&o(xn),t&&o(Lr),t&&o(Fe),t&&o(Fr),y(Xt,t),t&&o(Or),t&&o(Oe),t&&o(Gr),y(Zt,t),t&&o(Ur),t&&o(Cn),t&&o(zr),y(Qt,t),t&&o(Rr),t&&o(Dn),t&&o(Hr),t&&o(jn),t&&o(Wr),t&&o(he),t&&o(Br),t&&o(ge),y(eo),t&&o(Vr),t&&o(Ue),t&&o(Kr),t&&o(Tn),t&&o(Yr),t&&o(ze),t&&o(Jr),t&&o(_e),y(to),t&&o(Xr),t&&o(An),t&&o(Zr),t&&o(In),t&&o(Qr),t&&o(Mn),t&&o(el),y(oo,t),t&&o(tl),t&&o(qn),t&&o(ol),t&&o(ve),y(no),t&&o(nl),t&&o(Ln),t&&o(al),t&&o(ao),t&&o(sl),t&&o(Fn),t&&o(il),y(so,t),t&&o(rl),t&&o(io),t&&o(ll),t&&o(be),y(ro),t&&o(pl),y(lo,t),t&&o(cl),t&&o(po),t&&o(dl),t&&o(ye),y(co),t&&o(fl),t&&o(oe),t&&o(ml),t&&o(On),t&&o(ul),t&&o(we),y(uo),t&&o(hl),t&&o(ne),t&&o(gl),t&&o(Ke),t&&o(_l),t&&o($e),y(ho),t&&o(vl),t&&o(H),t&&o(bl),y(_o,t),t&&o(yl),t&&o(xe),y(vo),t&&o(wl),t&&o(Xe),t&&o($l),t&&o(Ee),y(wo),t&&o(xl),t&&o(ae),t&&o(El),t&&o(Qe),t&&o(kl),t&&o(ke),y(xo),t&&o(Pl),t&&o(tt),t&&o(Cl),t&&o(Pe),y(Oo),t&&o(Dl),t&&o(k),y(Go),y(Ro),y(dt),y(Ho),y(Wo),y(Vo),y(Ko),y(Jo),y(ut),y(Xo),y(Zo),y(gt),y(_t),y(vt),y(bt),y(Qo),y(en),t&&o(jl),t&&o(je),y(tn),t&&o(Nl),t&&o(z),y(on),y(an),y(xt)}}}const Lb={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"combining-multiple-conditionings",sections:[{local:"canny-conditioning",title:"Canny conditioning"},{local:"openpose-conditioning",title:"Openpose conditioning"},{local:"running-controlnet-with-multiple-conditionings",title:"Running ControlNet with multiple conditionings"},{local:"guess-mode",sections:[{local:"the-core-implementation",title:"The core implementation:"},{local:"usage",title:"Usage:"},{local:"output-image-comparison",title:"Output image comparison:"}],title:"Guess Mode"}],title:"Combining multiple conditionings"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"},{local:"diffusers.FlaxStableDiffusionControlNetPipeline",title:"FlaxStableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function Fb(M){return Db(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wb extends Eb{constructor(u){super();kb(this,u,Fb,qb,Pb,{})}}export{Wb as default,Lb as metadata};
