import{S as zo,i as Wo,s as Yo,e as r,k as m,w,t as o,M as Vo,c as i,d as t,m as d,a as l,x as v,h as n,b as u,G as a,g as h,y,q as b,o as k,B as x,v as Jo,L as Na}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ho}from"../../chunks/Tip-hf-doc-builder.js";import{I as je}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ie}from"../../chunks/CodeBlock-hf-doc-builder.js";import{F as Bo,M as Ma}from"../../chunks/Markdown-hf-doc-builder.js";function Ko(D){let p,g;return{c(){p=r("p"),g=o("The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset.")},l(s){p=i(s,"P",{});var $=l(p);g=n($,"The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset."),$.forEach(t)},m(s,$){h(s,p,$),a(p,g)},d(s){s&&t(p)}}}function Xo(D){let p,g,s,$,P,N,ee,ae,se,M,F,T,U,q,S,K,z,X,C,R,le,A,W,ue,Y,L,pe,I,oe,Q,he,H,V,G;return M=new ie({props:{code:`\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch --mixed_precision="fp16"  train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`\`\`\`bash
<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>  train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),T=new ie({props:{code:`
To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} [Datasets](https://huggingface.co/docs/datasets/index). You can [upload your dataset to the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub), or you can [prepare a local folder with your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in \`TRAIN_DIR\` and where to save the model to in \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export TRAIN_DIR="path_to_your_dataset"
export OUTPUT_DIR="path_to_save_model"

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir=\${OUTPUT_DIR}`,highlighted:`
<span class="hljs-keyword">To</span> finetune <span class="hljs-keyword">on</span> your own dataset, <span class="hljs-keyword">prepare</span> the dataset according <span class="hljs-keyword">to</span> the <span class="hljs-keyword">format</span> required <span class="hljs-keyword">by</span> \u{1F917} [Datasets](https://huggingface.co/docs/datasets/<span class="hljs-keyword">index</span>). You can [upload your dataset <span class="hljs-keyword">to</span> the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-<span class="hljs-keyword">to</span>-the-hub), <span class="hljs-keyword">or</span> you can [<span class="hljs-keyword">prepare</span> a <span class="hljs-keyword">local</span> folder <span class="hljs-keyword">with</span> your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script <span class="hljs-keyword">if</span> you want <span class="hljs-keyword">to</span> use custom loading logic. We left pointers <span class="hljs-keyword">in</span> the code <span class="hljs-keyword">in</span> the appropriate places <span class="hljs-keyword">to</span> help you. \u{1F917} The example script below shows how <span class="hljs-keyword">to</span> finetune <span class="hljs-keyword">on</span> a <span class="hljs-keyword">local</span> dataset <span class="hljs-keyword">in</span> \`TRAIN_DIR\` <span class="hljs-keyword">and</span> <span class="hljs-keyword">where</span> <span class="hljs-keyword">to</span> save the model <span class="hljs-keyword">to</span> <span class="hljs-keyword">in</span> \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME=&quot;CompVis/stable-diffusion-v1-4&quot;
export TRAIN_DIR=&quot;path_to_your_dataset&quot;
export OUTPUT_DIR=&quot;path_to_save_model&quot;

accelerate launch train_text_to_image.py \\
  <span class="hljs-comment">--pretrained_model_name_or_path=$MODEL_NAME \\</span>
  <span class="hljs-comment">--train_data_dir=$TRAIN_DIR \\</span>
  <span class="hljs-comment">--use_ema \\</span>
  <span class="hljs-comment">--resolution=512 --center_crop --random_flip \\</span>
  <span class="hljs-comment">--train_batch_size=1 \\</span>
  <span class="hljs-comment">--gradient_accumulation_steps=4 \\</span>
  <span class="hljs-comment">--gradient_checkpointing \\</span>
  <span class="hljs-comment">--mixed_precision=&quot;fp16&quot; \\</span>
  <span class="hljs-comment">--max_train_steps=15000 \\</span>
  <span class="hljs-comment">--learning_rate=1e-05 \\</span>
  <span class="hljs-comment">--max_grad_norm=1 \\</span>
  <span class="hljs-comment">--lr_scheduler=&quot;constant&quot; --lr_warmup_steps=0 \\</span>
  <span class="hljs-comment">--output_dir=\${OUTPUT_DIR}</span>`}}),z=new je({}),V=new ie({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch --mixed_precision="fp16" --multi_gpu  train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\ 
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> --multi_gpu  train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\ 
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),{c(){p=r("p"),g=o("Launch the "),s=r("a"),$=o("PyTorch training script"),P=o(" for a fine-tuning run on the "),N=r("a"),ee=o("Pok\xE9mon BLIP captions"),ae=o(" dataset like this:"),se=m(),w(M.$$.fragment),F=m(),w(T.$$.fragment),U=m(),q=r("h4"),S=r("a"),K=r("span"),w(z.$$.fragment),X=m(),C=r("span"),R=o("Training with multiple GPUs"),le=m(),A=r("p"),W=r("code"),ue=o("accelerate"),Y=o(" allows for seamless multi-GPU training. Follow the instructions "),L=r("a"),pe=o("here"),I=o(`
for running distributed training with `),oe=r("code"),Q=o("accelerate"),he=o(". Here is an example command:"),H=m(),w(V.$$.fragment),this.h()},l(_){p=i(_,"P",{});var E=l(p);g=n(E,"Launch the "),s=i(E,"A",{href:!0,rel:!0});var ce=l(s);$=n(ce,"PyTorch training script"),ce.forEach(t),P=n(E," for a fine-tuning run on the "),N=i(E,"A",{href:!0,rel:!0});var Z=l(N);ee=n(Z,"Pok\xE9mon BLIP captions"),Z.forEach(t),ae=n(E," dataset like this:"),E.forEach(t),se=d(_),v(M.$$.fragment,_),F=d(_),v(T.$$.fragment,_),U=d(_),q=i(_,"H4",{class:!0});var O=l(q);S=i(O,"A",{id:!0,class:!0,href:!0});var c=l(S);K=i(c,"SPAN",{});var j=l(K);v(z.$$.fragment,j),j.forEach(t),c.forEach(t),X=d(O),C=i(O,"SPAN",{});var ne=l(C);R=n(ne,"Training with multiple GPUs"),ne.forEach(t),O.forEach(t),le=d(_),A=i(_,"P",{});var te=l(A);W=i(te,"CODE",{});var re=l(W);ue=n(re,"accelerate"),re.forEach(t),Y=n(te," allows for seamless multi-GPU training. Follow the instructions "),L=i(te,"A",{href:!0,rel:!0});var we=l(L);pe=n(we,"here"),we.forEach(t),I=n(te,`
for running distributed training with `),oe=i(te,"CODE",{});var J=l(oe);Q=n(J,"accelerate"),J.forEach(t),he=n(te,". Here is an example command:"),te.forEach(t),H=d(_),v(V.$$.fragment,_),this.h()},h(){u(s,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image.py"),u(s,"rel","nofollow"),u(N,"href","https://huggingface.co/datasets/lambdalabs/pokemon-blip-captions"),u(N,"rel","nofollow"),u(S,"id","training-with-multiple-gpus"),u(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(S,"href","#training-with-multiple-gpus"),u(q,"class","relative group"),u(L,"href","https://huggingface.co/docs/accelerate/basic_tutorials/launch"),u(L,"rel","nofollow")},m(_,E){h(_,p,E),a(p,g),a(p,s),a(s,$),a(p,P),a(p,N),a(N,ee),a(p,ae),h(_,se,E),y(M,_,E),h(_,F,E),y(T,_,E),h(_,U,E),h(_,q,E),a(q,S),a(S,K),y(z,K,null),a(q,X),a(q,C),a(C,R),h(_,le,E),h(_,A,E),a(A,W),a(W,ue),a(A,Y),a(A,L),a(L,pe),a(A,I),a(A,oe),a(oe,Q),a(A,he),h(_,H,E),y(V,_,E),G=!0},p:Na,i(_){G||(b(M.$$.fragment,_),b(T.$$.fragment,_),b(z.$$.fragment,_),b(V.$$.fragment,_),G=!0)},o(_){k(M.$$.fragment,_),k(T.$$.fragment,_),k(z.$$.fragment,_),k(V.$$.fragment,_),G=!1},d(_){_&&t(p),_&&t(se),x(M,_),_&&t(F),x(T,_),_&&t(U),_&&t(q),x(z),_&&t(le),_&&t(A),_&&t(H),x(V,_)}}}function Qo(D){let p,g;return p=new Ma({props:{$$slots:{default:[Xo]},$$scope:{ctx:D}}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p(s,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:s}),p.$set(P)},i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function Zo(D){let p,g,s,$,P,N,ee,ae,se,M,F,T,U,q,S,K,z,X,C,R,le,A,W,ue,Y,L,pe,I,oe,Q,he,H,V,G,_,E,ce,Z,O;return M=new ie({props:{code:"pip install -U -r requirements_flax.txt",highlighted:"pip install -U -r requirements_flax.txt"}}),X=new ie({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export dataset_name="lambdalabs/pokemon-blip-captions"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),Z=new ie({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export TRAIN_DIR="path_to_your_dataset"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> TRAIN_DIR=<span class="hljs-string">&quot;path_to_your_dataset&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --train_data_dir=<span class="hljs-variable">$TRAIN_DIR</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span>`}}),{c(){p=r("p"),g=o("With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),s=r("a"),$=o("@duongna211"),P=o(". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),N=m(),ee=r("p"),ae=o("Before running the script, make sure you have the requirements installed:"),se=m(),w(M.$$.fragment),F=m(),T=r("p"),U=o("Now you can launch the "),q=r("a"),S=o("Flax training script"),K=o(" like this:"),z=m(),w(X.$$.fragment),C=m(),R=r("p"),le=o("To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),A=r("a"),W=o("Datasets"),ue=o(". You can "),Y=r("a"),L=o("upload your dataset to the Hub"),pe=o(", or you can "),I=r("a"),oe=o("prepare a local folder with your files"),Q=o("."),he=m(),H=r("p"),V=o("Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),G=r("code"),_=o("TRAIN_DIR"),E=o(":"),ce=m(),w(Z.$$.fragment),this.h()},l(c){p=i(c,"P",{});var j=l(p);g=n(j,"With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),s=i(j,"A",{href:!0,rel:!0});var ne=l(s);$=n(ne,"@duongna211"),ne.forEach(t),P=n(j,". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),j.forEach(t),N=d(c),ee=i(c,"P",{});var te=l(ee);ae=n(te,"Before running the script, make sure you have the requirements installed:"),te.forEach(t),se=d(c),v(M.$$.fragment,c),F=d(c),T=i(c,"P",{});var re=l(T);U=n(re,"Now you can launch the "),q=i(re,"A",{href:!0,rel:!0});var we=l(q);S=n(we,"Flax training script"),we.forEach(t),K=n(re," like this:"),re.forEach(t),z=d(c),v(X.$$.fragment,c),C=d(c),R=i(c,"P",{});var J=l(R);le=n(J,"To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),A=i(J,"A",{href:!0,rel:!0});var B=l(A);W=n(B,"Datasets"),B.forEach(t),ue=n(J,". You can "),Y=i(J,"A",{href:!0,rel:!0});var st=l(Y);L=n(st,"upload your dataset to the Hub"),st.forEach(t),pe=n(J,", or you can "),I=i(J,"A",{href:!0,rel:!0});var Pe=l(I);oe=n(Pe,"prepare a local folder with your files"),Pe.forEach(t),Q=n(J,"."),J.forEach(t),he=d(c),H=i(c,"P",{});var Ae=l(H);V=n(Ae,"Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),G=i(Ae,"CODE",{});var ot=l(G);_=n(ot,"TRAIN_DIR"),ot.forEach(t),E=n(Ae,":"),Ae.forEach(t),ce=d(c),v(Z.$$.fragment,c),this.h()},h(){u(s,"href","https://github.com/duongna21"),u(s,"rel","nofollow"),u(q,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image_flax.py"),u(q,"rel","nofollow"),u(A,"href","https://huggingface.co/docs/datasets/index"),u(A,"rel","nofollow"),u(Y,"href","https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub"),u(Y,"rel","nofollow"),u(I,"href","https://huggingface.co/docs/datasets/image_dataset#imagefolder"),u(I,"rel","nofollow")},m(c,j){h(c,p,j),a(p,g),a(p,s),a(s,$),a(p,P),h(c,N,j),h(c,ee,j),a(ee,ae),h(c,se,j),y(M,c,j),h(c,F,j),h(c,T,j),a(T,U),a(T,q),a(q,S),a(T,K),h(c,z,j),y(X,c,j),h(c,C,j),h(c,R,j),a(R,le),a(R,A),a(A,W),a(R,ue),a(R,Y),a(Y,L),a(R,pe),a(R,I),a(I,oe),a(R,Q),h(c,he,j),h(c,H,j),a(H,V),a(H,G),a(G,_),a(H,E),h(c,ce,j),y(Z,c,j),O=!0},p:Na,i(c){O||(b(M.$$.fragment,c),b(X.$$.fragment,c),b(Z.$$.fragment,c),O=!0)},o(c){k(M.$$.fragment,c),k(X.$$.fragment,c),k(Z.$$.fragment,c),O=!1},d(c){c&&t(p),c&&t(N),c&&t(ee),c&&t(se),x(M,c),c&&t(F),c&&t(T),c&&t(z),x(X,c),c&&t(C),c&&t(R),c&&t(he),c&&t(H),c&&t(ce),x(Z,c)}}}function en(D){let p,g;return p=new Ma({props:{$$slots:{default:[Zo]},$$scope:{ctx:D}}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p(s,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:s}),p.$set(P)},i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function tn(D){let p,g;return{c(){p=r("p"),g=o("Training with Min-SNR weighting strategy is only supported in PyTorch.")},l(s){p=i(s,"P",{});var $=l(p);g=n($,"Training with Min-SNR weighting strategy is only supported in PyTorch."),$.forEach(t)},m(s,$){h(s,p,$),a(p,g)},d(s){s&&t(p)}}}function an(D){let p,g;return p=new ie({props:{code:`from diffusers import StableDiffusionPipeline

model_path = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to("cuda")

image = pipe(prompt="yoda").images[0]
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

image = pipe(prompt=<span class="hljs-string">&quot;yoda&quot;</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p:Na,i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function sn(D){let p,g;return p=new Ma({props:{$$slots:{default:[an]},$$scope:{ctx:D}}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p(s,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:s}),p.$set(P)},i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function on(D){let p,g;return p=new ie({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers import FlaxStableDiffusionPipeline

model_path = "path_to_saved_model"
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = "yoda pokemon"
prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

# shard inputs and rng
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=True).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">import</span> jax
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = <span class="hljs-string">&quot;yoda pokemon&quot;</span>
prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
num_inference_steps = <span class="hljs-number">50</span>

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

<span class="hljs-comment"># shard inputs and rng</span>
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p:Na,i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function nn(D){let p,g;return p=new Ma({props:{$$slots:{default:[on]},$$scope:{ctx:D}}}),{c(){w(p.$$.fragment)},l(s){v(p.$$.fragment,s)},m(s,$){y(p,s,$),g=!0},p(s,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:s}),p.$set(P)},i(s){g||(b(p.$$.fragment,s),g=!0)},o(s){k(p.$$.fragment,s),g=!1},d(s){x(p,s)}}}function rn(D){let p,g,s,$,P,N,ee,ae,se,M,F,T,U,q,S,K,z,X,C,R,le,A,W,ue,Y,L,pe,I,oe,Q,he,H,V,G,_,E,ce,Z,O,c,j,ne,te,re,we,J,B,st,Pe,Ae,ot,$t,Sa,Ra,wt,Ia,Ua,nt,La,Oa,Wt,me,Fa,rt,Ca,Ga,vt,Ha,Ba,Yt,it,za,Vt,ve,Te,yt,He,Wa,bt,Ya,Jt,lt,Va,Kt,Be,Xt,ye,qe,kt,ze,Ja,xt,Ka,Qt,pt,Xa,Zt,We,ea,fe,Qa,Et,Za,es,jt,ts,as,Pt,ss,os,ta,De,ns,At,rs,is,aa,Ye,sa,be,Ne,Tt,Ve,ls,qt,ps,oa,Me,na,ke,Se,Dt,Je,hs,Nt,fs,ra,de,us,Ke,cs,ms,Mt,ds,_s,ia,Re,gs,Xe,$s,ws,la,_e,St,vs,ys,Qe,bs,Rt,ks,xs,Es,Ze,js,It,Ps,As,pa,ht,Ts,ha,ge,qs,Ut,Ds,Ns,Lt,Ms,Ss,fa,Ie,ua,xe,Ue,Ot,et,Rs,Ft,Is,ca,Le,Us,ft,Ls,Os,ma,Ee,Oe,Ct,tt,Fs,Gt,Cs,da,Fe,Gs,ut,Hs,Bs,_a,Ce,ga;return N=new je({}),F=new Ho({props:{warning:!0,$$slots:{default:[Ko]},$$scope:{ctx:D}}}),L=new ie({props:{code:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`}}),G=new ie({props:{code:"accelerate config",highlighted:"accelerate config"}}),ne=new je({}),He=new je({}),Be=new ie({props:{code:"  --push_to_hub",highlighted:"  --push_to_hub"}}),ze=new je({}),We=new ie({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),Ye=new ie({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),Ve=new je({}),Me=new Bo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[en],pytorch:[Qo]},$$scope:{ctx:D}}}),Je=new je({}),Ie=new Ho({props:{warning:!0,$$slots:{default:[tn]},$$scope:{ctx:D}}}),et=new je({}),tt=new je({}),Ce=new Bo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[nn],pytorch:[sn]},$$scope:{ctx:D}}}),{c(){p=r("meta"),g=m(),s=r("h1"),$=r("a"),P=r("span"),w(N.$$.fragment),ee=m(),ae=r("span"),se=o("Text-to-image"),M=m(),w(F.$$.fragment),T=m(),U=r("p"),q=o("Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),S=r("a"),K=r("code"),z=o("CompVis/stable-diffusion-v1-4"),X=o(" model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),C=r("a"),R=o("repository"),le=o(" if you\u2019re interested in taking a closer look."),A=m(),W=r("p"),ue=o("Before running the scripts, make sure to install the library\u2019s training dependencies:"),Y=m(),w(L.$$.fragment),pe=m(),I=r("p"),oe=o("And initialize an "),Q=r("a"),he=o("\u{1F917} Accelerate"),H=o(" environment with:"),V=m(),w(G.$$.fragment),_=m(),E=r("p"),ce=o("If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Z=m(),O=r("h2"),c=r("a"),j=r("span"),w(ne.$$.fragment),te=m(),re=r("span"),we=o("Hardware requirements"),J=m(),B=r("p"),st=o("Using "),Pe=r("code"),Ae=o("gradient_checkpointing"),ot=o(" and "),$t=r("code"),Sa=o("mixed_precision"),Ra=o(", it should be possible to finetune the model on a single 24GB GPU. For higher "),wt=r("code"),Ia=o("batch_size"),Ua=o("\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),nt=r("a"),La=o("below"),Oa=o("."),Wt=m(),me=r("p"),Fa=o("You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),rt=r("a"),Ca=o("xFormers installed"),Ga=o(" and pass the "),vt=r("code"),Ha=o("--enable_xformers_memory_efficient_attention"),Ba=o(" flag to the training script."),Yt=m(),it=r("p"),za=o("xFormers is not available for Flax."),Vt=m(),ve=r("h2"),Te=r("a"),yt=r("span"),w(He.$$.fragment),Wa=m(),bt=r("span"),Ya=o("Upload model to Hub"),Jt=m(),lt=r("p"),Va=o("Store your model on the Hub by adding the following argument to the training script:"),Kt=m(),w(Be.$$.fragment),Xt=m(),ye=r("h2"),qe=r("a"),kt=r("span"),w(ze.$$.fragment),Ja=m(),xt=r("span"),Ka=o("Save and load checkpoints"),Qt=m(),pt=r("p"),Xa=o("It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),Zt=m(),w(We.$$.fragment),ea=m(),fe=r("p"),Qa=o("Every 500 steps, the full training state is saved in a subfolder in the "),Et=r("code"),Za=o("output_dir"),es=o(". The checkpoint has the format "),jt=r("code"),ts=o("checkpoint-"),as=o(" followed by the number of steps trained so far. For example, "),Pt=r("code"),ss=o("checkpoint-1500"),os=o(" is a checkpoint saved after 1500 training steps."),ta=m(),De=r("p"),ns=o("To load a checkpoint to resume training, pass the argument "),At=r("code"),rs=o("--resume_from_checkpoint"),is=o(" to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),aa=m(),w(Ye.$$.fragment),sa=m(),be=r("h2"),Ne=r("a"),Tt=r("span"),w(Ve.$$.fragment),ls=m(),qt=r("span"),ps=o("Fine-tuning"),oa=m(),w(Me.$$.fragment),na=m(),ke=r("h2"),Se=r("a"),Dt=r("span"),w(Je.$$.fragment),hs=m(),Nt=r("span"),fs=o("Training with Min-SNR weighting"),ra=m(),de=r("p"),us=o("We support training with the Min-SNR weighting strategy proposed in "),Ke=r("a"),cs=o("Efficient Diffusion Training via Min-SNR Weighting Strategy"),ms=o(` which helps to achieve faster convergence
by rebalancing the loss. In order to use it, one needs to set the `),Mt=r("code"),ds=o("--snr_gamma"),_s=o(` argument. The recommended
value when using it is 5.0.`),ia=m(),Re=r("p"),gs=o("You can find "),Xe=r("a"),$s=o("this project on Weights and Biases"),ws=o(" that compares the loss surfaces of the following setups:"),la=m(),_e=r("ul"),St=r("li"),vs=o("Training without the Min-SNR weighting strategy"),ys=m(),Qe=r("li"),bs=o("Training with the Min-SNR weighting strategy ("),Rt=r("code"),ks=o("snr_gamma"),xs=o(" set to 5.0)"),Es=m(),Ze=r("li"),js=o("Training with the Min-SNR weighting strategy ("),It=r("code"),Ps=o("snr_gamma"),As=o(" set to 1.0)"),pa=m(),ht=r("p"),Ts=o("For our small Pokemons dataset, the effects of Min-SNR weighting strategy might not appear to be pronounced, but for larger datasets, we believe the effects will be more pronounced."),ha=m(),ge=r("p"),qs=o("Also, note that in this example, we either predict "),Ut=r("code"),Ds=o("epsilon"),Ns=o(" (i.e., the noise) or the "),Lt=r("code"),Ms=o("v_prediction"),Ss=o(". For both of these cases, the formulation of the Min-SNR weighting strategy that we have used holds."),fa=m(),w(Ie.$$.fragment),ua=m(),xe=r("h2"),Ue=r("a"),Ot=r("span"),w(et.$$.fragment),Rs=m(),Ft=r("span"),Is=o("LoRA"),ca=m(),Le=r("p"),Us=o("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),ft=r("a"),Ls=o("LoRA training"),Os=o(" guide."),ma=m(),Ee=r("h2"),Oe=r("a"),Ct=r("span"),w(tt.$$.fragment),Fs=m(),Gt=r("span"),Cs=o("Inference"),da=m(),Fe=r("p"),Gs=o("Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),ut=r("a"),Hs=o("StableDiffusionPipeline"),Bs=o(":"),_a=m(),w(Ce.$$.fragment),this.h()},l(e){const f=Vo('[data-svelte="svelte-1phssyn"]',document.head);p=i(f,"META",{name:!0,content:!0}),f.forEach(t),g=d(e),s=i(e,"H1",{class:!0});var at=l(s);$=i(at,"A",{id:!0,class:!0,href:!0});var Ht=l($);P=i(Ht,"SPAN",{});var Bt=l(P);v(N.$$.fragment,Bt),Bt.forEach(t),Ht.forEach(t),ee=d(at),ae=i(at,"SPAN",{});var zt=l(ae);se=n(zt,"Text-to-image"),zt.forEach(t),at.forEach(t),M=d(e),v(F.$$.fragment,e),T=d(e),U=i(e,"P",{});var ct=l(U);q=n(ct,"Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),S=i(ct,"A",{href:!0,rel:!0});var zs=l(S);K=i(zs,"CODE",{});var Ws=l(K);z=n(Ws,"CompVis/stable-diffusion-v1-4"),Ws.forEach(t),zs.forEach(t),X=n(ct," model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),C=i(ct,"A",{href:!0,rel:!0});var Ys=l(C);R=n(Ys,"repository"),Ys.forEach(t),le=n(ct," if you\u2019re interested in taking a closer look."),ct.forEach(t),A=d(e),W=i(e,"P",{});var Vs=l(W);ue=n(Vs,"Before running the scripts, make sure to install the library\u2019s training dependencies:"),Vs.forEach(t),Y=d(e),v(L.$$.fragment,e),pe=d(e),I=i(e,"P",{});var $a=l(I);oe=n($a,"And initialize an "),Q=i($a,"A",{href:!0,rel:!0});var Js=l(Q);he=n(Js,"\u{1F917} Accelerate"),Js.forEach(t),H=n($a," environment with:"),$a.forEach(t),V=d(e),v(G.$$.fragment,e),_=d(e),E=i(e,"P",{});var Ks=l(E);ce=n(Ks,"If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Ks.forEach(t),Z=d(e),O=i(e,"H2",{class:!0});var wa=l(O);c=i(wa,"A",{id:!0,class:!0,href:!0});var Xs=l(c);j=i(Xs,"SPAN",{});var Qs=l(j);v(ne.$$.fragment,Qs),Qs.forEach(t),Xs.forEach(t),te=d(wa),re=i(wa,"SPAN",{});var Zs=l(re);we=n(Zs,"Hardware requirements"),Zs.forEach(t),wa.forEach(t),J=d(e),B=i(e,"P",{});var $e=l(B);st=n($e,"Using "),Pe=i($e,"CODE",{});var eo=l(Pe);Ae=n(eo,"gradient_checkpointing"),eo.forEach(t),ot=n($e," and "),$t=i($e,"CODE",{});var to=l($t);Sa=n(to,"mixed_precision"),to.forEach(t),Ra=n($e,", it should be possible to finetune the model on a single 24GB GPU. For higher "),wt=i($e,"CODE",{});var ao=l(wt);Ia=n(ao,"batch_size"),ao.forEach(t),Ua=n($e,"\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),nt=i($e,"A",{href:!0});var so=l(nt);La=n(so,"below"),so.forEach(t),Oa=n($e,"."),$e.forEach(t),Wt=d(e),me=i(e,"P",{});var mt=l(me);Fa=n(mt,"You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),rt=i(mt,"A",{href:!0});var oo=l(rt);Ca=n(oo,"xFormers installed"),oo.forEach(t),Ga=n(mt," and pass the "),vt=i(mt,"CODE",{});var no=l(vt);Ha=n(no,"--enable_xformers_memory_efficient_attention"),no.forEach(t),Ba=n(mt," flag to the training script."),mt.forEach(t),Yt=d(e),it=i(e,"P",{});var ro=l(it);za=n(ro,"xFormers is not available for Flax."),ro.forEach(t),Vt=d(e),ve=i(e,"H2",{class:!0});var va=l(ve);Te=i(va,"A",{id:!0,class:!0,href:!0});var io=l(Te);yt=i(io,"SPAN",{});var lo=l(yt);v(He.$$.fragment,lo),lo.forEach(t),io.forEach(t),Wa=d(va),bt=i(va,"SPAN",{});var po=l(bt);Ya=n(po,"Upload model to Hub"),po.forEach(t),va.forEach(t),Jt=d(e),lt=i(e,"P",{});var ho=l(lt);Va=n(ho,"Store your model on the Hub by adding the following argument to the training script:"),ho.forEach(t),Kt=d(e),v(Be.$$.fragment,e),Xt=d(e),ye=i(e,"H2",{class:!0});var ya=l(ye);qe=i(ya,"A",{id:!0,class:!0,href:!0});var fo=l(qe);kt=i(fo,"SPAN",{});var uo=l(kt);v(ze.$$.fragment,uo),uo.forEach(t),fo.forEach(t),Ja=d(ya),xt=i(ya,"SPAN",{});var co=l(xt);Ka=n(co,"Save and load checkpoints"),co.forEach(t),ya.forEach(t),Qt=d(e),pt=i(e,"P",{});var mo=l(pt);Xa=n(mo,"It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),mo.forEach(t),Zt=d(e),v(We.$$.fragment,e),ea=d(e),fe=i(e,"P",{});var Ge=l(fe);Qa=n(Ge,"Every 500 steps, the full training state is saved in a subfolder in the "),Et=i(Ge,"CODE",{});var _o=l(Et);Za=n(_o,"output_dir"),_o.forEach(t),es=n(Ge,". The checkpoint has the format "),jt=i(Ge,"CODE",{});var go=l(jt);ts=n(go,"checkpoint-"),go.forEach(t),as=n(Ge," followed by the number of steps trained so far. For example, "),Pt=i(Ge,"CODE",{});var $o=l(Pt);ss=n($o,"checkpoint-1500"),$o.forEach(t),os=n(Ge," is a checkpoint saved after 1500 training steps."),Ge.forEach(t),ta=d(e),De=i(e,"P",{});var ba=l(De);ns=n(ba,"To load a checkpoint to resume training, pass the argument "),At=i(ba,"CODE",{});var wo=l(At);rs=n(wo,"--resume_from_checkpoint"),wo.forEach(t),is=n(ba," to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),ba.forEach(t),aa=d(e),v(Ye.$$.fragment,e),sa=d(e),be=i(e,"H2",{class:!0});var ka=l(be);Ne=i(ka,"A",{id:!0,class:!0,href:!0});var vo=l(Ne);Tt=i(vo,"SPAN",{});var yo=l(Tt);v(Ve.$$.fragment,yo),yo.forEach(t),vo.forEach(t),ls=d(ka),qt=i(ka,"SPAN",{});var bo=l(qt);ps=n(bo,"Fine-tuning"),bo.forEach(t),ka.forEach(t),oa=d(e),v(Me.$$.fragment,e),na=d(e),ke=i(e,"H2",{class:!0});var xa=l(ke);Se=i(xa,"A",{id:!0,class:!0,href:!0});var ko=l(Se);Dt=i(ko,"SPAN",{});var xo=l(Dt);v(Je.$$.fragment,xo),xo.forEach(t),ko.forEach(t),hs=d(xa),Nt=i(xa,"SPAN",{});var Eo=l(Nt);fs=n(Eo,"Training with Min-SNR weighting"),Eo.forEach(t),xa.forEach(t),ra=d(e),de=i(e,"P",{});var dt=l(de);us=n(dt,"We support training with the Min-SNR weighting strategy proposed in "),Ke=i(dt,"A",{href:!0,rel:!0});var jo=l(Ke);cs=n(jo,"Efficient Diffusion Training via Min-SNR Weighting Strategy"),jo.forEach(t),ms=n(dt,` which helps to achieve faster convergence
by rebalancing the loss. In order to use it, one needs to set the `),Mt=i(dt,"CODE",{});var Po=l(Mt);ds=n(Po,"--snr_gamma"),Po.forEach(t),_s=n(dt,` argument. The recommended
value when using it is 5.0.`),dt.forEach(t),ia=d(e),Re=i(e,"P",{});var Ea=l(Re);gs=n(Ea,"You can find "),Xe=i(Ea,"A",{href:!0,rel:!0});var Ao=l(Xe);$s=n(Ao,"this project on Weights and Biases"),Ao.forEach(t),ws=n(Ea," that compares the loss surfaces of the following setups:"),Ea.forEach(t),la=d(e),_e=i(e,"UL",{});var _t=l(_e);St=i(_t,"LI",{});var To=l(St);vs=n(To,"Training without the Min-SNR weighting strategy"),To.forEach(t),ys=d(_t),Qe=i(_t,"LI",{});var ja=l(Qe);bs=n(ja,"Training with the Min-SNR weighting strategy ("),Rt=i(ja,"CODE",{});var qo=l(Rt);ks=n(qo,"snr_gamma"),qo.forEach(t),xs=n(ja," set to 5.0)"),ja.forEach(t),Es=d(_t),Ze=i(_t,"LI",{});var Pa=l(Ze);js=n(Pa,"Training with the Min-SNR weighting strategy ("),It=i(Pa,"CODE",{});var Do=l(It);Ps=n(Do,"snr_gamma"),Do.forEach(t),As=n(Pa," set to 1.0)"),Pa.forEach(t),_t.forEach(t),pa=d(e),ht=i(e,"P",{});var No=l(ht);Ts=n(No,"For our small Pokemons dataset, the effects of Min-SNR weighting strategy might not appear to be pronounced, but for larger datasets, we believe the effects will be more pronounced."),No.forEach(t),ha=d(e),ge=i(e,"P",{});var gt=l(ge);qs=n(gt,"Also, note that in this example, we either predict "),Ut=i(gt,"CODE",{});var Mo=l(Ut);Ds=n(Mo,"epsilon"),Mo.forEach(t),Ns=n(gt," (i.e., the noise) or the "),Lt=i(gt,"CODE",{});var So=l(Lt);Ms=n(So,"v_prediction"),So.forEach(t),Ss=n(gt,". For both of these cases, the formulation of the Min-SNR weighting strategy that we have used holds."),gt.forEach(t),fa=d(e),v(Ie.$$.fragment,e),ua=d(e),xe=i(e,"H2",{class:!0});var Aa=l(xe);Ue=i(Aa,"A",{id:!0,class:!0,href:!0});var Ro=l(Ue);Ot=i(Ro,"SPAN",{});var Io=l(Ot);v(et.$$.fragment,Io),Io.forEach(t),Ro.forEach(t),Rs=d(Aa),Ft=i(Aa,"SPAN",{});var Uo=l(Ft);Is=n(Uo,"LoRA"),Uo.forEach(t),Aa.forEach(t),ca=d(e),Le=i(e,"P",{});var Ta=l(Le);Us=n(Ta,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),ft=i(Ta,"A",{href:!0});var Lo=l(ft);Ls=n(Lo,"LoRA training"),Lo.forEach(t),Os=n(Ta," guide."),Ta.forEach(t),ma=d(e),Ee=i(e,"H2",{class:!0});var qa=l(Ee);Oe=i(qa,"A",{id:!0,class:!0,href:!0});var Oo=l(Oe);Ct=i(Oo,"SPAN",{});var Fo=l(Ct);v(tt.$$.fragment,Fo),Fo.forEach(t),Oo.forEach(t),Fs=d(qa),Gt=i(qa,"SPAN",{});var Co=l(Gt);Cs=n(Co,"Inference"),Co.forEach(t),qa.forEach(t),da=d(e),Fe=i(e,"P",{});var Da=l(Fe);Gs=n(Da,"Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),ut=i(Da,"A",{href:!0});var Go=l(ut);Hs=n(Go,"StableDiffusionPipeline"),Go.forEach(t),Bs=n(Da,":"),Da.forEach(t),_a=d(e),v(Ce.$$.fragment,e),this.h()},h(){u(p,"name","hf:doc:metadata"),u(p,"content",JSON.stringify(ln)),u($,"id","texttoimage"),u($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u($,"href","#texttoimage"),u(s,"class","relative group"),u(S,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),u(S,"rel","nofollow"),u(C,"href","https://github.com/huggingface/diffusers/tree/main/examples/text_to_image"),u(C,"rel","nofollow"),u(Q,"href","https://github.com/huggingface/accelerate/"),u(Q,"rel","nofollow"),u(c,"id","hardware-requirements"),u(c,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(c,"href","#hardware-requirements"),u(O,"class","relative group"),u(nt,"href","#flax-jax-finetuning"),u(rt,"href","./optimization/xformers"),u(Te,"id","upload-model-to-hub"),u(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Te,"href","#upload-model-to-hub"),u(ve,"class","relative group"),u(qe,"id","save-and-load-checkpoints"),u(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(qe,"href","#save-and-load-checkpoints"),u(ye,"class","relative group"),u(Ne,"id","finetuning"),u(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ne,"href","#finetuning"),u(be,"class","relative group"),u(Se,"id","training-with-minsnr-weighting"),u(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Se,"href","#training-with-minsnr-weighting"),u(ke,"class","relative group"),u(Ke,"href","https://arxiv.org/abs/2303.09556"),u(Ke,"rel","nofollow"),u(Xe,"href","https://wandb.ai/sayakpaul/text2image-finetune-minsnr"),u(Xe,"rel","nofollow"),u(Ue,"id","lora"),u(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ue,"href","#lora"),u(xe,"class","relative group"),u(ft,"href","lora#text-to-image"),u(Oe,"id","inference"),u(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Oe,"href","#inference"),u(Ee,"class","relative group"),u(ut,"href","/docs/diffusers/pr_2555/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline")},m(e,f){a(document.head,p),h(e,g,f),h(e,s,f),a(s,$),a($,P),y(N,P,null),a(s,ee),a(s,ae),a(ae,se),h(e,M,f),y(F,e,f),h(e,T,f),h(e,U,f),a(U,q),a(U,S),a(S,K),a(K,z),a(U,X),a(U,C),a(C,R),a(U,le),h(e,A,f),h(e,W,f),a(W,ue),h(e,Y,f),y(L,e,f),h(e,pe,f),h(e,I,f),a(I,oe),a(I,Q),a(Q,he),a(I,H),h(e,V,f),y(G,e,f),h(e,_,f),h(e,E,f),a(E,ce),h(e,Z,f),h(e,O,f),a(O,c),a(c,j),y(ne,j,null),a(O,te),a(O,re),a(re,we),h(e,J,f),h(e,B,f),a(B,st),a(B,Pe),a(Pe,Ae),a(B,ot),a(B,$t),a($t,Sa),a(B,Ra),a(B,wt),a(wt,Ia),a(B,Ua),a(B,nt),a(nt,La),a(B,Oa),h(e,Wt,f),h(e,me,f),a(me,Fa),a(me,rt),a(rt,Ca),a(me,Ga),a(me,vt),a(vt,Ha),a(me,Ba),h(e,Yt,f),h(e,it,f),a(it,za),h(e,Vt,f),h(e,ve,f),a(ve,Te),a(Te,yt),y(He,yt,null),a(ve,Wa),a(ve,bt),a(bt,Ya),h(e,Jt,f),h(e,lt,f),a(lt,Va),h(e,Kt,f),y(Be,e,f),h(e,Xt,f),h(e,ye,f),a(ye,qe),a(qe,kt),y(ze,kt,null),a(ye,Ja),a(ye,xt),a(xt,Ka),h(e,Qt,f),h(e,pt,f),a(pt,Xa),h(e,Zt,f),y(We,e,f),h(e,ea,f),h(e,fe,f),a(fe,Qa),a(fe,Et),a(Et,Za),a(fe,es),a(fe,jt),a(jt,ts),a(fe,as),a(fe,Pt),a(Pt,ss),a(fe,os),h(e,ta,f),h(e,De,f),a(De,ns),a(De,At),a(At,rs),a(De,is),h(e,aa,f),y(Ye,e,f),h(e,sa,f),h(e,be,f),a(be,Ne),a(Ne,Tt),y(Ve,Tt,null),a(be,ls),a(be,qt),a(qt,ps),h(e,oa,f),y(Me,e,f),h(e,na,f),h(e,ke,f),a(ke,Se),a(Se,Dt),y(Je,Dt,null),a(ke,hs),a(ke,Nt),a(Nt,fs),h(e,ra,f),h(e,de,f),a(de,us),a(de,Ke),a(Ke,cs),a(de,ms),a(de,Mt),a(Mt,ds),a(de,_s),h(e,ia,f),h(e,Re,f),a(Re,gs),a(Re,Xe),a(Xe,$s),a(Re,ws),h(e,la,f),h(e,_e,f),a(_e,St),a(St,vs),a(_e,ys),a(_e,Qe),a(Qe,bs),a(Qe,Rt),a(Rt,ks),a(Qe,xs),a(_e,Es),a(_e,Ze),a(Ze,js),a(Ze,It),a(It,Ps),a(Ze,As),h(e,pa,f),h(e,ht,f),a(ht,Ts),h(e,ha,f),h(e,ge,f),a(ge,qs),a(ge,Ut),a(Ut,Ds),a(ge,Ns),a(ge,Lt),a(Lt,Ms),a(ge,Ss),h(e,fa,f),y(Ie,e,f),h(e,ua,f),h(e,xe,f),a(xe,Ue),a(Ue,Ot),y(et,Ot,null),a(xe,Rs),a(xe,Ft),a(Ft,Is),h(e,ca,f),h(e,Le,f),a(Le,Us),a(Le,ft),a(ft,Ls),a(Le,Os),h(e,ma,f),h(e,Ee,f),a(Ee,Oe),a(Oe,Ct),y(tt,Ct,null),a(Ee,Fs),a(Ee,Gt),a(Gt,Cs),h(e,da,f),h(e,Fe,f),a(Fe,Gs),a(Fe,ut),a(ut,Hs),a(Fe,Bs),h(e,_a,f),y(Ce,e,f),ga=!0},p(e,[f]){const at={};f&2&&(at.$$scope={dirty:f,ctx:e}),F.$set(at);const Ht={};f&2&&(Ht.$$scope={dirty:f,ctx:e}),Me.$set(Ht);const Bt={};f&2&&(Bt.$$scope={dirty:f,ctx:e}),Ie.$set(Bt);const zt={};f&2&&(zt.$$scope={dirty:f,ctx:e}),Ce.$set(zt)},i(e){ga||(b(N.$$.fragment,e),b(F.$$.fragment,e),b(L.$$.fragment,e),b(G.$$.fragment,e),b(ne.$$.fragment,e),b(He.$$.fragment,e),b(Be.$$.fragment,e),b(ze.$$.fragment,e),b(We.$$.fragment,e),b(Ye.$$.fragment,e),b(Ve.$$.fragment,e),b(Me.$$.fragment,e),b(Je.$$.fragment,e),b(Ie.$$.fragment,e),b(et.$$.fragment,e),b(tt.$$.fragment,e),b(Ce.$$.fragment,e),ga=!0)},o(e){k(N.$$.fragment,e),k(F.$$.fragment,e),k(L.$$.fragment,e),k(G.$$.fragment,e),k(ne.$$.fragment,e),k(He.$$.fragment,e),k(Be.$$.fragment,e),k(ze.$$.fragment,e),k(We.$$.fragment,e),k(Ye.$$.fragment,e),k(Ve.$$.fragment,e),k(Me.$$.fragment,e),k(Je.$$.fragment,e),k(Ie.$$.fragment,e),k(et.$$.fragment,e),k(tt.$$.fragment,e),k(Ce.$$.fragment,e),ga=!1},d(e){t(p),e&&t(g),e&&t(s),x(N),e&&t(M),x(F,e),e&&t(T),e&&t(U),e&&t(A),e&&t(W),e&&t(Y),x(L,e),e&&t(pe),e&&t(I),e&&t(V),x(G,e),e&&t(_),e&&t(E),e&&t(Z),e&&t(O),x(ne),e&&t(J),e&&t(B),e&&t(Wt),e&&t(me),e&&t(Yt),e&&t(it),e&&t(Vt),e&&t(ve),x(He),e&&t(Jt),e&&t(lt),e&&t(Kt),x(Be,e),e&&t(Xt),e&&t(ye),x(ze),e&&t(Qt),e&&t(pt),e&&t(Zt),x(We,e),e&&t(ea),e&&t(fe),e&&t(ta),e&&t(De),e&&t(aa),x(Ye,e),e&&t(sa),e&&t(be),x(Ve),e&&t(oa),x(Me,e),e&&t(na),e&&t(ke),x(Je),e&&t(ra),e&&t(de),e&&t(ia),e&&t(Re),e&&t(la),e&&t(_e),e&&t(pa),e&&t(ht),e&&t(ha),e&&t(ge),e&&t(fa),x(Ie,e),e&&t(ua),e&&t(xe),x(et),e&&t(ca),e&&t(Le),e&&t(ma),e&&t(Ee),x(tt),e&&t(da),e&&t(Fe),e&&t(_a),x(Ce,e)}}}const ln={local:"texttoimage",sections:[{local:"hardware-requirements",title:"Hardware requirements"},{local:"upload-model-to-hub",title:"Upload model to Hub"},{local:"save-and-load-checkpoints",title:"Save and load checkpoints"},{local:"finetuning",sections:[{local:"training-with-multiple-gpus",title:"Training with multiple GPUs"}],title:"Fine-tuning"},{local:"training-with-minsnr-weighting",title:"Training with Min-SNR weighting"},{local:"lora",title:"LoRA"},{local:"inference",title:"Inference"}],title:"Text-to-image"};function pn(D){return Jo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class dn extends zo{constructor(p){super();Wo(this,p,pn,rn,Yo,{})}}export{dn as default,ln as metadata};
