import{S as v$,i as y$,s as x$,e as n,k as i,w as f,t as l,M as $$,c as s,d as o,m as d,a as r,x as u,h as c,b as a,G as e,g as p,y as h,q as _,o as g,B as b,v as w$,L as kl}from"../../chunks/vendor-hf-doc-builder.js";import{T as b$}from"../../chunks/Tip-hf-doc-builder.js";import{D as y}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Tl}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as T}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Dl}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function D$(I){let x,M,D,$,k;return $=new Tl({props:{code:`import torch
from diffusers import UNet2DConditionModel
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

model = UNet2DConditionModel.from_pretrained(
    "stabilityai/stable-diffusion-2-1", subfolder="unet", torch_dtype=torch.float16
)
model = model.to("cuda")
model.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UNet2DConditionModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>model = UNet2DConditionModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, subfolder=<span class="hljs-string">&quot;unet&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = model.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)`}}),{c(){x=n("p"),M=l("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Examples:"),w.forEach(o),D=d(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,M),p(v,D,w),h($,v,w),k=!0},p:kl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&o(x),v&&o(D),b($,v)}}}function k$(I){let x,M,D,$,k,v,w,re;return{c(){x=n("p"),M=l("It is required to be logged in ("),D=n("code"),$=l("huggingface-cli login"),k=l(") when you want to use private or "),v=n("a"),w=l(`gated
models`),re=l("."),this.h()},l(Fe){x=s(Fe,"P",{});var Q=r(x);M=c(Q,"It is required to be logged in ("),D=s(Q,"CODE",{});var Y=r(D);$=c(Y,"huggingface-cli login"),Y.forEach(o),k=c(Q,") when you want to use private or "),v=s(Q,"A",{href:!0,rel:!0});var Fr=r(v);w=c(Fr,`gated
models`),Fr.forEach(o),re=c(Q,"."),Q.forEach(o),this.h()},h(){a(v,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),a(v,"rel","nofollow")},m(Fe,Q){p(Fe,x,Q),e(x,M),e(x,D),e(D,$),e(x,k),e(x,v),e(v,w),e(x,re)},d(Fe){Fe&&o(x)}}}function T$(I){let x,M,D,$,k;return{c(){x=n("p"),M=l("Activate the special "),D=n("a"),$=l("\u201Coffline-mode\u201D"),k=l(` to use
this method in a firewalled environment.`),this.h()},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Activate the special "),D=s(w,"A",{href:!0,rel:!0});var re=r(D);$=c(re,"\u201Coffline-mode\u201D"),re.forEach(o),k=c(w,` to use
this method in a firewalled environment.`),w.forEach(o),this.h()},h(){a(D,"href","https://huggingface.co/diffusers/installation.html#offline-mode"),a(D,"rel","nofollow")},m(v,w){p(v,x,w),e(x,M),e(x,D),e(D,$),e(x,k)},d(v){v&&o(x)}}}function M$(I){let x,M,D,$,k;return $=new Tl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# Download model and configuration from huggingface.co and cache.
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# Model was saved using *save_pretrained('./test/saved_model/')* (for example purposes, not runnable).
model, params = FlaxUNet2DConditionModel.from_pretrained("./test/saved_model/")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download model and configuration from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model was saved using *save_pretrained(&#x27;./test/saved_model/&#x27;)* (for example purposes, not runnable).</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;./test/saved_model/&quot;</span>)`}}),{c(){x=n("p"),M=l("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Examples:"),w.forEach(o),D=d(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,M),p(v,D,w),h($,v,w),k=!0},p:kl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&o(x),v&&o(D),b($,v)}}}function N$(I){let x,M,D,$,k;return $=new Tl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# load model
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model parameters will be in fp32 precision, to cast these to bfloat16 precision
params = model.to_bf16(params)
# If you don't want to cast certain parameters (for example layer norm bias and scale)
# then pass the mask as follows
from flax import traverse_util

model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
flat_params = traverse_util.flatten_dict(params)
mask = {
    path: (path[-2] != ("LayerNorm", "bias") and path[-2:] != ("LayerNorm", "scale"))
    for path in flat_params
}
mask = traverse_util.unflatten_dict(mask)
params = model.to_bf16(params, mask)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model parameters will be in fp32 precision, to cast these to bfloat16 precision</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_bf16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># If you don&#x27;t want to cast certain parameters (for example layer norm bias and scale)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># then pass the mask as follows</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax <span class="hljs-keyword">import</span> traverse_util

<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>flat_params = traverse_util.flatten_dict(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = {
<span class="hljs-meta">... </span>    path: (path[-<span class="hljs-number">2</span>] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;bias&quot;</span>) <span class="hljs-keyword">and</span> path[-<span class="hljs-number">2</span>:] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;scale&quot;</span>))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> path <span class="hljs-keyword">in</span> flat_params
<span class="hljs-meta">... </span>}
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = traverse_util.unflatten_dict(mask)
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_bf16(params, mask)`}}),{c(){x=n("p"),M=l("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Examples:"),w.forEach(o),D=d(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,M),p(v,D,w),h($,v,w),k=!0},p:kl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&o(x),v&&o(D),b($,v)}}}function A$(I){let x,M,D,$,k;return $=new Tl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# load model
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model params will be in fp32, to cast these to float16
params = model.to_fp16(params)
# If you want don't want to cast certain parameters (for example layer norm bias and scale)
# then pass the mask as follows
from flax import traverse_util

model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
flat_params = traverse_util.flatten_dict(params)
mask = {
    path: (path[-2] != ("LayerNorm", "bias") and path[-2:] != ("LayerNorm", "scale"))
    for path in flat_params
}
mask = traverse_util.unflatten_dict(mask)
params = model.to_fp16(params, mask)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model params will be in fp32, to cast these to float16</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># If you want don&#x27;t want to cast certain parameters (for example layer norm bias and scale)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># then pass the mask as follows</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax <span class="hljs-keyword">import</span> traverse_util

<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>flat_params = traverse_util.flatten_dict(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = {
<span class="hljs-meta">... </span>    path: (path[-<span class="hljs-number">2</span>] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;bias&quot;</span>) <span class="hljs-keyword">and</span> path[-<span class="hljs-number">2</span>:] != (<span class="hljs-string">&quot;LayerNorm&quot;</span>, <span class="hljs-string">&quot;scale&quot;</span>))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> path <span class="hljs-keyword">in</span> flat_params
<span class="hljs-meta">... </span>}
<span class="hljs-meta">&gt;&gt;&gt; </span>mask = traverse_util.unflatten_dict(mask)
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp16(params, mask)`}}),{c(){x=n("p"),M=l("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Examples:"),w.forEach(o),D=d(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,M),p(v,D,w),h($,v,w),k=!0},p:kl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&o(x),v&&o(D),b($,v)}}}function E$(I){let x,M,D,$,k;return $=new Tl({props:{code:`from diffusers import FlaxUNet2DConditionModel

# Download model and configuration from huggingface.co
model, params = FlaxUNet2DConditionModel.from_pretrained("runwayml/stable-diffusion-v1-5")
# By default, the model params will be in fp32, to illustrate the use of this method,
# we'll first cast to fp16 and back to fp32
params = model.to_f16(params)
# now cast back to fp32
params = model.to_fp32(params)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxUNet2DConditionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download model and configuration from huggingface.co</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, params = FlaxUNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># By default, the model params will be in fp32, to illustrate the use of this method,</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># we&#x27;ll first cast to fp16 and back to fp32</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_f16(params)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># now cast back to fp32</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>params = model.to_fp32(params)`}}),{c(){x=n("p"),M=l("Examples:"),D=i(),f($.$$.fragment)},l(v){x=s(v,"P",{});var w=r(x);M=c(w,"Examples:"),w.forEach(o),D=d(v),u($.$$.fragment,v)},m(v,w){p(v,x,w),e(x,M),p(v,D,w),h($,v,w),k=!0},p:kl,i(v){k||(_($.$$.fragment,v),k=!0)},o(v){g($.$$.fragment,v),k=!1},d(v){v&&o(x),v&&o(D),b($,v)}}}function U$(I){let x,M,D,$,k,v,w,re,Fe,Q,Y,Fr,$a,lp,cp,wa,mp,pp,Ml,Pe,vt,Da,Po,fp,ka,up,Nl,N,Oo,hp,Ta,_p,gp,Pr,Or,bp,vp,yp,Ma,be,Na,xp,$p,Aa,wp,Dp,Lr,kp,Tp,Mp,ve,Lo,Np,Ea,Ap,Ep,Ua,Up,Cp,yt,qo,Fp,Ca,Pp,Op,ye,jo,Lp,Fa,qp,jp,Pa,Ip,zp,K,Io,Vp,Oa,Bp,Sp,La,Kp,Wp,qa,Xp,Hp,xt,Rp,O,zo,Qp,ja,Yp,Gp,Oe,Jp,Ia,Zp,ef,za,tf,of,nf,Vo,sf,Va,rf,af,df,Bo,lf,Ba,cf,mf,pf,$t,ff,wt,uf,Dt,So,hf,Sa,_f,gf,kt,Ko,bf,Wo,vf,Ka,yf,xf,Al,Le,Tt,Wa,Xo,$f,Xa,wf,El,Ho,Ro,Ul,qe,Mt,Ha,Qo,Df,Ra,kf,Cl,G,Yo,Tf,Qa,Mf,Nf,Go,Af,qr,Ef,Uf,Cf,jr,Jo,Fl,je,Nt,Ya,Zo,Ff,Ga,Pf,Pl,en,tn,Ol,Ie,At,Ja,on,Of,Za,Lf,Ll,J,nn,qf,ei,jf,If,sn,zf,Ir,Vf,Bf,Sf,zr,rn,ql,ze,Et,ti,an,Kf,oi,Wf,jl,dn,ln,Il,Ve,Ut,ni,cn,Xf,si,Hf,zl,F,mn,Rf,ri,Qf,Yf,pn,Gf,Vr,Jf,Zf,eu,Br,fn,tu,xe,un,ou,ai,nu,su,ii,ru,au,Sr,hn,iu,Ct,_n,du,di,lu,Vl,Be,Ft,li,gn,cu,ci,mu,Bl,bn,vn,Sl,Se,Pt,mi,yn,pu,pi,fu,Kl,P,xn,uu,fi,hu,_u,$n,gu,Kr,bu,vu,yu,Wr,wn,xu,$e,Dn,$u,ui,wu,Du,hi,ku,Tu,Xr,kn,Mu,Ot,Tn,Nu,_i,Au,Wl,Ke,Lt,gi,Mn,Eu,bi,Uu,Xl,We,Nn,Cu,vi,Fu,Hl,Xe,qt,yi,An,Pu,xi,Ou,Rl,He,En,Lu,$i,qu,Ql,Re,jt,wi,Un,ju,Di,Iu,Yl,Z,Cn,zu,ki,Vu,Bu,Fn,Su,Hr,Ku,Wu,Xu,Rr,Pn,Gl,Qe,It,Ti,On,Hu,Mi,Ru,Jl,Ye,Ln,Qu,Ni,Yu,Zl,Ge,zt,Ai,qn,Gu,Ei,Ju,ec,A,jn,Zu,Ui,eh,th,In,oh,Qr,nh,sh,rh,Vt,zn,ah,Vn,ih,Ci,dh,lh,ch,Bt,Bn,mh,Sn,ph,Fi,fh,uh,hh,St,Kn,_h,Pi,gh,bh,Kt,Wn,vh,Oi,yh,xh,Yr,Xn,$h,Wt,Hn,wh,Li,Dh,kh,Xt,Rn,Th,qi,Mh,tc,Je,Ht,ji,Qn,Nh,Ii,Ah,oc,L,Yn,Eh,zi,Uh,Ch,Vi,Fh,Ph,Gn,Oh,Bi,Lh,qh,jh,Si,Ih,zh,Gr,Jn,nc,Ze,Rt,Ki,Zn,Vh,Wi,Bh,sc,es,ts,rc,et,Qt,Xi,os,Sh,Hi,Kh,ac,me,ns,Wh,Ri,Xh,Hh,Jr,ss,ic,tt,Yt,Qi,rs,Rh,Yi,Qh,dc,as,is,lc,ot,Gt,Gi,ds,Yh,Ji,Gh,cc,V,ls,Jh,Zi,Zh,e_,cs,t_,Zr,o_,n_,s_,ea,r_,ms,a_,i_,ta,ps,mc,nt,Jt,ed,fs,d_,td,l_,pc,us,hs,fc,st,Zt,od,_s,c_,nd,m_,uc,gs,bs,hc,rt,eo,sd,vs,p_,rd,f_,_c,B,ys,u_,to,xs,h_,ad,__,g_,we,$s,b_,id,v_,y_,dd,x_,$_,oa,ws,w_,oo,Ds,D_,ld,k_,gc,at,no,cd,ks,T_,md,M_,bc,ee,Ts,N_,pe,A_,na,E_,U_,Ms,C_,F_,Ns,P_,O_,L_,As,q_,sa,j_,I_,z_,ra,Es,vc,it,so,pd,Us,V_,fd,B_,yc,te,Cs,S_,ud,K_,W_,Fs,X_,aa,H_,R_,Q_,ia,Ps,xc,dt,ro,hd,Os,Y_,_d,G_,$c,U,Ls,J_,gd,Z_,eg,da,la,tg,og,ng,W,qs,sg,bd,rg,ag,js,ig,vd,dg,lg,cg,Is,mg,yd,pg,fg,ug,ao,hg,io,zs,_g,Vs,gg,xd,bg,vg,yg,ae,Bs,xg,oe,$g,$d,wg,Dg,wd,kg,Tg,Dd,Mg,Ng,kd,Ag,Eg,Ug,Td,Cg,Fg,lo,Pg,ie,Ss,Og,ne,Lg,Md,qg,jg,Nd,Ig,zg,Ad,Vg,Bg,Ed,Sg,Kg,Wg,Ud,Xg,Hg,co,Rg,De,Ks,Qg,se,Yg,Cd,Gg,Jg,Fd,Zg,e2,Pd,t2,o2,Od,n2,s2,r2,mo,wc,lt,po,Ld,Ws,a2,qd,i2,Dc,ct,Xs,d2,fo,Hs,l2,jd,c2,kc,mt,uo,Id,Rs,m2,zd,p2,Tc,q,Qs,f2,Vd,u2,h2,Ys,_2,ca,g2,b2,v2,Gs,y2,Js,x2,$2,w2,Bd,D2,k2,fe,Sd,Zs,T2,M2,Kd,er,N2,A2,Wd,tr,E2,U2,Xd,or,C2,Mc,pt,ho,Hd,nr,F2,Rd,P2,Nc,ue,sr,O2,Qd,L2,q2,_o,rr,j2,Yd,I2,Ac,ft,go,Gd,ar,z2,Jd,V2,Ec,he,ir,B2,Zd,S2,K2,bo,dr,W2,el,X2,Uc,ut,vo,tl,lr,H2,ol,R2,Cc,S,cr,Q2,nl,Y2,G2,mr,J2,pr,Z2,eb,tb,sl,ob,nb,_e,rl,fr,sb,rb,al,ur,ab,ib,il,hr,db,lb,dl,_r,cb,Fc,ht,yo,ll,gr,mb,cl,pb,Pc,_t,br,fb,xo,vr,ub,ml,hb,Oc,gt,$o,pl,yr,_b,fl,gb,Lc,j,xr,bb,$r,vb,wr,yb,xb,$b,Dr,wb,ma,Db,kb,Tb,kr,Mb,Tr,Nb,Ab,Eb,ul,Ub,Cb,ge,hl,Mr,Fb,Pb,_l,Nr,Ob,Lb,gl,Ar,qb,jb,bl,Er,Ib,qc;return v=new T({}),Po=new T({}),Oo=new y({props:{name:"class diffusers.ModelMixin",anchor:"diffusers.ModelMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L143"}}),Lo=new y({props:{name:"disable_gradient_checkpointing",anchor:"diffusers.ModelMixin.disable_gradient_checkpointing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L199"}}),qo=new y({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.ModelMixin.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L258"}}),jo=new y({props:{name:"enable_gradient_checkpointing",anchor:"diffusers.ModelMixin.enable_gradient_checkpointing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L188"}}),Io=new y({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L226"}}),xt=new Dl({props:{anchor:"diffusers.ModelMixin.enable_xformers_memory_efficient_attention.example",$$slots:{default:[D$]},$$scope:{ctx:I}}}),zo=new y({props:{name:"from_pretrained",anchor:"diffusers.ModelMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike, NoneType]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.ModelMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.ModelMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.ModelMixin.from_pretrained.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.ModelMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.ModelMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.ModelMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.ModelMixin.from_pretrained.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.ModelMixin.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.ModelMixin.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.ModelMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.ModelMixin.from_pretrained.from_flax",description:`<strong>from_flax</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Load the model weights from a Flax checkpoint save file.`,name:"from_flax"},{anchor:"diffusers.ModelMixin.from_pretrained.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.ModelMixin.from_pretrained.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"},{anchor:"diffusers.ModelMixin.from_pretrained.device_map",description:`<strong>device_map</strong> (<code>str</code> or <code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each
parameter/buffer name, once a given module name is inside, every submodule of it will be sent to the
same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For
more information about each option see <a href="https://hf.co/docs/accelerate/main/en/usage_guides/big_modeling#designing-a-device-map" rel="nofollow">designing a device
map</a>.`,name:"device_map"},{anchor:"diffusers.ModelMixin.from_pretrained.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code> if torch version &gt;= 1.9.0 else <code>False</code>) &#x2014;
Speed up model loading by not initializing the weights and only loading the pre-trained weights. This
also tries to not use more than 1x model size in CPU memory (including peak memory) while loading the
model. This is only supported when torch version &gt;= 1.9.0. If you are using an older version of torch,
setting this argument to <code>True</code> will raise an error.`,name:"low_cpu_mem_usage"},{anchor:"diffusers.ModelMixin.from_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"},{anchor:"diffusers.ModelMixin.from_pretrained.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em> ) &#x2014;
If set to <code>True</code>, the pipeline will forcibly load the models from <code>safetensors</code> weights. If set to
<code>None</code> (the default). The pipeline will load using <code>safetensors</code> if safetensors weights are available
<em>and</em> if <code>safetensors</code> is installed. If the to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L324"}}),$t=new b$({props:{$$slots:{default:[k$]},$$scope:{ctx:I}}}),wt=new b$({props:{$$slots:{default:[T$]},$$scope:{ctx:I}}}),So=new y({props:{name:"num_parameters",anchor:"diffusers.ModelMixin.num_parameters",parameters:[{name:"only_trainable",val:": bool = False"},{name:"exclude_embeddings",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.ModelMixin.num_parameters.only_trainable",description:`<strong>only_trainable</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return only the number of trainable parameters`,name:"only_trainable"},{anchor:"diffusers.ModelMixin.num_parameters.exclude_embeddings",description:`<strong>exclude_embeddings</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return only the number of non-embeddings parameters`,name:"exclude_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L770",returnDescription:`
<p>The number of parameters.</p>
`,returnType:`
<p><code>int</code></p>
`}}),Ko=new y({props:{name:"save_pretrained",anchor:"diffusers.ModelMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"is_main_process",val:": bool = True"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"},{name:"variant",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.ModelMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.ModelMixin.save_pretrained.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.ModelMixin.save_pretrained.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"},{anchor:"diffusers.ModelMixin.save_pretrained.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to save the model using <code>safetensors</code> or the traditional PyTorch way (that uses <code>pickle</code>).`,name:"safe_serialization"},{anchor:"diffusers.ModelMixin.save_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified, weights are saved in the format pytorch_model.<variant>.bin.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_utils.py#L264"}}),Xo=new T({}),Ro=new y({props:{name:"class diffusers.models.unet_2d.UNet2DOutput",anchor:"diffusers.models.unet_2d.UNet2DOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_2d.UNet2DOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states output. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d.py#L28"}}),Qo=new T({}),Yo=new y({props:{name:"class diffusers.UNet2DModel",anchor:"diffusers.UNet2DModel",parameters:[{name:"sample_size",val:": typing.Union[int, typing.Tuple[int, int], NoneType] = None"},{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"center_input_sample",val:": bool = False"},{name:"time_embedding_type",val:": str = 'positional'"},{name:"freq_shift",val:": int = 0"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D', 'AttnDownBlock2D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('AttnUpBlock2D', 'AttnUpBlock2D', 'AttnUpBlock2D', 'UpBlock2D')"},{name:"block_out_channels",val:": typing.Tuple[int] = (224, 448, 672, 896)"},{name:"layers_per_block",val:": int = 2"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"downsample_padding",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"attention_head_dim",val:": typing.Optional[int] = 8"},{name:"norm_num_groups",val:": int = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"add_attention",val:": bool = True"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample. Dimensions must be a multiple of <code>2 ** (len(block_out_channels) - 1)</code>.`,name:"sample_size"},{anchor:"diffusers.UNet2DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.UNet2DModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet2DModel.center_input_sample",description:"<strong>center_input_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to center the input sample.",name:"center_input_sample"},{anchor:"diffusers.UNet2DModel.time_embedding_type",description:"<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;positional&quot;</code>) &#x2014; Type of time embedding to use.",name:"time_embedding_type"},{anchor:"diffusers.UNet2DModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; Frequency shift for fourier time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet2DModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>True</code>): Whether to flip sin to cos for fourier time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet2DModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;, &quot;AttnDownBlock2D&quot;)</code>): Tuple of downsample block
types.`,name:"down_block_types"},{anchor:"diffusers.UNet2DModel.mid_block_type",description:`<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;UNetMidBlock2D&quot;</code>) &#x2014;
The mid block type. Choose from <code>UNetMidBlock2D</code> or <code>UnCLIPUNetMidBlock2D</code>.`,name:"mid_block_type"},{anchor:"diffusers.UNet2DModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;AttnUpBlock2D&quot;, &quot;UpBlock2D&quot;)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.UNet2DModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(224, 448, 672, 896)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.UNet2DModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <code>2</code>) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet2DModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The scale factor for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet2DModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014; The padding for the downsample convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet2DModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to <code>8</code>) &#x2014; The attention head dimension.",name:"attention_head_dim"},{anchor:"diffusers.UNet2DModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; The number of groups for the normalization.",name:"norm_num_groups"},{anchor:"diffusers.UNet2DModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet2DModel.resnet_time_scale_shift",description:`<strong>resnet_time_scale_shift</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;default&quot;</code>) &#x2014; Time scale shift config
for resnet blocks, see <code>ResnetBlock2D</code>. Choose from <code>default</code> or <code>scale_shift</code>.`,name:"resnet_time_scale_shift"},{anchor:"diffusers.UNet2DModel.class_embed_type",description:`<strong>class_embed_type</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014;
The type of class embedding to use which is ultimately summed with the time embeddings. Choose from <code>None</code>,
<code>&quot;timestep&quot;</code>, or <code>&quot;identity&quot;</code>.`,name:"class_embed_type"},{anchor:"diffusers.UNet2DModel.num_class_embeds",description:`<strong>num_class_embeds</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Input dimension of the learnable embedding matrix to be projected to <code>time_embed_dim</code>, when performing
class conditioning with <code>class_embed_type</code> equal to <code>None</code>.`,name:"num_class_embeds"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d.py#L38"}}),Jo=new y({props:{name:"forward",anchor:"diffusers.UNet2DModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet2DModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet2DModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or `int) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet2DModel.forward.class_labels",description:`<strong>class_labels</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Optional class labels for conditioning. Their embeddings will be summed with the timestep embeddings.`,name:"class_labels"},{anchor:"diffusers.UNet2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d.UNet2DOutput">UNet2DOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d.py#L219",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> if <code>return_dict</code> is True,
otherwise a <code>tuple</code>. When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d.UNet2DOutput"
>UNet2DOutput</a> or <code>tuple</code></p>
`}}),Zo=new T({}),tn=new y({props:{name:"class diffusers.models.unet_1d.UNet1DOutput",anchor:"diffusers.models.unet_1d.UNet1DOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_1d.UNet1DOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, sample_size)</code>) &#x2014;
Hidden states output. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_1d.py#L29"}}),on=new T({}),nn=new y({props:{name:"class diffusers.UNet1DModel",anchor:"diffusers.UNet1DModel",parameters:[{name:"sample_size",val:": int = 65536"},{name:"sample_rate",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 2"},{name:"out_channels",val:": int = 2"},{name:"extra_in_channels",val:": int = 0"},{name:"time_embedding_type",val:": str = 'fourier'"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"use_timestep_embedding",val:": bool = False"},{name:"freq_shift",val:": float = 0.0"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownBlock1DNoSkip', 'DownBlock1D', 'AttnDownBlock1D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('AttnUpBlock1D', 'UpBlock1D', 'UpBlock1DNoSkip')"},{name:"mid_block_type",val:": typing.Tuple[str] = 'UNetMidBlock1D'"},{name:"out_block_type",val:": str = None"},{name:"block_out_channels",val:": typing.Tuple[int] = (32, 32, 64)"},{name:"act_fn",val:": str = None"},{name:"norm_num_groups",val:": int = 8"},{name:"layers_per_block",val:": int = 1"},{name:"downsample_each_block",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.UNet1DModel.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Default length of sample. Should be adaptable at runtime.",name:"sample_size"},{anchor:"diffusers.UNet1DModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; Number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet1DModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet1DModel.extra_in_channels",description:`<strong>extra_in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
Number of additional channels to be added to the input of the first down block. Useful for cases where the
input data has more channels than what the model is initially designed for.`,name:"extra_in_channels"},{anchor:"diffusers.UNet1DModel.time_embedding_type",description:"<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;fourier&quot;</code>) &#x2014; Type of time embedding to use.",name:"time_embedding_type"},{anchor:"diffusers.UNet1DModel.freq_shift",description:"<strong>freq_shift</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; Frequency shift for fourier time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet1DModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>False</code>): Whether to flip sin to cos for fourier time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet1DModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownBlock1D&quot;, &quot;DownBlock1DNoSkip&quot;, &quot;AttnDownBlock1D&quot;)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.UNet1DModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpBlock1D&quot;, &quot;UpBlock1DNoSkip&quot;, &quot;AttnUpBlock1D&quot;)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.UNet1DModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(32, 32, 64)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.UNet1DModel.mid_block_type",description:"<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;UNetMidBlock1D&#x201D;) &#x2014; block type for middle of UNet.",name:"mid_block_type"},{anchor:"diffusers.UNet1DModel.out_block_type",description:"<strong>out_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; optional output processing of UNet.",name:"out_block_type"},{anchor:"diffusers.UNet1DModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014; optional activation function in UNet blocks.",name:"act_fn"},{anchor:"diffusers.UNet1DModel.norm_num_groups",description:"<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; group norm member count in UNet blocks.",name:"norm_num_groups"},{anchor:"diffusers.UNet1DModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; added number of layers in a UNet block.",name:"layers_per_block"},{anchor:"diffusers.UNet1DModel.downsample_each_block",description:`<strong>downsample_each_block</strong> (<code>int</code>, <em>optional</em>, defaults to False &#x2014;
experimental feature for using a UNet without upsampling.`,name:"downsample_each_block"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_1d.py#L39"}}),rn=new y({props:{name:"forward",anchor:"diffusers.UNet1DModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet1DModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; <code>(batch_size, num_channels, sample_size)</code> noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet1DModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or `int) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet1DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_1d.UNet1DOutput">UNet1DOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_1d.py#L193",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_1d.UNet1DOutput"
>UNet1DOutput</a> if <code>return_dict</code> is True,
otherwise a <code>tuple</code>. When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_1d.UNet1DOutput"
>UNet1DOutput</a> or <code>tuple</code></p>
`}}),an=new T({}),ln=new y({props:{name:"class diffusers.models.unet_2d_condition.UNet2DConditionOutput",anchor:"diffusers.models.unet_2d_condition.UNet2DConditionOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_2d_condition.UNet2DConditionOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L44"}}),cn=new T({}),mn=new y({props:{name:"class diffusers.UNet2DConditionModel",anchor:"diffusers.UNet2DConditionModel",parameters:[{name:"sample_size",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"center_input_sample",val:": bool = False"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"mid_block_type",val:": typing.Optional[str] = 'UNetMidBlock2DCrossAttn'"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": typing.Union[int, typing.Tuple[int]] = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": typing.Union[int, typing.Tuple[int]] = 1280"},{name:"encoder_hid_dim",val:": typing.Optional[int] = None"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"dual_cross_attention",val:": bool = False"},{name:"use_linear_projection",val:": bool = False"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"},{name:"upcast_attention",val:": bool = False"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"resnet_skip_time_act",val:": bool = False"},{name:"resnet_out_scale_factor",val:": int = 1.0"},{name:"time_embedding_type",val:": str = 'positional'"},{name:"time_embedding_act_fn",val:": typing.Optional[str] = None"},{name:"timestep_post_act",val:": typing.Optional[str] = None"},{name:"time_cond_proj_dim",val:": typing.Optional[int] = None"},{name:"conv_in_kernel",val:": int = 3"},{name:"conv_out_kernel",val:": int = 3"},{name:"projection_class_embeddings_input_dim",val:": typing.Optional[int] = None"},{name:"class_embeddings_concat",val:": bool = False"},{name:"mid_block_only_cross_attention",val:": typing.Optional[bool] = None"},{name:"cross_attention_norm",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample.`,name:"sample_size"},{anchor:"diffusers.UNet2DConditionModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet2DConditionModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet2DConditionModel.center_input_sample",description:"<strong>center_input_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to center the input sample.",name:"center_input_sample"},{anchor:"diffusers.UNet2DConditionModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.UNet2DConditionModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"},{anchor:"diffusers.UNet2DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use.`,name:"down_block_types"},{anchor:"diffusers.UNet2DConditionModel.mid_block_type",description:`<strong>mid_block_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;UNetMidBlock2DCrossAttn&quot;</code>) &#x2014;
The mid block type. Choose from <code>UNetMidBlock2DCrossAttn</code> or <code>UNetMidBlock2DSimpleCrossAttn</code>, will skip the
mid block layer if <code>None</code>.`,name:"mid_block_type"},{anchor:"diffusers.UNet2DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use.`,name:"up_block_types"},{anchor:"diffusers.UNet2DConditionModel.only_cross_attention(bool",description:`<strong>only_cross_attention(<code>bool</code></strong> or <code>Tuple[bool]</code>, <em>optional</em>, default to <code>False</code>) &#x2014;
Whether to include self-attention in the basic transformer blocks, see
<code>BasicTransformerBlock</code>.`,name:"only_cross_attention(bool"},{anchor:"diffusers.UNet2DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.UNet2DConditionModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet2DConditionModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The padding to use for the downsampling convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet2DConditionModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014; The scale factor to use for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet2DConditionModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet2DConditionModel.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of groups to use for the normalization.
If <code>None</code>, it will skip the normalization and activation layers in post-processing`,name:"norm_num_groups"},{anchor:"diffusers.UNet2DConditionModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014; The epsilon to use for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet2DConditionModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 1280) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.UNet2DConditionModel.encoder_hid_dim",description:`<strong>encoder_hid_dim</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
If given, <code>encoder_hidden_states</code> will be projected from this dimension to <code>cross_attention_dim</code>.`,name:"encoder_hid_dim"},{anchor:"diffusers.UNet2DConditionModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; The dimension of the attention heads.",name:"attention_head_dim"},{anchor:"diffusers.UNet2DConditionModel.resnet_time_scale_shift",description:`<strong>resnet_time_scale_shift</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;default&quot;</code>) &#x2014; Time scale shift config
for resnet blocks, see <code>ResnetBlock2D</code>. Choose from <code>default</code> or <code>scale_shift</code>.`,name:"resnet_time_scale_shift"},{anchor:"diffusers.UNet2DConditionModel.class_embed_type",description:`<strong>class_embed_type</strong> (<code>str</code>, <em>optional</em>, defaults to None) &#x2014;
The type of class embedding to use which is ultimately summed with the time embeddings. Choose from <code>None</code>,
<code>&quot;timestep&quot;</code>, <code>&quot;identity&quot;</code>, <code>&quot;projection&quot;</code>, or <code>&quot;simple_projection&quot;</code>.`,name:"class_embed_type"},{anchor:"diffusers.UNet2DConditionModel.num_class_embeds",description:`<strong>num_class_embeds</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Input dimension of the learnable embedding matrix to be projected to <code>time_embed_dim</code>, when performing
class conditioning with <code>class_embed_type</code> equal to <code>None</code>.`,name:"num_class_embeds"},{anchor:"diffusers.UNet2DConditionModel.time_embedding_type",description:`<strong>time_embedding_type</strong> (<code>str</code>, <em>optional</em>, default to <code>positional</code>) &#x2014;
The type of position embedding to use for timesteps. Choose from <code>positional</code> or <code>fourier</code>.`,name:"time_embedding_type"},{anchor:"diffusers.UNet2DConditionModel.time_embedding_act_fn",description:`<strong>time_embedding_act_fn</strong> (<code>str</code>, <em>optional</em>, default to <code>None</code>) &#x2014;
Optional activation function to use on the time embeddings only one time before they as passed to the rest
of the unet. Choose from <code>silu</code>, <code>mish</code>, <code>gelu</code>, and <code>swish</code>.`,name:"time_embedding_act_fn"},{anchor:"diffusers.UNet2DConditionModel.timestep_post_act",description:"<strong>timestep_post_act</strong> (<code>str, *optional*, default to </code>None<code>) -- The second activation function to use in timestep embedding. Choose from </code>silu<code>, </code>mish<code>and</code>gelu`.",name:"timestep_post_act"},{anchor:"diffusers.UNet2DConditionModel.time_cond_proj_dim",description:`<strong>time_cond_proj_dim</strong> (<code>int</code>, <em>optional</em>, default to <code>None</code>) &#x2014;
The dimension of <code>cond_proj</code> layer in timestep embedding.`,name:"time_cond_proj_dim"},{anchor:"diffusers.UNet2DConditionModel.conv_in_kernel",description:"<strong>conv_in_kernel</strong> (<code>int</code>, <em>optional</em>, default to <code>3</code>) &#x2014; The kernel size of <code>conv_in</code> layer.",name:"conv_in_kernel"},{anchor:"diffusers.UNet2DConditionModel.conv_out_kernel",description:"<strong>conv_out_kernel</strong> (<code>int</code>, <em>optional</em>, default to <code>3</code>) &#x2014; The kernel size of <code>conv_out</code> layer.",name:"conv_out_kernel"},{anchor:"diffusers.UNet2DConditionModel.projection_class_embeddings_input_dim",description:`<strong>projection_class_embeddings_input_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The dimension of the <code>class_labels</code> input when
using the &#x201C;projection&#x201D; <code>class_embed_type</code>. Required when using the &#x201C;projection&#x201D; <code>class_embed_type</code>.`,name:"projection_class_embeddings_input_dim"},{anchor:"diffusers.UNet2DConditionModel.class_embeddings_concat",description:`<strong>class_embeddings_concat</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Whether to concatenate the time
embeddings with the class embeddings.`,name:"class_embeddings_concat"},{anchor:"diffusers.UNet2DConditionModel.mid_block_only_cross_attention",description:`<strong>mid_block_only_cross_attention</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Whether to use cross attention with the mid block when using the <code>UNetMidBlock2DSimpleCrossAttn</code>. If
<code>only_cross_attention</code> is given as a single boolean and <code>mid_block_only_cross_attention</code> is None, the
<code>only_cross_attention</code> value will be used as the value for <code>mid_block_only_cross_attention</code>. Else, it will
default to <code>False</code>.`,name:"mid_block_only_cross_attention"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L54"}}),fn=new y({props:{name:"forward",anchor:"diffusers.UNet2DConditionModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"encoder_hidden_states",val:": Tensor"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"timestep_cond",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"down_block_additional_residuals",val:": typing.Optional[typing.Tuple[torch.Tensor]] = None"},{name:"mid_block_additional_residual",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet2DConditionModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or <code>int</code>) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet2DConditionModel.forward.encoder_hidden_states",description:"<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, sequence_length, feature_dim) encoder hidden states",name:"encoder_hidden_states"},{anchor:"diffusers.UNet2DConditionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.UNet2DConditionModel.forward.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L590",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput"
>UNet2DConditionOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput"
>UNet2DConditionOutput</a> or <code>tuple</code></p>
`}}),un=new y({props:{name:"set_attention_slice",anchor:"diffusers.UNet2DConditionModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L521"}}),hn=new y({props:{name:"set_attn_processor",anchor:"diffusers.UNet2DConditionModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.UNet2DConditionModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.UNet2DConditionModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L485"}}),_n=new y({props:{name:"set_default_attn_processor",anchor:"diffusers.UNet2DConditionModel.set_default_attn_processor",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition.py#L515"}}),gn=new T({}),vn=new y({props:{name:"class diffusers.models.unet_3d_condition.UNet3DConditionOutput",anchor:"diffusers.models.unet_3d_condition.UNet3DConditionOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.unet_3d_condition.UNet3DConditionOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L44"}}),yn=new T({}),xn=new y({props:{name:"class diffusers.UNet3DConditionModel",anchor:"diffusers.UNet3DConditionModel",parameters:[{name:"sample_size",val:": typing.Optional[int] = None"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock3D', 'CrossAttnDownBlock3D', 'CrossAttnDownBlock3D', 'DownBlock3D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock3D', 'CrossAttnUpBlock3D', 'CrossAttnUpBlock3D', 'CrossAttnUpBlock3D')"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": int = 1024"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 64"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code> or <code>Tuple[int, int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Height and width of input/output sample.`,name:"sample_size"},{anchor:"diffusers.UNet3DConditionModel.in_channels",description:"<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the input sample.",name:"in_channels"},{anchor:"diffusers.UNet3DConditionModel.out_channels",description:"<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of channels in the output.",name:"out_channels"},{anchor:"diffusers.UNet3DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use.`,name:"down_block_types"},{anchor:"diffusers.UNet3DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use.`,name:"up_block_types"},{anchor:"diffusers.UNet3DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.UNet3DConditionModel.layers_per_block",description:"<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014; The number of layers per block.",name:"layers_per_block"},{anchor:"diffusers.UNet3DConditionModel.downsample_padding",description:"<strong>downsample_padding</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The padding to use for the downsampling convolution.",name:"downsample_padding"},{anchor:"diffusers.UNet3DConditionModel.mid_block_scale_factor",description:"<strong>mid_block_scale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014; The scale factor to use for the mid block.",name:"mid_block_scale_factor"},{anchor:"diffusers.UNet3DConditionModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.UNet3DConditionModel.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of groups to use for the normalization.
If <code>None</code>, it will skip the normalization and activation layers in post-processing`,name:"norm_num_groups"},{anchor:"diffusers.UNet3DConditionModel.norm_eps",description:"<strong>norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014; The epsilon to use for the normalization.",name:"norm_eps"},{anchor:"diffusers.UNet3DConditionModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 1280) &#x2014; The dimension of the cross attention features.",name:"cross_attention_dim"},{anchor:"diffusers.UNet3DConditionModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014; The dimension of the attention heads.",name:"attention_head_dim"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L54"}}),wn=new y({props:{name:"forward",anchor:"diffusers.UNet3DConditionModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"encoder_hidden_states",val:": Tensor"},{name:"class_labels",val:": typing.Optional[torch.Tensor] = None"},{name:"timestep_cond",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"down_block_additional_residuals",val:": typing.Optional[typing.Tuple[torch.Tensor]] = None"},{name:"mid_block_additional_residual",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, num_frames, channel, height, width) noisy inputs tensor",name:"sample"},{anchor:"diffusers.UNet3DConditionModel.forward.timestep",description:"<strong>timestep</strong> (<code>torch.FloatTensor</code> or <code>float</code> or <code>int</code>) &#x2014; (batch) timesteps",name:"timestep"},{anchor:"diffusers.UNet3DConditionModel.forward.encoder_hidden_states",description:"<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code>) &#x2014; (batch, sequence_length, feature_dim) encoder hidden states",name:"encoder_hidden_states"},{anchor:"diffusers.UNet3DConditionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>models.unet_2d_condition.UNet3DConditionOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"diffusers.UNet3DConditionModel.forward.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L387",returnDescription:`
<p><code>~models.unet_2d_condition.UNet3DConditionOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><code>~models.unet_2d_condition.UNet3DConditionOutput</code> or <code>tuple</code></p>
`}}),Dn=new y({props:{name:"set_attention_slice",anchor:"diffusers.UNet3DConditionModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L280"}}),kn=new y({props:{name:"set_attn_processor",anchor:"diffusers.UNet3DConditionModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.UNet3DConditionModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.UNet3DConditionModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L346"}}),Tn=new y({props:{name:"set_default_attn_processor",anchor:"diffusers.UNet3DConditionModel.set_default_attn_processor",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_3d_condition.py#L377"}}),Mn=new T({}),Nn=new y({props:{name:"class diffusers.models.vae.DecoderOutput",anchor:"diffusers.models.vae.DecoderOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.vae.DecoderOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Decoded output sample of the model. Output of the last layer of the model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vae.py#L26"}}),An=new T({}),En=new y({props:{name:"class diffusers.models.vq_model.VQEncoderOutput",anchor:"diffusers.models.vq_model.VQEncoderOutput",parameters:[{name:"latents",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.vq_model.VQEncoderOutput.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Encoded output sample of the model. Output of the last layer of the model.`,name:"latents"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vq_model.py#L27"}}),Un=new T({}),Cn=new y({props:{name:"class diffusers.VQModel",anchor:"diffusers.VQModel",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 3"},{name:"sample_size",val:": int = 32"},{name:"num_vq_embeddings",val:": int = 256"},{name:"norm_num_groups",val:": int = 32"},{name:"vq_embed_dim",val:": typing.Optional[int] = None"},{name:"scaling_factor",val:": float = 0.18215"}],parametersDescription:[{anchor:"diffusers.VQModel.in_channels",description:"<strong>in_channels</strong> (int, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.VQModel.out_channels",description:"<strong>out_channels</strong> (int,  <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.VQModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownEncoderBlock2D&quot;,)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.VQModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpDecoderBlock2D&quot;,)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.VQModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(64,)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.VQModel.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.VQModel.latent_channels",description:"<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to <code>3</code>) &#x2014; Number of channels in the latent space.",name:"latent_channels"},{anchor:"diffusers.VQModel.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; TODO",name:"sample_size"},{anchor:"diffusers.VQModel.num_vq_embeddings",description:"<strong>num_vq_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to <code>256</code>) &#x2014; Number of codebook vectors in the VQ-VAE.",name:"num_vq_embeddings"},{anchor:"diffusers.VQModel.vq_embed_dim",description:"<strong>vq_embed_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; Hidden dim of codebook vectors in the VQ-VAE.",name:"vq_embed_dim"},{anchor:"diffusers.VQModel.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.18215</code>) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vq_model.py#L39"}}),Pn=new y({props:{name:"forward",anchor:"diffusers.VQModel.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.VQModel.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.VQModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vq_model.py#L142"}}),On=new T({}),Ln=new y({props:{name:"class diffusers.models.autoencoder_kl.AutoencoderKLOutput",anchor:"diffusers.models.autoencoder_kl.AutoencoderKLOutput",parameters:[{name:"latent_dist",val:": DiagonalGaussianDistribution"}],parametersDescription:[{anchor:"diffusers.models.autoencoder_kl.AutoencoderKLOutput.latent_dist",description:`<strong>latent_dist</strong> (<code>DiagonalGaussianDistribution</code>) &#x2014;
Encoded outputs of <code>Encoder</code> represented as the mean and logvar of <code>DiagonalGaussianDistribution</code>.
<code>DiagonalGaussianDistribution</code> allows for sampling latents from the distribution.`,name:"latent_dist"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L27"}}),qn=new T({}),jn=new y({props:{name:"class diffusers.AutoencoderKL",anchor:"diffusers.AutoencoderKL",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 4"},{name:"norm_num_groups",val:": int = 32"},{name:"sample_size",val:": int = 32"},{name:"scaling_factor",val:": float = 0.18215"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.in_channels",description:"<strong>in_channels</strong> (int, <em>optional</em>, defaults to 3) &#x2014; Number of channels in the input image.",name:"in_channels"},{anchor:"diffusers.AutoencoderKL.out_channels",description:"<strong>out_channels</strong> (int,  <em>optional</em>, defaults to 3) &#x2014; Number of channels in the output.",name:"out_channels"},{anchor:"diffusers.AutoencoderKL.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;DownEncoderBlock2D&quot;,)</code>): Tuple of downsample block types.`,name:"down_block_types"},{anchor:"diffusers.AutoencoderKL.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(&quot;UpDecoderBlock2D&quot;,)</code>): Tuple of upsample block types.`,name:"up_block_types"},{anchor:"diffusers.AutoencoderKL.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to  &#x2014;
obj:<code>(64,)</code>): Tuple of block output channels.`,name:"block_out_channels"},{anchor:"diffusers.AutoencoderKL.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.AutoencoderKL.latent_channels",description:"<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; Number of channels in the latent space.",name:"latent_channels"},{anchor:"diffusers.AutoencoderKL.sample_size",description:"<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>32</code>) &#x2014; TODO",name:"sample_size"},{anchor:"diffusers.AutoencoderKL.scaling_factor",description:`<strong>scaling_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 0.18215) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <code>z = z * scaling_factor</code> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: <code>z = 1 / scaling_factor * z</code>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L40"}}),zn=new y({props:{name:"disable_slicing",anchor:"diffusers.AutoencoderKL.disable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L152"}}),Bn=new y({props:{name:"disable_tiling",anchor:"diffusers.AutoencoderKL.disable_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L138"}}),Kn=new y({props:{name:"enable_slicing",anchor:"diffusers.AutoencoderKL.enable_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L145"}}),Wn=new y({props:{name:"enable_tiling",anchor:"diffusers.AutoencoderKL.enable_tiling",parameters:[{name:"use_tiling",val:": bool = True"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L130"}}),Xn=new y({props:{name:"forward",anchor:"diffusers.AutoencoderKL.forward",parameters:[{name:"sample",val:": FloatTensor"},{name:"sample_posterior",val:": bool = False"},{name:"return_dict",val:": bool = True"},{name:"generator",val:": typing.Optional[torch._C.Generator] = None"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.forward.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; Input sample.",name:"sample"},{anchor:"diffusers.AutoencoderKL.forward.sample_posterior",description:`<strong>sample_posterior</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to sample from the posterior.`,name:"sample_posterior"},{anchor:"diffusers.AutoencoderKL.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L302"}}),Hn=new y({props:{name:"tiled_decode",anchor:"diffusers.AutoencoderKL.tiled_decode",parameters:[{name:"z",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.tiled_decode.When",description:"<strong>When</strong> this option is enabled, the VAE will split the input tensor into tiles to compute decoding in several &#x2014;",name:"When"},{anchor:"diffusers.AutoencoderKL.tiled_decode.steps.",description:"<strong>steps.</strong> This is useful to keep memory use constant regardless of image size. The end result of tiled decoding is &#x2014;",name:"steps."},{anchor:"diffusers.AutoencoderKL.tiled_decode.different",description:"<strong>different</strong> from non-tiled decoding due to each tile using a different decoder. To avoid tiling artifacts, the &#x2014;",name:"different"},{anchor:"diffusers.AutoencoderKL.tiled_decode.tiles",description:"<strong>tiles</strong> overlap and are blended together to form a smooth output. You may still see tile-sized changes in the &#x2014;",name:"tiles"},{anchor:"diffusers.AutoencoderKL.tiled_decode.look",description:`<strong>look</strong> of the output, but they should be much less noticeable. &#x2014;
z (<code>torch.FloatTensor</code>): Input batch of latent vectors. return_dict (<code>bool</code>, <em>optional</em>, defaults to
<code>True</code>):
Whether or not to return a <code>DecoderOutput</code> instead of a plain tuple.`,name:"look"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L255"}}),Rn=new y({props:{name:"tiled_encode",anchor:"diffusers.AutoencoderKL.tiled_encode",parameters:[{name:"x",val:": FloatTensor"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.AutoencoderKL.tiled_encode.When",description:"<strong>When</strong> this option is enabled, the VAE will split the input tensor into tiles to compute encoding in several &#x2014;",name:"When"},{anchor:"diffusers.AutoencoderKL.tiled_encode.steps.",description:"<strong>steps.</strong> This is useful to keep memory use constant regardless of image size. The end result of tiled encoding is &#x2014;",name:"steps."},{anchor:"diffusers.AutoencoderKL.tiled_encode.different",description:"<strong>different</strong> from non-tiled encoding due to each tile using a different encoder. To avoid tiling artifacts, the &#x2014;",name:"different"},{anchor:"diffusers.AutoencoderKL.tiled_encode.tiles",description:"<strong>tiles</strong> overlap and are blended together to form a smooth output. You may still see tile-sized changes in the &#x2014;",name:"tiles"},{anchor:"diffusers.AutoencoderKL.tiled_encode.look",description:`<strong>look</strong> of the output, but they should be much less noticeable. &#x2014;
x (<code>torch.FloatTensor</code>): Input batch of images. return_dict (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>):
Whether or not to return a <code>AutoencoderKLOutput</code> instead of a plain tuple.`,name:"look"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/autoencoder_kl.py#L208"}}),Qn=new T({}),Yn=new y({props:{name:"class diffusers.Transformer2DModel",anchor:"diffusers.Transformer2DModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": typing.Optional[int] = None"},{name:"out_channels",val:": typing.Optional[int] = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": typing.Optional[int] = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": typing.Optional[int] = None"},{name:"num_vector_embeds",val:": typing.Optional[int] = None"},{name:"patch_size",val:": typing.Optional[int] = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"num_embeds_ada_norm",val:": typing.Optional[int] = None"},{name:"use_linear_projection",val:": bool = False"},{name:"only_cross_attention",val:": bool = False"},{name:"upcast_attention",val:": bool = False"},{name:"norm_type",val:": str = 'layer_norm'"},{name:"norm_elementwise_affine",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.Transformer2DModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.Transformer2DModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.Transformer2DModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is continuous. The number of channels in the input and output.`,name:"in_channels"},{anchor:"diffusers.Transformer2DModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.Transformer2DModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.Transformer2DModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of encoder_hidden_states dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.Transformer2DModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Pass if the input is discrete. The width of the latent images.
Note that this is fixed at training time as it is used for learning a number of position embeddings. See
<code>ImagePositionalEmbeddings</code>.`,name:"sample_size"},{anchor:"diffusers.Transformer2DModel.num_vector_embeds",description:`<strong>num_vector_embeds</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is discrete. The number of classes of the vector embeddings of the latent pixels.
Includes the class for the masked latent pixel.`,name:"num_vector_embeds"},{anchor:"diffusers.Transformer2DModel.activation_fn",description:"<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014; Activation function to be used in feed-forward.",name:"activation_fn"},{anchor:"diffusers.Transformer2DModel.num_embeds_ada_norm",description:`<strong>num_embeds_ada_norm</strong> ( <code>int</code>, <em>optional</em>) &#x2014; Pass if at least one of the norm_layers is <code>AdaLayerNorm</code>.
The number of diffusion steps used during training. Note that this is fixed at training time as it is used
to learn a number of embeddings that are added to the hidden states. During inference, you can denoise for
up to but not more than steps than <code>num_embeds_ada_norm</code>.`,name:"num_embeds_ada_norm"},{anchor:"diffusers.Transformer2DModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the TransformerBlocks&#x2019; attention should contain a bias parameter.`,name:"attention_bias"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_2d.py#L41"}}),Jn=new y({props:{name:"forward",anchor:"diffusers.Transformer2DModel.forward",parameters:[{name:"hidden_states",val:""},{name:"encoder_hidden_states",val:" = None"},{name:"timestep",val:" = None"},{name:"class_labels",val:" = None"},{name:"cross_attention_kwargs",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.Transformer2DModel.forward.hidden_states",description:`<strong>hidden_states</strong> ( When discrete, <code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code>. &#x2014;
When continuous, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code>): Input
hidden_states`,name:"hidden_states"},{anchor:"diffusers.Transformer2DModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.Transformer2DModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.long</code>, <em>optional</em>) &#x2014;
Optional timestep to be applied as an embedding in AdaLayerNorm&#x2019;s. Used to indicate denoising step.`,name:"timestep"},{anchor:"diffusers.Transformer2DModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Optional class labels to be applied as an embedding in AdaLayerZeroNorm. Used to indicate class labels
conditioning.`,name:"class_labels"},{anchor:"diffusers.Transformer2DModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_2d.py#L214",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.transformer_2d.Transformer2DModelOutput"
>Transformer2DModelOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.transformer_2d.Transformer2DModelOutput"
>Transformer2DModelOutput</a> or <code>tuple</code></p>
`}}),Zn=new T({}),ts=new y({props:{name:"class diffusers.models.transformer_2d.Transformer2DModelOutput",anchor:"diffusers.models.transformer_2d.Transformer2DModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_2d.Transformer2DModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code> or <code>(batch size, num_vector_embeds - 1, num_latent_pixels)</code> if <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.Transformer2DModel">Transformer2DModel</a> is discrete) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. If discrete, returns probability distributions
for the unnoised latent pixels.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_2d.py#L30"}}),os=new T({}),ns=new y({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModel",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel",parameters:[{name:"num_attention_heads",val:": int = 16"},{name:"attention_head_dim",val:": int = 88"},{name:"in_channels",val:": typing.Optional[int] = None"},{name:"out_channels",val:": typing.Optional[int] = None"},{name:"num_layers",val:": int = 1"},{name:"dropout",val:": float = 0.0"},{name:"norm_num_groups",val:": int = 32"},{name:"cross_attention_dim",val:": typing.Optional[int] = None"},{name:"attention_bias",val:": bool = False"},{name:"sample_size",val:": typing.Optional[int] = None"},{name:"activation_fn",val:": str = 'geglu'"},{name:"norm_elementwise_affine",val:": bool = True"},{name:"double_self_attention",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 88) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Pass if the input is continuous. The number of channels in the input and output.`,name:"in_channels"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.cross_attention_dim",description:"<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>) &#x2014; The number of encoder_hidden_states dimensions to use.",name:"cross_attention_dim"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014; Pass if the input is discrete. The width of the latent images.
Note that this is fixed at training time as it is used for learning a number of position embeddings. See
<code>ImagePositionalEmbeddings</code>.`,name:"sample_size"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.activation_fn",description:"<strong>activation_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;geglu&quot;</code>) &#x2014; Activation function to be used in feed-forward.",name:"activation_fn"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.attention_bias",description:`<strong>attention_bias</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if the TransformerBlocks&#x2019; attention should contain a bias parameter.`,name:"attention_bias"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.double_self_attention",description:`<strong>double_self_attention</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Configure if each TransformerBlock should contain two self-attention layers`,name:"double_self_attention"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_temporal.py#L37"}}),ss=new y({props:{name:"forward",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward",parameters:[{name:"hidden_states",val:""},{name:"encoder_hidden_states",val:" = None"},{name:"timestep",val:" = None"},{name:"class_labels",val:" = None"},{name:"num_frames",val:" = 1"},{name:"cross_attention_kwargs",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.hidden_states",description:`<strong>hidden_states</strong> ( When discrete, <code>torch.LongTensor</code> of shape <code>(batch size, num latent pixels)</code>. &#x2014;
When continous, <code>torch.FloatTensor</code> of shape <code>(batch size, channel, height, width)</code>): Input
hidden_states`,name:"hidden_states"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, encoder_hidden_states dim)</code>, <em>optional</em>) &#x2014;
Conditional embeddings for cross attention layer. If not given, cross-attention defaults to
self-attention.`,name:"encoder_hidden_states"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.timestep",description:`<strong>timestep</strong> ( <code>torch.long</code>, <em>optional</em>) &#x2014;
Optional timestep to be applied as an embedding in AdaLayerNorm&#x2019;s. Used to indicate denoising step.`,name:"timestep"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.class_labels",description:`<strong>class_labels</strong> ( <code>torch.LongTensor</code> of shape <code>(batch size, num classes)</code>, <em>optional</em>) &#x2014;
Optional class labels to be applied as an embedding in AdaLayerZeroNorm. Used to indicate class labels
conditioning.`,name:"class_labels"},{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.unet_2d_condition.UNet2DConditionOutput">models.unet_2d_condition.UNet2DConditionOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_temporal.py#L106",returnDescription:`
<p><code>~models.transformer_2d.TransformerTemporalModelOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple</code>.
When returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><code>~models.transformer_2d.TransformerTemporalModelOutput</code> or <code>tuple</code></p>
`}}),rs=new T({}),is=new y({props:{name:"class diffusers.models.transformer_temporal.TransformerTemporalModelOutput",anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",parameters:[{name:"sample",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size x num_frames, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/transformer_temporal.py#L27"}}),ds=new T({}),ls=new y({props:{name:"class diffusers.PriorTransformer",anchor:"diffusers.PriorTransformer",parameters:[{name:"num_attention_heads",val:": int = 32"},{name:"attention_head_dim",val:": int = 64"},{name:"num_layers",val:": int = 20"},{name:"embedding_dim",val:": int = 768"},{name:"num_embeddings",val:" = 77"},{name:"additional_embeddings",val:" = 4"},{name:"dropout",val:": float = 0.0"}],parametersDescription:[{anchor:"diffusers.PriorTransformer.num_attention_heads",description:"<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014; The number of heads to use for multi-head attention.",name:"num_attention_heads"},{anchor:"diffusers.PriorTransformer.attention_head_dim",description:"<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014; The number of channels in each head.",name:"attention_head_dim"},{anchor:"diffusers.PriorTransformer.num_layers",description:"<strong>num_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 20) &#x2014; The number of layers of Transformer blocks to use.",name:"num_layers"},{anchor:"diffusers.PriorTransformer.embedding_dim",description:`<strong>embedding_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014; The dimension of the CLIP embeddings. Note that CLIP
image embeddings and text embeddings are both the same dimension.`,name:"embedding_dim"},{anchor:"diffusers.PriorTransformer.num_embeddings",description:`<strong>num_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 77) &#x2014; The max number of clip embeddings allowed. I.e. the
length of the prompt after it has been tokenized.`,name:"num_embeddings"},{anchor:"diffusers.PriorTransformer.additional_embeddings",description:`<strong>additional_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014; The number of additional tokens appended to the
projected hidden_states. The actual length of the used hidden_states is <code>num_embeddings + additional_embeddings</code>.`,name:"additional_embeddings"},{anchor:"diffusers.PriorTransformer.dropout",description:"<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014; The dropout probability to use.",name:"dropout"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/prior_transformer.py#L26"}}),ps=new y({props:{name:"forward",anchor:"diffusers.PriorTransformer.forward",parameters:[{name:"hidden_states",val:""},{name:"timestep",val:": typing.Union[torch.Tensor, float, int]"},{name:"proj_embedding",val:": FloatTensor"},{name:"encoder_hidden_states",val:": FloatTensor"},{name:"attention_mask",val:": typing.Optional[torch.BoolTensor] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.PriorTransformer.forward.hidden_states",description:`<strong>hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
x_t, the currently predicted image embeddings.`,name:"hidden_states"},{anchor:"diffusers.PriorTransformer.forward.timestep",description:`<strong>timestep</strong> (<code>torch.long</code>) &#x2014;
Current denoising step.`,name:"timestep"},{anchor:"diffusers.PriorTransformer.forward.proj_embedding",description:`<strong>proj_embedding</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
Projected embedding vector the denoising process is conditioned on.`,name:"proj_embedding"},{anchor:"diffusers.PriorTransformer.forward.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_embeddings, embedding_dim)</code>) &#x2014;
Hidden states of the text embeddings the denoising process is conditioned on.`,name:"encoder_hidden_states"},{anchor:"diffusers.PriorTransformer.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, num_embeddings)</code>) &#x2014;
Text mask for the text embeddings.`,name:"attention_mask"},{anchor:"diffusers.PriorTransformer.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput">models.prior_transformer.PriorTransformerOutput</a> instead of a plain
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/prior_transformer.py#L107",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput"
>PriorTransformerOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2555/en/api/models#diffusers.models.prior_transformer.PriorTransformerOutput"
>PriorTransformerOutput</a> or <code>tuple</code></p>
`}}),fs=new T({}),hs=new y({props:{name:"class diffusers.models.prior_transformer.PriorTransformerOutput",anchor:"diffusers.models.prior_transformer.PriorTransformerOutput",parameters:[{name:"predicted_image_embedding",val:": FloatTensor"}],parametersDescription:[{anchor:"diffusers.models.prior_transformer.PriorTransformerOutput.predicted_image_embedding",description:`<strong>predicted_image_embedding</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, embedding_dim)</code>) &#x2014;
The predicted CLIP image embedding conditioned on the CLIP text embedding input.`,name:"predicted_image_embedding"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/prior_transformer.py#L16"}}),_s=new T({}),bs=new y({props:{name:"class diffusers.models.controlnet.ControlNetOutput",anchor:"diffusers.models.controlnet.ControlNetOutput",parameters:[{name:"down_block_res_samples",val:": typing.Tuple[torch.Tensor]"},{name:"mid_block_res_sample",val:": Tensor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L39"}}),vs=new T({}),ys=new y({props:{name:"class diffusers.ControlNetModel",anchor:"diffusers.ControlNetModel",parameters:[{name:"in_channels",val:": int = 4"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"downsample_padding",val:": int = 1"},{name:"mid_block_scale_factor",val:": float = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"norm_num_groups",val:": typing.Optional[int] = 32"},{name:"norm_eps",val:": float = 1e-05"},{name:"cross_attention_dim",val:": int = 1280"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"use_linear_projection",val:": bool = False"},{name:"class_embed_type",val:": typing.Optional[str] = None"},{name:"num_class_embeds",val:": typing.Optional[int] = None"},{name:"upcast_attention",val:": bool = False"},{name:"resnet_time_scale_shift",val:": str = 'default'"},{name:"projection_class_embeddings_input_dim",val:": typing.Optional[int] = None"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Optional[typing.Tuple[int]] = (16, 32, 96, 256)"},{name:"global_pool_conditions",val:": bool = False"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L89"}}),xs=new y({props:{name:"from_unet",anchor:"diffusers.ControlNetModel.from_unet",parameters:[{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Optional[typing.Tuple[int]] = (16, 32, 96, 256)"},{name:"load_weights_from_unet",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.ControlNetModel.from_unet.unet",description:`<strong>unet</strong> (<code>UNet2DConditionModel</code>) &#x2014;
UNet model which weights are copied to the ControlNet. Note that all configuration options are also
copied where applicable.`,name:"unet"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L262"}}),$s=new y({props:{name:"set_attention_slice",anchor:"diffusers.ControlNetModel.set_attention_slice",parameters:[{name:"slice_size",val:""}],parametersDescription:[{anchor:"diffusers.ControlNetModel.set_attention_slice.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code> or <code>list(int)</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L380"}}),ws=new y({props:{name:"set_attn_processor",anchor:"diffusers.ControlNetModel.set_attn_processor",parameters:[{name:"processor",val:": typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor, typing.Dict[str, typing.Union[diffusers.models.attention_processor.AttnProcessor, diffusers.models.attention_processor.AttnProcessor2_0, diffusers.models.attention_processor.XFormersAttnProcessor, diffusers.models.attention_processor.SlicedAttnProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor, diffusers.models.attention_processor.SlicedAttnAddedKVProcessor, diffusers.models.attention_processor.AttnAddedKVProcessor2_0, diffusers.models.attention_processor.LoRAAttnProcessor, diffusers.models.attention_processor.LoRAXFormersAttnProcessor]]]"}],parametersDescription:[{anchor:"diffusers.ControlNetModel.set_attn_processor.`processor",description:`<strong>\`processor</strong> (<code>dict</code> of <code>AttentionProcessor</code> or <code>AttentionProcessor</code>) &#x2014;
The instantiated processor class or a dictionary of processor classes that will be set as the processor
of <strong>all</strong> <code>Attention</code> layers.`,name:"`processor"},{anchor:"diffusers.ControlNetModel.set_attn_processor.In",description:"<strong>In</strong> case <code>processor</code> is a dict, the key needs to define the path to the corresponding cross attention processor. This is strongly recommended when setting trainable attention processors. &#x2014;",name:"In"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L342"}}),Ds=new y({props:{name:"set_default_attn_processor",anchor:"diffusers.ControlNetModel.set_default_attn_processor",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet.py#L373"}}),ks=new T({}),Ts=new y({props:{name:"class diffusers.T2IAdapter",anchor:"diffusers.T2IAdapter",parameters:[{name:"block_out_channels",val:": typing.List[int] = [320, 640, 1280, 1280]"},{name:"block_mid_channels",val:": typing.Optional[typing.List[int]] = None"},{name:"num_res_blocks",val:": int = 3"},{name:"channels_in",val:": int = 3"},{name:"kernel_size",val:": int = 3"},{name:"proj_kernel_size",val:": int = 1"},{name:"res_block_skip",val:": bool = True"},{name:"use_conv",val:": bool = False"},{name:"input_scale_factor",val:": int = 8"}],parametersDescription:[{anchor:"diffusers.T2IAdapter.block_out_channels",description:`<strong>block_out_channels</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The number of channel of each downsample block&#x2019;s output hidden state. The <code>len(block_out_channels)</code> will
also determine the number of downsample blocks in the Adapter.`,name:"block_out_channels"},{anchor:"diffusers.T2IAdapter.block_mid_channels",description:`<strong>block_mid_channels</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>block_out_channels</code> if not provided) &#x2014;
The number of channels ResNet blocks in each downsample blocks will have, a downsample block will insert a
projection layer in the last ResNet block when having different &#x201C;mid_channel&#x201D; and &#x201C;out_channel&#x201D;.`,name:"block_mid_channels"},{anchor:"diffusers.T2IAdapter.num_res_blocks",description:`<strong>num_res_blocks</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of ResNet blocks in each downsample block`,name:"num_res_blocks"},{anchor:"diffusers.T2IAdapter.channels_in",description:`<strong>channels_in</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of channels of Aapter&#x2019;s input(<em>control image</em>). Set this parameter to 1 if you&#x2019;re using gray scale
image as <em>control image</em>.`,name:"channels_in"},{anchor:"diffusers.T2IAdapter.kernel_size",description:`<strong>kernel_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Kernel size of conv-2d layers inside ResNet blocks.`,name:"kernel_size"},{anchor:"diffusers.T2IAdapter.proj_kernel_size",description:`<strong>proj_kernel_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Kernel size of conv-2d projection layers located at the start and end of a downsample block.`,name:"proj_kernel_size"},{anchor:"diffusers.T2IAdapter.res_block_skip",description:`<strong>res_block_skip</strong> (<code>bool</code>, <em>optional</em>, defaults to True) &#x2014;
If set to <code>True</code>, ResNet block will using a regular residual connect that add layer&#x2019;s input to its output.
If set to <code>False</code>, ResNet block will create a additional conv-2d layer in residual connect before adding
residual back.`,name:"res_block_skip"},{anchor:"diffusers.T2IAdapter.use_conv",description:`<strong>use_conv</strong> (<code>bool</code>, <em>optional</em>, defaults to False) &#x2014;
Whether to use a conv-2d layer for down sample feature map or a average pooling layer.`,name:"use_conv"},{anchor:"diffusers.T2IAdapter.input_scale_factor",description:`<strong>input_scale_factor</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
The down scaling factor will be apply to input image when it is frist deliver to Adapter. Which should be
equal to the down scaling factor of the VAE of your choice.`,name:"input_scale_factor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/adapter.py#L59"}}),Es=new y({props:{name:"forward",anchor:"diffusers.T2IAdapter.forward",parameters:[{name:"x",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.T2IAdapter.forward.x",description:`<strong>x</strong> (<code>torch.Tensor</code>) &#x2014;
(batch, channel, height, width) input images for adapter model, <code>channel</code> should equal to
<code>channels_in</code>.`,name:"x"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/adapter.py#L177"}}),Us=new T({}),Cs=new y({props:{name:"class diffusers.MultiAdapter",anchor:"diffusers.MultiAdapter",parameters:[{name:"adapters",val:": typing.List[diffusers.models.adapter.T2IAdapter]"}],parametersDescription:[{anchor:"diffusers.MultiAdapter.adapters",description:`<strong>adapters</strong> (<code>List[T2IAdapter]</code>, <em>optional</em>, defaults to None) &#x2014;
A list of <code>T2IAdapter</code> model instances.`,name:"adapters"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/adapter.py#L196"}}),Ps=new y({props:{name:"forward",anchor:"diffusers.MultiAdapter.forward",parameters:[{name:"xs",val:": Tensor"},{name:"adapter_weights",val:": typing.Optional[typing.List[float]] = None"}],parametersDescription:[{anchor:"diffusers.MultiAdapter.forward.xs",description:`<strong>xs</strong> (<code>torch.Tensor</code>) &#x2014;
(batch, channel, height, width) input images for multiple adapter models concated along dimension 1,
<code>channel</code> should equal to <code>num_adapter</code> * &#x201C;number of channel of image&#x201D;.`,name:"xs"},{anchor:"diffusers.MultiAdapter.forward.adapter_weights",description:`<strong>adapter_weights</strong> (<code>List[float]</code>, <em>optional</em>, defaults to None) &#x2014;
List of floats representing the weight which will be multiply to each adapter&#x2019;s output before adding
them together.`,name:"adapter_weights"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/adapter.py#L215"}}),Os=new T({}),Ls=new y({props:{name:"class diffusers.FlaxModelMixin",anchor:"diffusers.FlaxModelMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L45"}}),qs=new y({props:{name:"from_pretrained",anchor:"diffusers.FlaxModelMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"*model_args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids are namespaced under a user or organization name, like
<code>runwayml/stable-diffusion-v1-5</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <a href="/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin.save_pretrained">save_pretrained()</a>,
e.g., <code>./my_model_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <code>~ModelMixin.to_fp16</code> and
<code>~ModelMixin.to_bf16</code>.`,name:"dtype"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.model_args",description:`<strong>model_args</strong> (sequence of positional arguments, <em>optional</em>) &#x2014;
All remaining positional arguments will be passed to the underlying model&#x2019;s <code>__init__</code> method.`,name:"model_args"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.from_pt",description:`<strong>from_pt</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Load the model weights from a PyTorch checkpoint save file.`,name:"from_pt"},{anchor:"diffusers.FlaxModelMixin.from_pretrained.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to update the configuration object (after it being loaded) and initiate the model (e.g.,
<code>output_attentions=True</code>). Behaves differently depending on whether a <code>config</code> is provided or
automatically loaded:</p>
<ul>
<li>If a configuration is provided with <code>config</code>, <code>**kwargs</code> will be directly passed to the
underlying model&#x2019;s <code>__init__</code> method (we assume all relevant updates to the configuration have
already been done)</li>
<li>If a configuration is not provided, <code>kwargs</code> will be first passed to the configuration class
initialization function (<a href="/docs/diffusers/pr_2555/en/api/configuration#diffusers.ConfigMixin.from_config">from_config()</a>). Each key of <code>kwargs</code> that corresponds to
a configuration attribute will be used to override said attribute with the supplied <code>kwargs</code>
value. Remaining keys that do not correspond to any configuration attribute will be passed to the
underlying model&#x2019;s <code>__init__</code> function.</li>
</ul>`,name:"kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L195"}}),ao=new Dl({props:{anchor:"diffusers.FlaxModelMixin.from_pretrained.example",$$slots:{default:[M$]},$$scope:{ctx:I}}}),zs=new y({props:{name:"save_pretrained",anchor:"diffusers.FlaxModelMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"is_main_process",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.FlaxModelMixin.save_pretrained.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.save_pretrained.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L487"}}),Bs=new y({props:{name:"to_bf16",anchor:"diffusers.FlaxModelMixin.to_bf16",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_bf16.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_bf16.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip.`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L87"}}),lo=new Dl({props:{anchor:"diffusers.FlaxModelMixin.to_bf16.example",$$slots:{default:[N$]},$$scope:{ctx:I}}}),Ss=new y({props:{name:"to_fp16",anchor:"diffusers.FlaxModelMixin.to_fp16",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_fp16.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_fp16.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L153"}}),co=new Dl({props:{anchor:"diffusers.FlaxModelMixin.to_fp16.example",$$slots:{default:[A$]},$$scope:{ctx:I}}}),Ks=new y({props:{name:"to_fp32",anchor:"diffusers.FlaxModelMixin.to_fp32",parameters:[{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"mask",val:": typing.Any = None"}],parametersDescription:[{anchor:"diffusers.FlaxModelMixin.to_fp32.params",description:`<strong>params</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> of model parameters.`,name:"params"},{anchor:"diffusers.FlaxModelMixin.to_fp32.mask",description:`<strong>mask</strong> (<code>Union[Dict, FrozenDict]</code>) &#x2014;
A <code>PyTree</code> with same structure as the <code>params</code> tree. The leaves should be booleans, <code>True</code> for params
you want to cast, and should be <code>False</code> for those you want to skip`,name:"mask"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/modeling_flax_utils.py#L126"}}),mo=new Dl({props:{anchor:"diffusers.FlaxModelMixin.to_fp32.example",$$slots:{default:[E$]},$$scope:{ctx:I}}}),Ws=new T({}),Xs=new y({props:{name:"class diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",parameters:[{name:"sample",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput.sample",description:`<strong>sample</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Hidden states conditioned on <code>encoder_hidden_states</code> input. Output of last layer of model.`,name:"sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition_flax.py#L36"}}),Hs=new y({props:{name:"replace",anchor:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/flax/struct.py#L108"}}),Rs=new T({}),Qs=new y({props:{name:"class diffusers.FlaxUNet2DConditionModel",anchor:"diffusers.FlaxUNet2DConditionModel",parameters:[{name:"sample_size",val:": int = 32"},{name:"in_channels",val:": int = 4"},{name:"out_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D', 'CrossAttnUpBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"cross_attention_dim",val:": int = 1280"},{name:"dropout",val:": float = 0.0"},{name:"use_linear_projection",val:": bool = False"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"use_memory_efficient_attention",val:": bool = False"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7f6fd095ee80>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxUNet2DConditionModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the input sample.`,name:"sample_size"},{anchor:"diffusers.FlaxUNet2DConditionModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the input sample.`,name:"in_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.out_channels",description:`<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the output.`,name:"out_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use. The corresponding class names will be: &#x201C;FlaxCrossAttnDownBlock2D&#x201D;,
&#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxDownBlock2D&#x201D;`,name:"down_block_types"},{anchor:"diffusers.FlaxUNet2DConditionModel.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;UpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;, &quot;CrossAttnUpBlock2D&quot;,)</code>) &#x2014;
The tuple of upsample blocks to use. The corresponding class names will be: &#x201C;FlaxUpBlock2D&#x201D;,
&#x201C;FlaxCrossAttnUpBlock2D&#x201D;, &#x201C;FlaxCrossAttnUpBlock2D&#x201D;, &#x201C;FlaxCrossAttnUpBlock2D&#x201D;`,name:"up_block_types"},{anchor:"diffusers.FlaxUNet2DConditionModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.FlaxUNet2DConditionModel.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The number of layers per block.`,name:"layers_per_block"},{anchor:"diffusers.FlaxUNet2DConditionModel.attention_head_dim",description:`<strong>attention_head_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 8) &#x2014;
The dimension of the attention heads.`,name:"attention_head_dim"},{anchor:"diffusers.FlaxUNet2DConditionModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.FlaxUNet2DConditionModel.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
Dropout probability for down, up and bottleneck blocks.`,name:"dropout"},{anchor:"diffusers.FlaxUNet2DConditionModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.FlaxUNet2DConditionModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"},{anchor:"diffusers.FlaxUNet2DConditionModel.use_memory_efficient_attention",description:`<strong>use_memory_efficient_attention</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
enable memory efficient attention <a href="https://arxiv.org/abs/2112.05682" rel="nofollow">https://arxiv.org/abs/2112.05682</a>`,name:"use_memory_efficient_attention"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/unet_2d_condition_flax.py#L47"}}),nr=new T({}),sr=new y({props:{name:"class diffusers.models.vae_flax.FlaxDecoderOutput",anchor:"diffusers.models.vae_flax.FlaxDecoderOutput",parameters:[{name:"sample",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.sample",description:`<strong>sample</strong> (<em>jnp.ndarray</em> of shape <em>(batch_size, num_channels, height, width)</em>) &#x2014;
Decoded output sample of the model. Output of the last layer of the model.`,name:"sample"},{anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.dtype",description:`<strong>dtype</strong> (<code>jnp.dtype</code>, <em>optional</em>, defaults to jnp.float32) &#x2014;
Parameters <em>dtype</em>`,name:"dtype"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vae_flax.py#L33"}}),rr=new y({props:{name:"replace",anchor:"diffusers.models.vae_flax.FlaxDecoderOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/flax/struct.py#L108"}}),ar=new T({}),ir=new y({props:{name:"class diffusers.models.vae_flax.FlaxAutoencoderKLOutput",anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput",parameters:[{name:"latent_dist",val:": FlaxDiagonalGaussianDistribution"}],parametersDescription:[{anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput.latent_dist",description:`<strong>latent_dist</strong> (<code>FlaxDiagonalGaussianDistribution</code>) &#x2014;
Encoded outputs of <code>Encoder</code> represented as the mean and logvar of <code>FlaxDiagonalGaussianDistribution</code>.
<code>FlaxDiagonalGaussianDistribution</code> allows for sampling latents from the distribution.`,name:"latent_dist"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vae_flax.py#L48"}}),dr=new y({props:{name:"replace",anchor:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/flax/struct.py#L108"}}),lr=new T({}),cr=new y({props:{name:"class diffusers.FlaxAutoencoderKL",anchor:"diffusers.FlaxAutoencoderKL",parameters:[{name:"in_channels",val:": int = 3"},{name:"out_channels",val:": int = 3"},{name:"down_block_types",val:": typing.Tuple[str] = ('DownEncoderBlock2D',)"},{name:"up_block_types",val:": typing.Tuple[str] = ('UpDecoderBlock2D',)"},{name:"block_out_channels",val:": typing.Tuple[int] = (64,)"},{name:"layers_per_block",val:": int = 1"},{name:"act_fn",val:": str = 'silu'"},{name:"latent_channels",val:": int = 4"},{name:"norm_num_groups",val:": int = 32"},{name:"sample_size",val:": int = 32"},{name:"scaling_factor",val:": float = 0.18215"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7f6fd095ee80>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxAutoencoderKL.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Input channels`,name:"in_channels"},{anchor:"diffusers.FlaxAutoencoderKL.out_channels",description:`<strong>out_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Output channels`,name:"out_channels"},{anchor:"diffusers.FlaxAutoencoderKL.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(DownEncoderBlock2D)</em>) &#x2014;
DownEncoder block type`,name:"down_block_types"},{anchor:"diffusers.FlaxAutoencoderKL.up_block_types",description:`<strong>up_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(UpDecoderBlock2D)</em>) &#x2014;
UpDecoder block type`,name:"up_block_types"},{anchor:"diffusers.FlaxAutoencoderKL.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <em>(64,)</em>) &#x2014;
Tuple containing the number of output channels for each block`,name:"block_out_channels"},{anchor:"diffusers.FlaxAutoencoderKL.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to <em>2</em>) &#x2014;
Number of Resnet layer for each block`,name:"layers_per_block"},{anchor:"diffusers.FlaxAutoencoderKL.act_fn",description:`<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <em>silu</em>) &#x2014;
Activation function`,name:"act_fn"},{anchor:"diffusers.FlaxAutoencoderKL.latent_channels",description:`<strong>latent_channels</strong> (<code>int</code>, <em>optional</em>, defaults to <em>4</em>) &#x2014;
Latent space channels`,name:"latent_channels"},{anchor:"diffusers.FlaxAutoencoderKL.norm_num_groups",description:`<strong>norm_num_groups</strong> (<code>int</code>, <em>optional</em>, defaults to <em>32</em>) &#x2014;
Norm num group`,name:"norm_num_groups"},{anchor:"diffusers.FlaxAutoencoderKL.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Sample input size`,name:"sample_size"},{anchor:"diffusers.FlaxAutoencoderKL.scaling_factor",description:`<strong>scaling_factor</strong> (<em>float</em>, <em>optional</em>, defaults to 0.18215) &#x2014;
The component-wise standard deviation of the trained latent space computed using the first batch of the
training set. This is used to scale the latent space to have unit variance when training the diffusion
model. The latents are scaled with the formula <em>z = z </em> scaling_factor<em> before being passed to the
diffusion model. When decoding, the latents are scaled back to the original scale with the formula: </em>z = 1
/ scaling_factor <em> z</em>. For more details, refer to sections 4.3.2 and D.1 of the <a href="https://arxiv.org/abs/2112.10752" rel="nofollow">High-Resolution Image
Synthesis with Latent Diffusion Models</a> paper.`,name:"scaling_factor"},{anchor:"diffusers.FlaxAutoencoderKL.dtype",description:`<strong>dtype</strong> (<code>jnp.dtype</code>, <em>optional</em>, defaults to jnp.float32) &#x2014;
parameters <em>dtype</em>`,name:"dtype"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/vae_flax.py#L721"}}),gr=new T({}),br=new y({props:{name:"class diffusers.models.controlnet_flax.FlaxControlNetOutput",anchor:"diffusers.models.controlnet_flax.FlaxControlNetOutput",parameters:[{name:"down_block_res_samples",val:": ndarray"},{name:"mid_block_res_sample",val:": ndarray"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet_flax.py#L34"}}),vr=new y({props:{name:"replace",anchor:"diffusers.models.controlnet_flax.FlaxControlNetOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/flax/struct.py#L108"}}),yr=new T({}),xr=new y({props:{name:"class diffusers.FlaxControlNetModel",anchor:"diffusers.FlaxControlNetModel",parameters:[{name:"sample_size",val:": int = 32"},{name:"in_channels",val:": int = 4"},{name:"down_block_types",val:": typing.Tuple[str] = ('CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'CrossAttnDownBlock2D', 'DownBlock2D')"},{name:"only_cross_attention",val:": typing.Union[bool, typing.Tuple[bool]] = False"},{name:"block_out_channels",val:": typing.Tuple[int] = (320, 640, 1280, 1280)"},{name:"layers_per_block",val:": int = 2"},{name:"attention_head_dim",val:": typing.Union[int, typing.Tuple[int]] = 8"},{name:"cross_attention_dim",val:": int = 1280"},{name:"dropout",val:": float = 0.0"},{name:"use_linear_projection",val:": bool = False"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"flip_sin_to_cos",val:": bool = True"},{name:"freq_shift",val:": int = 0"},{name:"controlnet_conditioning_channel_order",val:": str = 'rgb'"},{name:"conditioning_embedding_out_channels",val:": typing.Tuple[int] = (16, 32, 96, 256)"},{name:"parent",val:": typing.Union[typing.Type[flax.linen.module.Module], typing.Type[flax.core.scope.Scope], typing.Type[flax.linen.module._Sentinel], NoneType] = <flax.linen.module._Sentinel object at 0x7f6fd095ee80>"},{name:"name",val:": str = None"}],parametersDescription:[{anchor:"diffusers.FlaxControlNetModel.sample_size",description:`<strong>sample_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The size of the input sample.`,name:"sample_size"},{anchor:"diffusers.FlaxControlNetModel.in_channels",description:`<strong>in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of channels in the input sample.`,name:"in_channels"},{anchor:"diffusers.FlaxControlNetModel.down_block_types",description:`<strong>down_block_types</strong> (<code>Tuple[str]</code>, <em>optional</em>, defaults to <code>(&quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;CrossAttnDownBlock2D&quot;, &quot;DownBlock2D&quot;)</code>) &#x2014;
The tuple of downsample blocks to use. The corresponding class names will be: &#x201C;FlaxCrossAttnDownBlock2D&#x201D;,
&#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxCrossAttnDownBlock2D&#x201D;, &#x201C;FlaxDownBlock2D&#x201D;`,name:"down_block_types"},{anchor:"diffusers.FlaxControlNetModel.block_out_channels",description:`<strong>block_out_channels</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>(320, 640, 1280, 1280)</code>) &#x2014;
The tuple of output channels for each block.`,name:"block_out_channels"},{anchor:"diffusers.FlaxControlNetModel.layers_per_block",description:`<strong>layers_per_block</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The number of layers per block.`,name:"layers_per_block"},{anchor:"diffusers.FlaxControlNetModel.attention_head_dim",description:`<strong>attention_head_dim</strong> (<code>int</code> or <code>Tuple[int]</code>, <em>optional</em>, defaults to 8) &#x2014;
The dimension of the attention heads.`,name:"attention_head_dim"},{anchor:"diffusers.FlaxControlNetModel.cross_attention_dim",description:`<strong>cross_attention_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
The dimension of the cross attention features.`,name:"cross_attention_dim"},{anchor:"diffusers.FlaxControlNetModel.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
Dropout probability for down, up and bottleneck blocks.`,name:"dropout"},{anchor:"diffusers.FlaxControlNetModel.flip_sin_to_cos",description:`<strong>flip_sin_to_cos</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to flip the sin to cos in the time embedding.`,name:"flip_sin_to_cos"},{anchor:"diffusers.FlaxControlNetModel.freq_shift",description:"<strong>freq_shift</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The frequency shift to apply to the time embedding.",name:"freq_shift"},{anchor:"diffusers.FlaxControlNetModel.controlnet_conditioning_channel_order",description:`<strong>controlnet_conditioning_channel_order</strong> (<code>str</code>, <em>optional</em>, defaults to <code>rgb</code>) &#x2014;
The channel order of conditional image. Will convert it to <code>rgb</code> if it&#x2019;s <code>bgr</code>`,name:"controlnet_conditioning_channel_order"},{anchor:"diffusers.FlaxControlNetModel.conditioning_embedding_out_channels",description:`<strong>conditioning_embedding_out_channels</strong> (<code>tuple</code>, <em>optional</em>, defaults to <code>(16, 32, 96, 256)</code>) &#x2014;
The tuple of output channel for each block in conditioning_embedding layer`,name:"conditioning_embedding_out_channels"}],source:"https://github.com/huggingface/diffusers/blob/vr_2555/src/diffusers/models/controlnet_flax.py#L96"}}),{c(){x=n("meta"),M=i(),D=n("h1"),$=n("a"),k=n("span"),f(v.$$.fragment),w=i(),re=n("span"),Fe=l("Models"),Q=i(),Y=n("p"),Fr=l(`Diffusers contains pretrained models for popular algorithms and modules for creating the next set of diffusion models.
The primary function of these models is to denoise an input sample, by modeling the distribution $p`),$a=n("em"),lp=l("\\theta(\\mathbf{x}"),cp=l(`{t-1}|\\mathbf{x}_t)$.
The models are built on the base class [\u2018ModelMixin\u2019] that is a `),wa=n("code"),mp=l("torch.nn.module"),pp=l(" with basic functionality for saving and loading models both locally and from the HuggingFace hub."),Ml=i(),Pe=n("h2"),vt=n("a"),Da=n("span"),f(Po.$$.fragment),fp=i(),ka=n("span"),up=l("ModelMixin"),Nl=i(),N=n("div"),f(Oo.$$.fragment),hp=i(),Ta=n("p"),_p=l("Base class for all models."),gp=i(),Pr=n("p"),Or=n("a"),bp=l("ModelMixin"),vp=l(` takes care of storing the configuration of the models and handles methods for loading, downloading
and saving models.`),yp=i(),Ma=n("ul"),be=n("li"),Na=n("strong"),xp=l("config_name"),$p=l(" ("),Aa=n("code"),wp=l("str"),Dp=l(`) \u2014 A filename under which the model should be stored when calling
`),Lr=n("a"),kp=l("save_pretrained()"),Tp=l("."),Mp=i(),ve=n("div"),f(Lo.$$.fragment),Np=i(),Ea=n("p"),Ap=l("Deactivates gradient checkpointing for the current model."),Ep=i(),Ua=n("p"),Up=l(`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),Cp=i(),yt=n("div"),f(qo.$$.fragment),Fp=i(),Ca=n("p"),Pp=l("Disable memory efficient attention as implemented in xformers."),Op=i(),ye=n("div"),f(jo.$$.fragment),Lp=i(),Fa=n("p"),qp=l("Activates gradient checkpointing for the current model."),jp=i(),Pa=n("p"),Ip=l(`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),zp=i(),K=n("div"),f(Io.$$.fragment),Vp=i(),Oa=n("p"),Bp=l("Enable memory efficient attention as implemented in xformers."),Sp=i(),La=n("p"),Kp=l(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Wp=i(),qa=n("p"),Xp=l(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Hp=i(),f(xt.$$.fragment),Rp=i(),O=n("div"),f(zo.$$.fragment),Qp=i(),ja=n("p"),Yp=l("Instantiate a pretrained pytorch model from a pre-trained model configuration."),Gp=i(),Oe=n("p"),Jp=l("The model is set in evaluation mode by default using "),Ia=n("code"),Zp=l("model.eval()"),ef=l(` (Dropout modules are deactivated). To train
the model, you should first set it back in training mode with `),za=n("code"),tf=l("model.train()"),of=l("."),nf=i(),Vo=n("p"),sf=l("The warning "),Va=n("em"),rf=l("Weights from XXX not initialized from pretrained model"),af=l(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),df=i(),Bo=n("p"),lf=l("The warning "),Ba=n("em"),cf=l("Weights from XXX not used in YYY"),mf=l(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),pf=i(),f($t.$$.fragment),ff=i(),f(wt.$$.fragment),uf=i(),Dt=n("div"),f(So.$$.fragment),hf=i(),Sa=n("p"),_f=l("Get number of (optionally, trainable or non-embeddings) parameters in the module."),gf=i(),kt=n("div"),f(Ko.$$.fragment),bf=i(),Wo=n("p"),vf=l(`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),Ka=n("code"),yf=l("[from_pretrained()](/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin.from_pretrained)"),xf=l(" class method."),Al=i(),Le=n("h2"),Tt=n("a"),Wa=n("span"),f(Xo.$$.fragment),$f=i(),Xa=n("span"),wf=l("UNet2DOutput"),El=i(),Ho=n("div"),f(Ro.$$.fragment),Ul=i(),qe=n("h2"),Mt=n("a"),Ha=n("span"),f(Qo.$$.fragment),Df=i(),Ra=n("span"),kf=l("UNet2DModel"),Cl=i(),G=n("div"),f(Yo.$$.fragment),Tf=i(),Qa=n("p"),Mf=l("UNet2DModel is a 2D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),Nf=i(),Go=n("p"),Af=l("This model inherits from "),qr=n("a"),Ef=l("ModelMixin"),Uf=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Cf=i(),jr=n("div"),f(Jo.$$.fragment),Fl=i(),je=n("h2"),Nt=n("a"),Ya=n("span"),f(Zo.$$.fragment),Ff=i(),Ga=n("span"),Pf=l("UNet1DOutput"),Pl=i(),en=n("div"),f(tn.$$.fragment),Ol=i(),Ie=n("h2"),At=n("a"),Ja=n("span"),f(on.$$.fragment),Of=i(),Za=n("span"),Lf=l("UNet1DModel"),Ll=i(),J=n("div"),f(nn.$$.fragment),qf=i(),ei=n("p"),jf=l("UNet1DModel is a 1D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),If=i(),sn=n("p"),zf=l("This model inherits from "),Ir=n("a"),Vf=l("ModelMixin"),Bf=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Sf=i(),zr=n("div"),f(rn.$$.fragment),ql=i(),ze=n("h2"),Et=n("a"),ti=n("span"),f(an.$$.fragment),Kf=i(),oi=n("span"),Wf=l("UNet2DConditionOutput"),jl=i(),dn=n("div"),f(ln.$$.fragment),Il=i(),Ve=n("h2"),Ut=n("a"),ni=n("span"),f(cn.$$.fragment),Xf=i(),si=n("span"),Hf=l("UNet2DConditionModel"),zl=i(),F=n("div"),f(mn.$$.fragment),Rf=i(),ri=n("p"),Qf=l(`UNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),Yf=i(),pn=n("p"),Gf=l("This model inherits from "),Vr=n("a"),Jf=l("ModelMixin"),Zf=l(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),eu=i(),Br=n("div"),f(fn.$$.fragment),tu=i(),xe=n("div"),f(un.$$.fragment),ou=i(),ai=n("p"),nu=l("Enable sliced attention computation."),su=i(),ii=n("p"),ru=l(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),au=i(),Sr=n("div"),f(hn.$$.fragment),iu=i(),Ct=n("div"),f(_n.$$.fragment),du=i(),di=n("p"),lu=l("Disables custom attention processors and sets the default attention implementation."),Vl=i(),Be=n("h2"),Ft=n("a"),li=n("span"),f(gn.$$.fragment),cu=i(),ci=n("span"),mu=l("UNet3DConditionOutput"),Bl=i(),bn=n("div"),f(vn.$$.fragment),Sl=i(),Se=n("h2"),Pt=n("a"),mi=n("span"),f(yn.$$.fragment),pu=i(),pi=n("span"),fu=l("UNet3DConditionModel"),Kl=i(),P=n("div"),f(xn.$$.fragment),uu=i(),fi=n("p"),hu=l(`UNet3DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),_u=i(),$n=n("p"),gu=l("This model inherits from "),Kr=n("a"),bu=l("ModelMixin"),vu=l(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),yu=i(),Wr=n("div"),f(wn.$$.fragment),xu=i(),$e=n("div"),f(Dn.$$.fragment),$u=i(),ui=n("p"),wu=l("Enable sliced attention computation."),Du=i(),hi=n("p"),ku=l(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Tu=i(),Xr=n("div"),f(kn.$$.fragment),Mu=i(),Ot=n("div"),f(Tn.$$.fragment),Nu=i(),_i=n("p"),Au=l("Disables custom attention processors and sets the default attention implementation."),Wl=i(),Ke=n("h2"),Lt=n("a"),gi=n("span"),f(Mn.$$.fragment),Eu=i(),bi=n("span"),Uu=l("DecoderOutput"),Xl=i(),We=n("div"),f(Nn.$$.fragment),Cu=i(),vi=n("p"),Fu=l("Output of decoding method."),Hl=i(),Xe=n("h2"),qt=n("a"),yi=n("span"),f(An.$$.fragment),Pu=i(),xi=n("span"),Ou=l("VQEncoderOutput"),Rl=i(),He=n("div"),f(En.$$.fragment),Lu=i(),$i=n("p"),qu=l("Output of VQModel encoding method."),Ql=i(),Re=n("h2"),jt=n("a"),wi=n("span"),f(Un.$$.fragment),ju=i(),Di=n("span"),Iu=l("VQModel"),Yl=i(),Z=n("div"),f(Cn.$$.fragment),zu=i(),ki=n("p"),Vu=l(`VQ-VAE model from the paper Neural Discrete Representation Learning by Aaron van den Oord, Oriol Vinyals and Koray
Kavukcuoglu.`),Bu=i(),Fn=n("p"),Su=l("This model inherits from "),Hr=n("a"),Ku=l("ModelMixin"),Wu=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Xu=i(),Rr=n("div"),f(Pn.$$.fragment),Gl=i(),Qe=n("h2"),It=n("a"),Ti=n("span"),f(On.$$.fragment),Hu=i(),Mi=n("span"),Ru=l("AutoencoderKLOutput"),Jl=i(),Ye=n("div"),f(Ln.$$.fragment),Qu=i(),Ni=n("p"),Yu=l("Output of AutoencoderKL encoding method."),Zl=i(),Ge=n("h2"),zt=n("a"),Ai=n("span"),f(qn.$$.fragment),Gu=i(),Ei=n("span"),Ju=l("AutoencoderKL"),ec=i(),A=n("div"),f(jn.$$.fragment),Zu=i(),Ui=n("p"),eh=l(`Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational Bayes by Diederik P. Kingma
and Max Welling.`),th=i(),In=n("p"),oh=l("This model inherits from "),Qr=n("a"),nh=l("ModelMixin"),sh=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),rh=i(),Vt=n("div"),f(zn.$$.fragment),ah=i(),Vn=n("p"),ih=l("Disable sliced VAE decoding. If "),Ci=n("code"),dh=l("enable_slicing"),lh=l(` was previously invoked, this method will go back to computing
decoding in one step.`),ch=i(),Bt=n("div"),f(Bn.$$.fragment),mh=i(),Sn=n("p"),ph=l("Disable tiled VAE decoding. If "),Fi=n("code"),fh=l("enable_vae_tiling"),uh=l(` was previously invoked, this method will go back to
computing decoding in one step.`),hh=i(),St=n("div"),f(Kn.$$.fragment),_h=i(),Pi=n("p"),gh=l(`Enable sliced VAE decoding. When this option is enabled, the VAE will split the input tensor in slices to
compute decoding in several steps. This is useful to save some memory and allow larger batch sizes.`),bh=i(),Kt=n("div"),f(Wn.$$.fragment),vh=i(),Oi=n("p"),yh=l(`Enable tiled VAE decoding. When this option is enabled, the VAE will split the input tensor into tiles to
compute decoding and encoding in several steps. This is useful to save a large amount of memory and to allow
the processing of larger images.`),xh=i(),Yr=n("div"),f(Xn.$$.fragment),$h=i(),Wt=n("div"),f(Hn.$$.fragment),wh=i(),Li=n("p"),Dh=l("Decode a batch of images using a tiled decoder."),kh=i(),Xt=n("div"),f(Rn.$$.fragment),Th=i(),qi=n("p"),Mh=l("Encode a batch of images using a tiled encoder."),tc=i(),Je=n("h2"),Ht=n("a"),ji=n("span"),f(Qn.$$.fragment),Nh=i(),Ii=n("span"),Ah=l("Transformer2DModel"),oc=i(),L=n("div"),f(Yn.$$.fragment),Eh=i(),zi=n("p"),Uh=l(`Transformer model for image-like data. Takes either discrete (classes of vector embeddings) or continuous (actual
embeddings) inputs.`),Ch=i(),Vi=n("p"),Fh=l(`When input is continuous: First, project the input (aka embedding) and reshape to b, t, d. Then apply standard
transformer action. Finally, reshape to image.`),Ph=i(),Gn=n("p"),Oh=l(`When input is discrete: First, input (classes of latent pixels) is converted to embeddings and has positional
embeddings applied, see `),Bi=n("code"),Lh=l("ImagePositionalEmbeddings"),qh=l(`. Then apply standard transformer action. Finally, predict
classes of unnoised image.`),jh=i(),Si=n("p"),Ih=l(`Note that it is assumed one of the input classes is the masked latent pixel. The predicted classes of the unnoised
image do not contain a prediction for the masked pixel as the unnoised image cannot be masked.`),zh=i(),Gr=n("div"),f(Jn.$$.fragment),nc=i(),Ze=n("h2"),Rt=n("a"),Ki=n("span"),f(Zn.$$.fragment),Vh=i(),Wi=n("span"),Bh=l("Transformer2DModelOutput"),sc=i(),es=n("div"),f(ts.$$.fragment),rc=i(),et=n("h2"),Qt=n("a"),Xi=n("span"),f(os.$$.fragment),Sh=i(),Hi=n("span"),Kh=l("TransformerTemporalModel"),ac=i(),me=n("div"),f(ns.$$.fragment),Wh=i(),Ri=n("p"),Xh=l("Transformer model for video-like data."),Hh=i(),Jr=n("div"),f(ss.$$.fragment),ic=i(),tt=n("h2"),Yt=n("a"),Qi=n("span"),f(rs.$$.fragment),Rh=i(),Yi=n("span"),Qh=l("Transformer2DModelOutput"),dc=i(),as=n("div"),f(is.$$.fragment),lc=i(),ot=n("h2"),Gt=n("a"),Gi=n("span"),f(ds.$$.fragment),Yh=i(),Ji=n("span"),Gh=l("PriorTransformer"),cc=i(),V=n("div"),f(ls.$$.fragment),Jh=i(),Zi=n("p"),Zh=l(`The prior transformer from unCLIP is used to predict CLIP image embeddings from CLIP text embeddings. Note that the
transformer predicts the image embeddings through a denoising diffusion process.`),e_=i(),cs=n("p"),t_=l("This model inherits from "),Zr=n("a"),o_=l("ModelMixin"),n_=l(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),s_=i(),ea=n("p"),r_=l("For more details, see the original paper: "),ms=n("a"),a_=l("https://arxiv.org/abs/2204.06125"),i_=i(),ta=n("div"),f(ps.$$.fragment),mc=i(),nt=n("h2"),Jt=n("a"),ed=n("span"),f(fs.$$.fragment),d_=i(),td=n("span"),l_=l("PriorTransformerOutput"),pc=i(),us=n("div"),f(hs.$$.fragment),fc=i(),st=n("h2"),Zt=n("a"),od=n("span"),f(_s.$$.fragment),c_=i(),nd=n("span"),m_=l("ControlNetOutput"),uc=i(),gs=n("div"),f(bs.$$.fragment),hc=i(),rt=n("h2"),eo=n("a"),sd=n("span"),f(vs.$$.fragment),p_=i(),rd=n("span"),f_=l("ControlNetModel"),_c=i(),B=n("div"),f(ys.$$.fragment),u_=i(),to=n("div"),f(xs.$$.fragment),h_=i(),ad=n("p"),__=l("Instantiate Controlnet class from UNet2DConditionModel."),g_=i(),we=n("div"),f($s.$$.fragment),b_=i(),id=n("p"),v_=l("Enable sliced attention computation."),y_=i(),dd=n("p"),x_=l(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),$_=i(),oa=n("div"),f(ws.$$.fragment),w_=i(),oo=n("div"),f(Ds.$$.fragment),D_=i(),ld=n("p"),k_=l("Disables custom attention processors and sets the default attention implementation."),gc=i(),at=n("h2"),no=n("a"),cd=n("span"),f(ks.$$.fragment),T_=i(),md=n("span"),M_=l("T2IAdapter"),bc=i(),ee=n("div"),f(Ts.$$.fragment),N_=i(),pe=n("p"),A_=l(`A simple ResNet-like model that accepts images containing control signals such as keyposes and depth. The model
generates multiple feature maps that are used as additional conditioning in `),na=n("a"),E_=l("UNet2DConditionModel"),U_=l(`. The model\u2019s
architecture follows the original implementation of
`),Ms=n("a"),C_=l("Adapter"),F_=l(`
and
`),Ns=n("a"),P_=l("AdapterLight"),O_=l("."),L_=i(),As=n("p"),q_=l("This model inherits from "),sa=n("a"),j_=l("ModelMixin"),I_=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),z_=i(),ra=n("div"),f(Es.$$.fragment),vc=i(),it=n("h2"),so=n("a"),pd=n("span"),f(Us.$$.fragment),V_=i(),fd=n("span"),B_=l("MultiAdapter"),yc=i(),te=n("div"),f(Cs.$$.fragment),S_=i(),ud=n("p"),K_=l(`MultiAdapter is a wrapper model that contains multiple adapter models and merges their outputs according to
user-assigned weighting.`),W_=i(),Fs=n("p"),X_=l("This model inherits from "),aa=n("a"),H_=l("ModelMixin"),R_=l(`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Q_=i(),ia=n("div"),f(Ps.$$.fragment),xc=i(),dt=n("h2"),ro=n("a"),hd=n("span"),f(Os.$$.fragment),Y_=i(),_d=n("span"),G_=l("FlaxModelMixin"),$c=i(),U=n("div"),f(Ls.$$.fragment),J_=i(),gd=n("p"),Z_=l("Base class for all flax models."),eg=i(),da=n("p"),la=n("a"),tg=l("FlaxModelMixin"),og=l(` takes care of storing the configuration of the models and handles methods for loading,
downloading and saving models.`),ng=i(),W=n("div"),f(qs.$$.fragment),sg=i(),bd=n("p"),rg=l("Instantiate a pretrained flax model from a pre-trained model configuration."),ag=i(),js=n("p"),ig=l("The warning "),vd=n("em"),dg=l("Weights from XXX not initialized from pretrained model"),lg=l(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),cg=i(),Is=n("p"),mg=l("The warning "),yd=n("em"),pg=l("Weights from XXX not used in YYY"),fg=l(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),ug=i(),f(ao.$$.fragment),hg=i(),io=n("div"),f(zs.$$.fragment),_g=i(),Vs=n("p"),gg=l(`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),xd=n("code"),bg=l("[from_pretrained()](/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxModelMixin.from_pretrained)"),vg=l(" class method"),yg=i(),ae=n("div"),f(Bs.$$.fragment),xg=i(),oe=n("p"),$g=l("Cast the floating-point "),$d=n("code"),wg=l("params"),Dg=l(" to "),wd=n("code"),kg=l("jax.numpy.bfloat16"),Tg=l(". This returns a new "),Dd=n("code"),Mg=l("params"),Ng=l(` tree and does not cast
the `),kd=n("code"),Ag=l("params"),Eg=l(" in place."),Ug=i(),Td=n("p"),Cg=l(`This method can be used on TPU to explicitly convert the model parameters to bfloat16 precision to do full
half-precision training or to save weights in bfloat16 for inference in order to save memory and improve speed.`),Fg=i(),f(lo.$$.fragment),Pg=i(),ie=n("div"),f(Ss.$$.fragment),Og=i(),ne=n("p"),Lg=l("Cast the floating-point "),Md=n("code"),qg=l("params"),jg=l(" to "),Nd=n("code"),Ig=l("jax.numpy.float16"),zg=l(". This returns a new "),Ad=n("code"),Vg=l("params"),Bg=l(` tree and does not cast the
`),Ed=n("code"),Sg=l("params"),Kg=l(" in place."),Wg=i(),Ud=n("p"),Xg=l(`This method can be used on GPU to explicitly convert the model parameters to float16 precision to do full
half-precision training or to save weights in float16 for inference in order to save memory and improve speed.`),Hg=i(),f(co.$$.fragment),Rg=i(),De=n("div"),f(Ks.$$.fragment),Qg=i(),se=n("p"),Yg=l("Cast the floating-point "),Cd=n("code"),Gg=l("params"),Jg=l(" to "),Fd=n("code"),Zg=l("jax.numpy.float32"),e2=l(`. This method can be used to explicitly convert the
model parameters to fp32 precision. This returns a new `),Pd=n("code"),t2=l("params"),o2=l(" tree and does not cast the "),Od=n("code"),n2=l("params"),s2=l(" in place."),r2=i(),f(mo.$$.fragment),wc=i(),lt=n("h2"),po=n("a"),Ld=n("span"),f(Ws.$$.fragment),a2=i(),qd=n("span"),i2=l("FlaxUNet2DConditionOutput"),Dc=i(),ct=n("div"),f(Xs.$$.fragment),d2=i(),fo=n("div"),f(Hs.$$.fragment),l2=i(),jd=n("p"),c2=l("\u201CReturns a new object replacing the specified fields with new values."),kc=i(),mt=n("h2"),uo=n("a"),Id=n("span"),f(Rs.$$.fragment),m2=i(),zd=n("span"),p2=l("FlaxUNet2DConditionModel"),Tc=i(),q=n("div"),f(Qs.$$.fragment),f2=i(),Vd=n("p"),u2=l(`FlaxUNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a
timestep and returns sample shaped output.`),h2=i(),Ys=n("p"),_2=l("This model inherits from "),ca=n("a"),g2=l("FlaxModelMixin"),b2=l(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),v2=i(),Gs=n("p"),y2=l("Also, this model is a Flax Linen "),Js=n("a"),x2=l("flax.linen.Module"),$2=l(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),w2=i(),Bd=n("p"),D2=l("Finally, this model supports inherent JAX features such as:"),k2=i(),fe=n("ul"),Sd=n("li"),Zs=n("a"),T2=l("Just-In-Time (JIT) compilation"),M2=i(),Kd=n("li"),er=n("a"),N2=l("Automatic Differentiation"),A2=i(),Wd=n("li"),tr=n("a"),E2=l("Vectorization"),U2=i(),Xd=n("li"),or=n("a"),C2=l("Parallelization"),Mc=i(),pt=n("h2"),ho=n("a"),Hd=n("span"),f(nr.$$.fragment),F2=i(),Rd=n("span"),P2=l("FlaxDecoderOutput"),Nc=i(),ue=n("div"),f(sr.$$.fragment),O2=i(),Qd=n("p"),L2=l("Output of decoding method."),q2=i(),_o=n("div"),f(rr.$$.fragment),j2=i(),Yd=n("p"),I2=l("\u201CReturns a new object replacing the specified fields with new values."),Ac=i(),ft=n("h2"),go=n("a"),Gd=n("span"),f(ar.$$.fragment),z2=i(),Jd=n("span"),V2=l("FlaxAutoencoderKLOutput"),Ec=i(),he=n("div"),f(ir.$$.fragment),B2=i(),Zd=n("p"),S2=l("Output of AutoencoderKL encoding method."),K2=i(),bo=n("div"),f(dr.$$.fragment),W2=i(),el=n("p"),X2=l("\u201CReturns a new object replacing the specified fields with new values."),Uc=i(),ut=n("h2"),vo=n("a"),tl=n("span"),f(lr.$$.fragment),H2=i(),ol=n("span"),R2=l("FlaxAutoencoderKL"),Cc=i(),S=n("div"),f(cr.$$.fragment),Q2=i(),nl=n("p"),Y2=l(`Flax Implementation of Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational
Bayes by Diederik P. Kingma and Max Welling.`),G2=i(),mr=n("p"),J2=l("This model is a Flax Linen "),pr=n("a"),Z2=l("flax.linen.Module"),eb=l(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),tb=i(),sl=n("p"),ob=l("Finally, this model supports inherent JAX features such as:"),nb=i(),_e=n("ul"),rl=n("li"),fr=n("a"),sb=l("Just-In-Time (JIT) compilation"),rb=i(),al=n("li"),ur=n("a"),ab=l("Automatic Differentiation"),ib=i(),il=n("li"),hr=n("a"),db=l("Vectorization"),lb=i(),dl=n("li"),_r=n("a"),cb=l("Parallelization"),Fc=i(),ht=n("h2"),yo=n("a"),ll=n("span"),f(gr.$$.fragment),mb=i(),cl=n("span"),pb=l("FlaxControlNetOutput"),Pc=i(),_t=n("div"),f(br.$$.fragment),fb=i(),xo=n("div"),f(vr.$$.fragment),ub=i(),ml=n("p"),hb=l("\u201CReturns a new object replacing the specified fields with new values."),Oc=i(),gt=n("h2"),$o=n("a"),pl=n("span"),f(yr.$$.fragment),_b=i(),fl=n("span"),gb=l("FlaxControlNetModel"),Lc=i(),j=n("div"),f(xr.$$.fragment),bb=i(),$r=n("p"),vb=l("Quoting from "),wr=n("a"),yb=l("https://arxiv.org/abs/2302.05543"),xb=l(`: \u201CStable Diffusion uses a pre-processing method similar to VQ-GAN
[11] to convert the entire dataset of 512 \xD7 512 images into smaller 64 \xD7 64 \u201Clatent images\u201D for stabilized
training. This requires ControlNets to convert image-based conditions to 64 \xD7 64 feature space to match the
convolution size. We use a tiny network E(\xB7) of four convolution layers with 4 \xD7 4 kernels and 2 \xD7 2 strides
(activated by ReLU, channels are 16, 32, 64, 128, initialized with Gaussian weights, trained jointly with the full
model) to encode image-space conditions \u2026 into feature maps \u2026\u201D`),$b=i(),Dr=n("p"),wb=l("This model inherits from "),ma=n("a"),Db=l("FlaxModelMixin"),kb=l(`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Tb=i(),kr=n("p"),Mb=l("Also, this model is a Flax Linen "),Tr=n("a"),Nb=l("flax.linen.Module"),Ab=l(`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Eb=i(),ul=n("p"),Ub=l("Finally, this model supports inherent JAX features such as:"),Cb=i(),ge=n("ul"),hl=n("li"),Mr=n("a"),Fb=l("Just-In-Time (JIT) compilation"),Pb=i(),_l=n("li"),Nr=n("a"),Ob=l("Automatic Differentiation"),Lb=i(),gl=n("li"),Ar=n("a"),qb=l("Vectorization"),jb=i(),bl=n("li"),Er=n("a"),Ib=l("Parallelization"),this.h()},l(t){const m=$$('[data-svelte="svelte-1phssyn"]',document.head);x=s(m,"META",{name:!0,content:!0}),m.forEach(o),M=d(t),D=s(t,"H1",{class:!0});var Ur=r(D);$=s(Ur,"A",{id:!0,class:!0,href:!0});var vl=r($);k=s(vl,"SPAN",{});var yl=r(k);u(v.$$.fragment,yl),yl.forEach(o),vl.forEach(o),w=d(Ur),re=s(Ur,"SPAN",{});var xl=r(re);Fe=c(xl,"Models"),xl.forEach(o),Ur.forEach(o),Q=d(t),Y=s(t,"P",{});var bt=r(Y);Fr=c(bt,`Diffusers contains pretrained models for popular algorithms and modules for creating the next set of diffusion models.
The primary function of these models is to denoise an input sample, by modeling the distribution $p`),$a=s(bt,"EM",{});var $l=r($a);lp=c($l,"\\theta(\\mathbf{x}"),$l.forEach(o),cp=c(bt,`{t-1}|\\mathbf{x}_t)$.
The models are built on the base class [\u2018ModelMixin\u2019] that is a `),wa=s(bt,"CODE",{});var wl=r(wa);mp=c(wl,"torch.nn.module"),wl.forEach(o),pp=c(bt," with basic functionality for saving and loading models both locally and from the HuggingFace hub."),bt.forEach(o),Ml=d(t),Pe=s(t,"H2",{class:!0});var jc=r(Pe);vt=s(jc,"A",{id:!0,class:!0,href:!0});var Sb=r(vt);Da=s(Sb,"SPAN",{});var Kb=r(Da);u(Po.$$.fragment,Kb),Kb.forEach(o),Sb.forEach(o),fp=d(jc),ka=s(jc,"SPAN",{});var Wb=r(ka);up=c(Wb,"ModelMixin"),Wb.forEach(o),jc.forEach(o),Nl=d(t),N=s(t,"DIV",{class:!0});var E=r(N);u(Oo.$$.fragment,E),hp=d(E),Ta=s(E,"P",{});var Xb=r(Ta);_p=c(Xb,"Base class for all models."),Xb.forEach(o),gp=d(E),Pr=s(E,"P",{});var zb=r(Pr);Or=s(zb,"A",{href:!0});var Hb=r(Or);bp=c(Hb,"ModelMixin"),Hb.forEach(o),vp=c(zb,` takes care of storing the configuration of the models and handles methods for loading, downloading
and saving models.`),zb.forEach(o),yp=d(E),Ma=s(E,"UL",{});var Rb=r(Ma);be=s(Rb,"LI",{});var Cr=r(be);Na=s(Cr,"STRONG",{});var Qb=r(Na);xp=c(Qb,"config_name"),Qb.forEach(o),$p=c(Cr," ("),Aa=s(Cr,"CODE",{});var Yb=r(Aa);wp=c(Yb,"str"),Yb.forEach(o),Dp=c(Cr,`) \u2014 A filename under which the model should be stored when calling
`),Lr=s(Cr,"A",{href:!0});var Gb=r(Lr);kp=c(Gb,"save_pretrained()"),Gb.forEach(o),Tp=c(Cr,"."),Cr.forEach(o),Rb.forEach(o),Mp=d(E),ve=s(E,"DIV",{class:!0});var pa=r(ve);u(Lo.$$.fragment,pa),Np=d(pa),Ea=s(pa,"P",{});var Jb=r(Ea);Ap=c(Jb,"Deactivates gradient checkpointing for the current model."),Jb.forEach(o),Ep=d(pa),Ua=s(pa,"P",{});var Zb=r(Ua);Up=c(Zb,`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),Zb.forEach(o),pa.forEach(o),Cp=d(E),yt=s(E,"DIV",{class:!0});var Ic=r(yt);u(qo.$$.fragment,Ic),Fp=d(Ic),Ca=s(Ic,"P",{});var ev=r(Ca);Pp=c(ev,"Disable memory efficient attention as implemented in xformers."),ev.forEach(o),Ic.forEach(o),Op=d(E),ye=s(E,"DIV",{class:!0});var fa=r(ye);u(jo.$$.fragment,fa),Lp=d(fa),Fa=s(fa,"P",{});var tv=r(Fa);qp=c(tv,"Activates gradient checkpointing for the current model."),tv.forEach(o),jp=d(fa),Pa=s(fa,"P",{});var ov=r(Pa);Ip=c(ov,`Note that in other frameworks this feature can be referred to as \u201Cactivation checkpointing\u201D or \u201Ccheckpoint
activations\u201D.`),ov.forEach(o),fa.forEach(o),zp=d(E),K=s(E,"DIV",{class:!0});var ke=r(K);u(Io.$$.fragment,ke),Vp=d(ke),Oa=s(ke,"P",{});var nv=r(Oa);Bp=c(nv,"Enable memory efficient attention as implemented in xformers."),nv.forEach(o),Sp=d(ke),La=s(ke,"P",{});var sv=r(La);Kp=c(sv,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),sv.forEach(o),Wp=d(ke),qa=s(ke,"P",{});var rv=r(qa);Xp=c(rv,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),rv.forEach(o),Hp=d(ke),u(xt.$$.fragment,ke),ke.forEach(o),Rp=d(E),O=s(E,"DIV",{class:!0});var X=r(O);u(zo.$$.fragment,X),Qp=d(X),ja=s(X,"P",{});var av=r(ja);Yp=c(av,"Instantiate a pretrained pytorch model from a pre-trained model configuration."),av.forEach(o),Gp=d(X),Oe=s(X,"P",{});var ua=r(Oe);Jp=c(ua,"The model is set in evaluation mode by default using "),Ia=s(ua,"CODE",{});var iv=r(Ia);Zp=c(iv,"model.eval()"),iv.forEach(o),ef=c(ua,` (Dropout modules are deactivated). To train
the model, you should first set it back in training mode with `),za=s(ua,"CODE",{});var dv=r(za);tf=c(dv,"model.train()"),dv.forEach(o),of=c(ua,"."),ua.forEach(o),nf=d(X),Vo=s(X,"P",{});var zc=r(Vo);sf=c(zc,"The warning "),Va=s(zc,"EM",{});var lv=r(Va);rf=c(lv,"Weights from XXX not initialized from pretrained model"),lv.forEach(o),af=c(zc,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),zc.forEach(o),df=d(X),Bo=s(X,"P",{});var Vc=r(Bo);lf=c(Vc,"The warning "),Ba=s(Vc,"EM",{});var cv=r(Ba);cf=c(cv,"Weights from XXX not used in YYY"),cv.forEach(o),mf=c(Vc,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Vc.forEach(o),pf=d(X),u($t.$$.fragment,X),ff=d(X),u(wt.$$.fragment,X),X.forEach(o),uf=d(E),Dt=s(E,"DIV",{class:!0});var Bc=r(Dt);u(So.$$.fragment,Bc),hf=d(Bc),Sa=s(Bc,"P",{});var mv=r(Sa);_f=c(mv,"Get number of (optionally, trainable or non-embeddings) parameters in the module."),mv.forEach(o),Bc.forEach(o),gf=d(E),kt=s(E,"DIV",{class:!0});var Sc=r(kt);u(Ko.$$.fragment,Sc),bf=d(Sc),Wo=s(Sc,"P",{});var Kc=r(Wo);vf=c(Kc,`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),Ka=s(Kc,"CODE",{});var pv=r(Ka);yf=c(pv,"[from_pretrained()](/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin.from_pretrained)"),pv.forEach(o),xf=c(Kc," class method."),Kc.forEach(o),Sc.forEach(o),E.forEach(o),Al=d(t),Le=s(t,"H2",{class:!0});var Wc=r(Le);Tt=s(Wc,"A",{id:!0,class:!0,href:!0});var fv=r(Tt);Wa=s(fv,"SPAN",{});var uv=r(Wa);u(Xo.$$.fragment,uv),uv.forEach(o),fv.forEach(o),$f=d(Wc),Xa=s(Wc,"SPAN",{});var hv=r(Xa);wf=c(hv,"UNet2DOutput"),hv.forEach(o),Wc.forEach(o),El=d(t),Ho=s(t,"DIV",{class:!0});var _v=r(Ho);u(Ro.$$.fragment,_v),_v.forEach(o),Ul=d(t),qe=s(t,"H2",{class:!0});var Xc=r(qe);Mt=s(Xc,"A",{id:!0,class:!0,href:!0});var gv=r(Mt);Ha=s(gv,"SPAN",{});var bv=r(Ha);u(Qo.$$.fragment,bv),bv.forEach(o),gv.forEach(o),Df=d(Xc),Ra=s(Xc,"SPAN",{});var vv=r(Ra);kf=c(vv,"UNet2DModel"),vv.forEach(o),Xc.forEach(o),Cl=d(t),G=s(t,"DIV",{class:!0});var wo=r(G);u(Yo.$$.fragment,wo),Tf=d(wo),Qa=s(wo,"P",{});var yv=r(Qa);Mf=c(yv,"UNet2DModel is a 2D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),yv.forEach(o),Nf=d(wo),Go=s(wo,"P",{});var Hc=r(Go);Af=c(Hc,"This model inherits from "),qr=s(Hc,"A",{href:!0});var xv=r(qr);Ef=c(xv,"ModelMixin"),xv.forEach(o),Uf=c(Hc,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Hc.forEach(o),Cf=d(wo),jr=s(wo,"DIV",{class:!0});var $v=r(jr);u(Jo.$$.fragment,$v),$v.forEach(o),wo.forEach(o),Fl=d(t),je=s(t,"H2",{class:!0});var Rc=r(je);Nt=s(Rc,"A",{id:!0,class:!0,href:!0});var wv=r(Nt);Ya=s(wv,"SPAN",{});var Dv=r(Ya);u(Zo.$$.fragment,Dv),Dv.forEach(o),wv.forEach(o),Ff=d(Rc),Ga=s(Rc,"SPAN",{});var kv=r(Ga);Pf=c(kv,"UNet1DOutput"),kv.forEach(o),Rc.forEach(o),Pl=d(t),en=s(t,"DIV",{class:!0});var Tv=r(en);u(tn.$$.fragment,Tv),Tv.forEach(o),Ol=d(t),Ie=s(t,"H2",{class:!0});var Qc=r(Ie);At=s(Qc,"A",{id:!0,class:!0,href:!0});var Mv=r(At);Ja=s(Mv,"SPAN",{});var Nv=r(Ja);u(on.$$.fragment,Nv),Nv.forEach(o),Mv.forEach(o),Of=d(Qc),Za=s(Qc,"SPAN",{});var Av=r(Za);Lf=c(Av,"UNet1DModel"),Av.forEach(o),Qc.forEach(o),Ll=d(t),J=s(t,"DIV",{class:!0});var Do=r(J);u(nn.$$.fragment,Do),qf=d(Do),ei=s(Do,"P",{});var Ev=r(ei);jf=c(Ev,"UNet1DModel is a 1D UNet model that takes in a noisy sample and a timestep and returns sample shaped output."),Ev.forEach(o),If=d(Do),sn=s(Do,"P",{});var Yc=r(sn);zf=c(Yc,"This model inherits from "),Ir=s(Yc,"A",{href:!0});var Uv=r(Ir);Vf=c(Uv,"ModelMixin"),Uv.forEach(o),Bf=c(Yc,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Yc.forEach(o),Sf=d(Do),zr=s(Do,"DIV",{class:!0});var Cv=r(zr);u(rn.$$.fragment,Cv),Cv.forEach(o),Do.forEach(o),ql=d(t),ze=s(t,"H2",{class:!0});var Gc=r(ze);Et=s(Gc,"A",{id:!0,class:!0,href:!0});var Fv=r(Et);ti=s(Fv,"SPAN",{});var Pv=r(ti);u(an.$$.fragment,Pv),Pv.forEach(o),Fv.forEach(o),Kf=d(Gc),oi=s(Gc,"SPAN",{});var Ov=r(oi);Wf=c(Ov,"UNet2DConditionOutput"),Ov.forEach(o),Gc.forEach(o),jl=d(t),dn=s(t,"DIV",{class:!0});var Lv=r(dn);u(ln.$$.fragment,Lv),Lv.forEach(o),Il=d(t),Ve=s(t,"H2",{class:!0});var Jc=r(Ve);Ut=s(Jc,"A",{id:!0,class:!0,href:!0});var qv=r(Ut);ni=s(qv,"SPAN",{});var jv=r(ni);u(cn.$$.fragment,jv),jv.forEach(o),qv.forEach(o),Xf=d(Jc),si=s(Jc,"SPAN",{});var Iv=r(si);Hf=c(Iv,"UNet2DConditionModel"),Iv.forEach(o),Jc.forEach(o),zl=d(t),F=s(t,"DIV",{class:!0});var H=r(F);u(mn.$$.fragment,H),Rf=d(H),ri=s(H,"P",{});var zv=r(ri);Qf=c(zv,`UNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),zv.forEach(o),Yf=d(H),pn=s(H,"P",{});var Zc=r(pn);Gf=c(Zc,"This model inherits from "),Vr=s(Zc,"A",{href:!0});var Vv=r(Vr);Jf=c(Vv,"ModelMixin"),Vv.forEach(o),Zf=c(Zc,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Zc.forEach(o),eu=d(H),Br=s(H,"DIV",{class:!0});var Bv=r(Br);u(fn.$$.fragment,Bv),Bv.forEach(o),tu=d(H),xe=s(H,"DIV",{class:!0});var ha=r(xe);u(un.$$.fragment,ha),ou=d(ha),ai=s(ha,"P",{});var Sv=r(ai);nu=c(Sv,"Enable sliced attention computation."),Sv.forEach(o),su=d(ha),ii=s(ha,"P",{});var Kv=r(ii);ru=c(Kv,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Kv.forEach(o),ha.forEach(o),au=d(H),Sr=s(H,"DIV",{class:!0});var Wv=r(Sr);u(hn.$$.fragment,Wv),Wv.forEach(o),iu=d(H),Ct=s(H,"DIV",{class:!0});var em=r(Ct);u(_n.$$.fragment,em),du=d(em),di=s(em,"P",{});var Xv=r(di);lu=c(Xv,"Disables custom attention processors and sets the default attention implementation."),Xv.forEach(o),em.forEach(o),H.forEach(o),Vl=d(t),Be=s(t,"H2",{class:!0});var tm=r(Be);Ft=s(tm,"A",{id:!0,class:!0,href:!0});var Hv=r(Ft);li=s(Hv,"SPAN",{});var Rv=r(li);u(gn.$$.fragment,Rv),Rv.forEach(o),Hv.forEach(o),cu=d(tm),ci=s(tm,"SPAN",{});var Qv=r(ci);mu=c(Qv,"UNet3DConditionOutput"),Qv.forEach(o),tm.forEach(o),Bl=d(t),bn=s(t,"DIV",{class:!0});var Yv=r(bn);u(vn.$$.fragment,Yv),Yv.forEach(o),Sl=d(t),Se=s(t,"H2",{class:!0});var om=r(Se);Pt=s(om,"A",{id:!0,class:!0,href:!0});var Gv=r(Pt);mi=s(Gv,"SPAN",{});var Jv=r(mi);u(yn.$$.fragment,Jv),Jv.forEach(o),Gv.forEach(o),pu=d(om),pi=s(om,"SPAN",{});var Zv=r(pi);fu=c(Zv,"UNet3DConditionModel"),Zv.forEach(o),om.forEach(o),Kl=d(t),P=s(t,"DIV",{class:!0});var R=r(P);u(xn.$$.fragment,R),uu=d(R),fi=s(R,"P",{});var e1=r(fi);hu=c(e1,`UNet3DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a timestep
and returns sample shaped output.`),e1.forEach(o),_u=d(R),$n=s(R,"P",{});var nm=r($n);gu=c(nm,"This model inherits from "),Kr=s(nm,"A",{href:!0});var t1=r(Kr);bu=c(t1,"ModelMixin"),t1.forEach(o),vu=c(nm,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),nm.forEach(o),yu=d(R),Wr=s(R,"DIV",{class:!0});var o1=r(Wr);u(wn.$$.fragment,o1),o1.forEach(o),xu=d(R),$e=s(R,"DIV",{class:!0});var _a=r($e);u(Dn.$$.fragment,_a),$u=d(_a),ui=s(_a,"P",{});var n1=r(ui);wu=c(n1,"Enable sliced attention computation."),n1.forEach(o),Du=d(_a),hi=s(_a,"P",{});var s1=r(hi);ku=c(s1,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),s1.forEach(o),_a.forEach(o),Tu=d(R),Xr=s(R,"DIV",{class:!0});var r1=r(Xr);u(kn.$$.fragment,r1),r1.forEach(o),Mu=d(R),Ot=s(R,"DIV",{class:!0});var sm=r(Ot);u(Tn.$$.fragment,sm),Nu=d(sm),_i=s(sm,"P",{});var a1=r(_i);Au=c(a1,"Disables custom attention processors and sets the default attention implementation."),a1.forEach(o),sm.forEach(o),R.forEach(o),Wl=d(t),Ke=s(t,"H2",{class:!0});var rm=r(Ke);Lt=s(rm,"A",{id:!0,class:!0,href:!0});var i1=r(Lt);gi=s(i1,"SPAN",{});var d1=r(gi);u(Mn.$$.fragment,d1),d1.forEach(o),i1.forEach(o),Eu=d(rm),bi=s(rm,"SPAN",{});var l1=r(bi);Uu=c(l1,"DecoderOutput"),l1.forEach(o),rm.forEach(o),Xl=d(t),We=s(t,"DIV",{class:!0});var am=r(We);u(Nn.$$.fragment,am),Cu=d(am),vi=s(am,"P",{});var c1=r(vi);Fu=c(c1,"Output of decoding method."),c1.forEach(o),am.forEach(o),Hl=d(t),Xe=s(t,"H2",{class:!0});var im=r(Xe);qt=s(im,"A",{id:!0,class:!0,href:!0});var m1=r(qt);yi=s(m1,"SPAN",{});var p1=r(yi);u(An.$$.fragment,p1),p1.forEach(o),m1.forEach(o),Pu=d(im),xi=s(im,"SPAN",{});var f1=r(xi);Ou=c(f1,"VQEncoderOutput"),f1.forEach(o),im.forEach(o),Rl=d(t),He=s(t,"DIV",{class:!0});var dm=r(He);u(En.$$.fragment,dm),Lu=d(dm),$i=s(dm,"P",{});var u1=r($i);qu=c(u1,"Output of VQModel encoding method."),u1.forEach(o),dm.forEach(o),Ql=d(t),Re=s(t,"H2",{class:!0});var lm=r(Re);jt=s(lm,"A",{id:!0,class:!0,href:!0});var h1=r(jt);wi=s(h1,"SPAN",{});var _1=r(wi);u(Un.$$.fragment,_1),_1.forEach(o),h1.forEach(o),ju=d(lm),Di=s(lm,"SPAN",{});var g1=r(Di);Iu=c(g1,"VQModel"),g1.forEach(o),lm.forEach(o),Yl=d(t),Z=s(t,"DIV",{class:!0});var ko=r(Z);u(Cn.$$.fragment,ko),zu=d(ko),ki=s(ko,"P",{});var b1=r(ki);Vu=c(b1,`VQ-VAE model from the paper Neural Discrete Representation Learning by Aaron van den Oord, Oriol Vinyals and Koray
Kavukcuoglu.`),b1.forEach(o),Bu=d(ko),Fn=s(ko,"P",{});var cm=r(Fn);Su=c(cm,"This model inherits from "),Hr=s(cm,"A",{href:!0});var v1=r(Hr);Ku=c(v1,"ModelMixin"),v1.forEach(o),Wu=c(cm,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),cm.forEach(o),Xu=d(ko),Rr=s(ko,"DIV",{class:!0});var y1=r(Rr);u(Pn.$$.fragment,y1),y1.forEach(o),ko.forEach(o),Gl=d(t),Qe=s(t,"H2",{class:!0});var mm=r(Qe);It=s(mm,"A",{id:!0,class:!0,href:!0});var x1=r(It);Ti=s(x1,"SPAN",{});var $1=r(Ti);u(On.$$.fragment,$1),$1.forEach(o),x1.forEach(o),Hu=d(mm),Mi=s(mm,"SPAN",{});var w1=r(Mi);Ru=c(w1,"AutoencoderKLOutput"),w1.forEach(o),mm.forEach(o),Jl=d(t),Ye=s(t,"DIV",{class:!0});var pm=r(Ye);u(Ln.$$.fragment,pm),Qu=d(pm),Ni=s(pm,"P",{});var D1=r(Ni);Yu=c(D1,"Output of AutoencoderKL encoding method."),D1.forEach(o),pm.forEach(o),Zl=d(t),Ge=s(t,"H2",{class:!0});var fm=r(Ge);zt=s(fm,"A",{id:!0,class:!0,href:!0});var k1=r(zt);Ai=s(k1,"SPAN",{});var T1=r(Ai);u(qn.$$.fragment,T1),T1.forEach(o),k1.forEach(o),Gu=d(fm),Ei=s(fm,"SPAN",{});var M1=r(Ei);Ju=c(M1,"AutoencoderKL"),M1.forEach(o),fm.forEach(o),ec=d(t),A=s(t,"DIV",{class:!0});var C=r(A);u(jn.$$.fragment,C),Zu=d(C),Ui=s(C,"P",{});var N1=r(Ui);eh=c(N1,`Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational Bayes by Diederik P. Kingma
and Max Welling.`),N1.forEach(o),th=d(C),In=s(C,"P",{});var um=r(In);oh=c(um,"This model inherits from "),Qr=s(um,"A",{href:!0});var A1=r(Qr);nh=c(A1,"ModelMixin"),A1.forEach(o),sh=c(um,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),um.forEach(o),rh=d(C),Vt=s(C,"DIV",{class:!0});var hm=r(Vt);u(zn.$$.fragment,hm),ah=d(hm),Vn=s(hm,"P",{});var _m=r(Vn);ih=c(_m,"Disable sliced VAE decoding. If "),Ci=s(_m,"CODE",{});var E1=r(Ci);dh=c(E1,"enable_slicing"),E1.forEach(o),lh=c(_m,` was previously invoked, this method will go back to computing
decoding in one step.`),_m.forEach(o),hm.forEach(o),ch=d(C),Bt=s(C,"DIV",{class:!0});var gm=r(Bt);u(Bn.$$.fragment,gm),mh=d(gm),Sn=s(gm,"P",{});var bm=r(Sn);ph=c(bm,"Disable tiled VAE decoding. If "),Fi=s(bm,"CODE",{});var U1=r(Fi);fh=c(U1,"enable_vae_tiling"),U1.forEach(o),uh=c(bm,` was previously invoked, this method will go back to
computing decoding in one step.`),bm.forEach(o),gm.forEach(o),hh=d(C),St=s(C,"DIV",{class:!0});var vm=r(St);u(Kn.$$.fragment,vm),_h=d(vm),Pi=s(vm,"P",{});var C1=r(Pi);gh=c(C1,`Enable sliced VAE decoding. When this option is enabled, the VAE will split the input tensor in slices to
compute decoding in several steps. This is useful to save some memory and allow larger batch sizes.`),C1.forEach(o),vm.forEach(o),bh=d(C),Kt=s(C,"DIV",{class:!0});var ym=r(Kt);u(Wn.$$.fragment,ym),vh=d(ym),Oi=s(ym,"P",{});var F1=r(Oi);yh=c(F1,`Enable tiled VAE decoding. When this option is enabled, the VAE will split the input tensor into tiles to
compute decoding and encoding in several steps. This is useful to save a large amount of memory and to allow
the processing of larger images.`),F1.forEach(o),ym.forEach(o),xh=d(C),Yr=s(C,"DIV",{class:!0});var P1=r(Yr);u(Xn.$$.fragment,P1),P1.forEach(o),$h=d(C),Wt=s(C,"DIV",{class:!0});var xm=r(Wt);u(Hn.$$.fragment,xm),wh=d(xm),Li=s(xm,"P",{});var O1=r(Li);Dh=c(O1,"Decode a batch of images using a tiled decoder."),O1.forEach(o),xm.forEach(o),kh=d(C),Xt=s(C,"DIV",{class:!0});var $m=r(Xt);u(Rn.$$.fragment,$m),Th=d($m),qi=s($m,"P",{});var L1=r(qi);Mh=c(L1,"Encode a batch of images using a tiled encoder."),L1.forEach(o),$m.forEach(o),C.forEach(o),tc=d(t),Je=s(t,"H2",{class:!0});var wm=r(Je);Ht=s(wm,"A",{id:!0,class:!0,href:!0});var q1=r(Ht);ji=s(q1,"SPAN",{});var j1=r(ji);u(Qn.$$.fragment,j1),j1.forEach(o),q1.forEach(o),Nh=d(wm),Ii=s(wm,"SPAN",{});var I1=r(Ii);Ah=c(I1,"Transformer2DModel"),I1.forEach(o),wm.forEach(o),oc=d(t),L=s(t,"DIV",{class:!0});var de=r(L);u(Yn.$$.fragment,de),Eh=d(de),zi=s(de,"P",{});var z1=r(zi);Uh=c(z1,`Transformer model for image-like data. Takes either discrete (classes of vector embeddings) or continuous (actual
embeddings) inputs.`),z1.forEach(o),Ch=d(de),Vi=s(de,"P",{});var V1=r(Vi);Fh=c(V1,`When input is continuous: First, project the input (aka embedding) and reshape to b, t, d. Then apply standard
transformer action. Finally, reshape to image.`),V1.forEach(o),Ph=d(de),Gn=s(de,"P",{});var Dm=r(Gn);Oh=c(Dm,`When input is discrete: First, input (classes of latent pixels) is converted to embeddings and has positional
embeddings applied, see `),Bi=s(Dm,"CODE",{});var B1=r(Bi);Lh=c(B1,"ImagePositionalEmbeddings"),B1.forEach(o),qh=c(Dm,`. Then apply standard transformer action. Finally, predict
classes of unnoised image.`),Dm.forEach(o),jh=d(de),Si=s(de,"P",{});var S1=r(Si);Ih=c(S1,`Note that it is assumed one of the input classes is the masked latent pixel. The predicted classes of the unnoised
image do not contain a prediction for the masked pixel as the unnoised image cannot be masked.`),S1.forEach(o),zh=d(de),Gr=s(de,"DIV",{class:!0});var K1=r(Gr);u(Jn.$$.fragment,K1),K1.forEach(o),de.forEach(o),nc=d(t),Ze=s(t,"H2",{class:!0});var km=r(Ze);Rt=s(km,"A",{id:!0,class:!0,href:!0});var W1=r(Rt);Ki=s(W1,"SPAN",{});var X1=r(Ki);u(Zn.$$.fragment,X1),X1.forEach(o),W1.forEach(o),Vh=d(km),Wi=s(km,"SPAN",{});var H1=r(Wi);Bh=c(H1,"Transformer2DModelOutput"),H1.forEach(o),km.forEach(o),sc=d(t),es=s(t,"DIV",{class:!0});var R1=r(es);u(ts.$$.fragment,R1),R1.forEach(o),rc=d(t),et=s(t,"H2",{class:!0});var Tm=r(et);Qt=s(Tm,"A",{id:!0,class:!0,href:!0});var Q1=r(Qt);Xi=s(Q1,"SPAN",{});var Y1=r(Xi);u(os.$$.fragment,Y1),Y1.forEach(o),Q1.forEach(o),Sh=d(Tm),Hi=s(Tm,"SPAN",{});var G1=r(Hi);Kh=c(G1,"TransformerTemporalModel"),G1.forEach(o),Tm.forEach(o),ac=d(t),me=s(t,"DIV",{class:!0});var ga=r(me);u(ns.$$.fragment,ga),Wh=d(ga),Ri=s(ga,"P",{});var J1=r(Ri);Xh=c(J1,"Transformer model for video-like data."),J1.forEach(o),Hh=d(ga),Jr=s(ga,"DIV",{class:!0});var Z1=r(Jr);u(ss.$$.fragment,Z1),Z1.forEach(o),ga.forEach(o),ic=d(t),tt=s(t,"H2",{class:!0});var Mm=r(tt);Yt=s(Mm,"A",{id:!0,class:!0,href:!0});var ey=r(Yt);Qi=s(ey,"SPAN",{});var ty=r(Qi);u(rs.$$.fragment,ty),ty.forEach(o),ey.forEach(o),Rh=d(Mm),Yi=s(Mm,"SPAN",{});var oy=r(Yi);Qh=c(oy,"Transformer2DModelOutput"),oy.forEach(o),Mm.forEach(o),dc=d(t),as=s(t,"DIV",{class:!0});var ny=r(as);u(is.$$.fragment,ny),ny.forEach(o),lc=d(t),ot=s(t,"H2",{class:!0});var Nm=r(ot);Gt=s(Nm,"A",{id:!0,class:!0,href:!0});var sy=r(Gt);Gi=s(sy,"SPAN",{});var ry=r(Gi);u(ds.$$.fragment,ry),ry.forEach(o),sy.forEach(o),Yh=d(Nm),Ji=s(Nm,"SPAN",{});var ay=r(Ji);Gh=c(ay,"PriorTransformer"),ay.forEach(o),Nm.forEach(o),cc=d(t),V=s(t,"DIV",{class:!0});var Te=r(V);u(ls.$$.fragment,Te),Jh=d(Te),Zi=s(Te,"P",{});var iy=r(Zi);Zh=c(iy,`The prior transformer from unCLIP is used to predict CLIP image embeddings from CLIP text embeddings. Note that the
transformer predicts the image embeddings through a denoising diffusion process.`),iy.forEach(o),e_=d(Te),cs=s(Te,"P",{});var Am=r(cs);t_=c(Am,"This model inherits from "),Zr=s(Am,"A",{href:!0});var dy=r(Zr);o_=c(dy,"ModelMixin"),dy.forEach(o),n_=c(Am,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Am.forEach(o),s_=d(Te),ea=s(Te,"P",{});var Vb=r(ea);r_=c(Vb,"For more details, see the original paper: "),ms=s(Vb,"A",{href:!0,rel:!0});var ly=r(ms);a_=c(ly,"https://arxiv.org/abs/2204.06125"),ly.forEach(o),Vb.forEach(o),i_=d(Te),ta=s(Te,"DIV",{class:!0});var cy=r(ta);u(ps.$$.fragment,cy),cy.forEach(o),Te.forEach(o),mc=d(t),nt=s(t,"H2",{class:!0});var Em=r(nt);Jt=s(Em,"A",{id:!0,class:!0,href:!0});var my=r(Jt);ed=s(my,"SPAN",{});var py=r(ed);u(fs.$$.fragment,py),py.forEach(o),my.forEach(o),d_=d(Em),td=s(Em,"SPAN",{});var fy=r(td);l_=c(fy,"PriorTransformerOutput"),fy.forEach(o),Em.forEach(o),pc=d(t),us=s(t,"DIV",{class:!0});var uy=r(us);u(hs.$$.fragment,uy),uy.forEach(o),fc=d(t),st=s(t,"H2",{class:!0});var Um=r(st);Zt=s(Um,"A",{id:!0,class:!0,href:!0});var hy=r(Zt);od=s(hy,"SPAN",{});var _y=r(od);u(_s.$$.fragment,_y),_y.forEach(o),hy.forEach(o),c_=d(Um),nd=s(Um,"SPAN",{});var gy=r(nd);m_=c(gy,"ControlNetOutput"),gy.forEach(o),Um.forEach(o),uc=d(t),gs=s(t,"DIV",{class:!0});var by=r(gs);u(bs.$$.fragment,by),by.forEach(o),hc=d(t),rt=s(t,"H2",{class:!0});var Cm=r(rt);eo=s(Cm,"A",{id:!0,class:!0,href:!0});var vy=r(eo);sd=s(vy,"SPAN",{});var yy=r(sd);u(vs.$$.fragment,yy),yy.forEach(o),vy.forEach(o),p_=d(Cm),rd=s(Cm,"SPAN",{});var xy=r(rd);f_=c(xy,"ControlNetModel"),xy.forEach(o),Cm.forEach(o),_c=d(t),B=s(t,"DIV",{class:!0});var Me=r(B);u(ys.$$.fragment,Me),u_=d(Me),to=s(Me,"DIV",{class:!0});var Fm=r(to);u(xs.$$.fragment,Fm),h_=d(Fm),ad=s(Fm,"P",{});var $y=r(ad);__=c($y,"Instantiate Controlnet class from UNet2DConditionModel."),$y.forEach(o),Fm.forEach(o),g_=d(Me),we=s(Me,"DIV",{class:!0});var ba=r(we);u($s.$$.fragment,ba),b_=d(ba),id=s(ba,"P",{});var wy=r(id);v_=c(wy,"Enable sliced attention computation."),wy.forEach(o),y_=d(ba),dd=s(ba,"P",{});var Dy=r(dd);x_=c(Dy,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Dy.forEach(o),ba.forEach(o),$_=d(Me),oa=s(Me,"DIV",{class:!0});var ky=r(oa);u(ws.$$.fragment,ky),ky.forEach(o),w_=d(Me),oo=s(Me,"DIV",{class:!0});var Pm=r(oo);u(Ds.$$.fragment,Pm),D_=d(Pm),ld=s(Pm,"P",{});var Ty=r(ld);k_=c(Ty,"Disables custom attention processors and sets the default attention implementation."),Ty.forEach(o),Pm.forEach(o),Me.forEach(o),gc=d(t),at=s(t,"H2",{class:!0});var Om=r(at);no=s(Om,"A",{id:!0,class:!0,href:!0});var My=r(no);cd=s(My,"SPAN",{});var Ny=r(cd);u(ks.$$.fragment,Ny),Ny.forEach(o),My.forEach(o),T_=d(Om),md=s(Om,"SPAN",{});var Ay=r(md);M_=c(Ay,"T2IAdapter"),Ay.forEach(o),Om.forEach(o),bc=d(t),ee=s(t,"DIV",{class:!0});var To=r(ee);u(Ts.$$.fragment,To),N_=d(To),pe=s(To,"P",{});var Mo=r(pe);A_=c(Mo,`A simple ResNet-like model that accepts images containing control signals such as keyposes and depth. The model
generates multiple feature maps that are used as additional conditioning in `),na=s(Mo,"A",{href:!0});var Ey=r(na);E_=c(Ey,"UNet2DConditionModel"),Ey.forEach(o),U_=c(Mo,`. The model\u2019s
architecture follows the original implementation of
`),Ms=s(Mo,"A",{href:!0,rel:!0});var Uy=r(Ms);C_=c(Uy,"Adapter"),Uy.forEach(o),F_=c(Mo,`
and
`),Ns=s(Mo,"A",{href:!0,rel:!0});var Cy=r(Ns);P_=c(Cy,"AdapterLight"),Cy.forEach(o),O_=c(Mo,"."),Mo.forEach(o),L_=d(To),As=s(To,"P",{});var Lm=r(As);q_=c(Lm,"This model inherits from "),sa=s(Lm,"A",{href:!0});var Fy=r(sa);j_=c(Fy,"ModelMixin"),Fy.forEach(o),I_=c(Lm,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),Lm.forEach(o),z_=d(To),ra=s(To,"DIV",{class:!0});var Py=r(ra);u(Es.$$.fragment,Py),Py.forEach(o),To.forEach(o),vc=d(t),it=s(t,"H2",{class:!0});var qm=r(it);so=s(qm,"A",{id:!0,class:!0,href:!0});var Oy=r(so);pd=s(Oy,"SPAN",{});var Ly=r(pd);u(Us.$$.fragment,Ly),Ly.forEach(o),Oy.forEach(o),V_=d(qm),fd=s(qm,"SPAN",{});var qy=r(fd);B_=c(qy,"MultiAdapter"),qy.forEach(o),qm.forEach(o),yc=d(t),te=s(t,"DIV",{class:!0});var No=r(te);u(Cs.$$.fragment,No),S_=d(No),ud=s(No,"P",{});var jy=r(ud);K_=c(jy,`MultiAdapter is a wrapper model that contains multiple adapter models and merges their outputs according to
user-assigned weighting.`),jy.forEach(o),W_=d(No),Fs=s(No,"P",{});var jm=r(Fs);X_=c(jm,"This model inherits from "),aa=s(jm,"A",{href:!0});var Iy=r(aa);H_=c(Iy,"ModelMixin"),Iy.forEach(o),R_=c(jm,`. Check the superclass documentation for the generic methods the library
implements for all the model (such as downloading or saving, etc.)`),jm.forEach(o),Q_=d(No),ia=s(No,"DIV",{class:!0});var zy=r(ia);u(Ps.$$.fragment,zy),zy.forEach(o),No.forEach(o),xc=d(t),dt=s(t,"H2",{class:!0});var Im=r(dt);ro=s(Im,"A",{id:!0,class:!0,href:!0});var Vy=r(ro);hd=s(Vy,"SPAN",{});var By=r(hd);u(Os.$$.fragment,By),By.forEach(o),Vy.forEach(o),Y_=d(Im),_d=s(Im,"SPAN",{});var Sy=r(_d);G_=c(Sy,"FlaxModelMixin"),Sy.forEach(o),Im.forEach(o),$c=d(t),U=s(t,"DIV",{class:!0});var z=r(U);u(Ls.$$.fragment,z),J_=d(z),gd=s(z,"P",{});var Ky=r(gd);Z_=c(Ky,"Base class for all flax models."),Ky.forEach(o),eg=d(z),da=s(z,"P",{});var Bb=r(da);la=s(Bb,"A",{href:!0});var Wy=r(la);tg=c(Wy,"FlaxModelMixin"),Wy.forEach(o),og=c(Bb,` takes care of storing the configuration of the models and handles methods for loading,
downloading and saving models.`),Bb.forEach(o),ng=d(z),W=s(z,"DIV",{class:!0});var Ne=r(W);u(qs.$$.fragment,Ne),sg=d(Ne),bd=s(Ne,"P",{});var Xy=r(bd);rg=c(Xy,"Instantiate a pretrained flax model from a pre-trained model configuration."),Xy.forEach(o),ag=d(Ne),js=s(Ne,"P",{});var zm=r(js);ig=c(zm,"The warning "),vd=s(zm,"EM",{});var Hy=r(vd);dg=c(Hy,"Weights from XXX not initialized from pretrained model"),Hy.forEach(o),lg=c(zm,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),zm.forEach(o),cg=d(Ne),Is=s(Ne,"P",{});var Vm=r(Is);mg=c(Vm,"The warning "),yd=s(Vm,"EM",{});var Ry=r(yd);pg=c(Ry,"Weights from XXX not used in YYY"),Ry.forEach(o),fg=c(Vm,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Vm.forEach(o),ug=d(Ne),u(ao.$$.fragment,Ne),Ne.forEach(o),hg=d(z),io=s(z,"DIV",{class:!0});var Bm=r(io);u(zs.$$.fragment,Bm),_g=d(Bm),Vs=s(Bm,"P",{});var Sm=r(Vs);gg=c(Sm,`Save a model and its configuration file to a directory, so that it can be re-loaded using the
`),xd=s(Sm,"CODE",{});var Qy=r(xd);bg=c(Qy,"[from_pretrained()](/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxModelMixin.from_pretrained)"),Qy.forEach(o),vg=c(Sm," class method"),Sm.forEach(o),Bm.forEach(o),yg=d(z),ae=s(z,"DIV",{class:!0});var Ao=r(ae);u(Bs.$$.fragment,Ao),xg=d(Ao),oe=s(Ao,"P",{});var Ae=r(oe);$g=c(Ae,"Cast the floating-point "),$d=s(Ae,"CODE",{});var Yy=r($d);wg=c(Yy,"params"),Yy.forEach(o),Dg=c(Ae," to "),wd=s(Ae,"CODE",{});var Gy=r(wd);kg=c(Gy,"jax.numpy.bfloat16"),Gy.forEach(o),Tg=c(Ae,". This returns a new "),Dd=s(Ae,"CODE",{});var Jy=r(Dd);Mg=c(Jy,"params"),Jy.forEach(o),Ng=c(Ae,` tree and does not cast
the `),kd=s(Ae,"CODE",{});var Zy=r(kd);Ag=c(Zy,"params"),Zy.forEach(o),Eg=c(Ae," in place."),Ae.forEach(o),Ug=d(Ao),Td=s(Ao,"P",{});var ex=r(Td);Cg=c(ex,`This method can be used on TPU to explicitly convert the model parameters to bfloat16 precision to do full
half-precision training or to save weights in bfloat16 for inference in order to save memory and improve speed.`),ex.forEach(o),Fg=d(Ao),u(lo.$$.fragment,Ao),Ao.forEach(o),Pg=d(z),ie=s(z,"DIV",{class:!0});var Eo=r(ie);u(Ss.$$.fragment,Eo),Og=d(Eo),ne=s(Eo,"P",{});var Ee=r(ne);Lg=c(Ee,"Cast the floating-point "),Md=s(Ee,"CODE",{});var tx=r(Md);qg=c(tx,"params"),tx.forEach(o),jg=c(Ee," to "),Nd=s(Ee,"CODE",{});var ox=r(Nd);Ig=c(ox,"jax.numpy.float16"),ox.forEach(o),zg=c(Ee,". This returns a new "),Ad=s(Ee,"CODE",{});var nx=r(Ad);Vg=c(nx,"params"),nx.forEach(o),Bg=c(Ee,` tree and does not cast the
`),Ed=s(Ee,"CODE",{});var sx=r(Ed);Sg=c(sx,"params"),sx.forEach(o),Kg=c(Ee," in place."),Ee.forEach(o),Wg=d(Eo),Ud=s(Eo,"P",{});var rx=r(Ud);Xg=c(rx,`This method can be used on GPU to explicitly convert the model parameters to float16 precision to do full
half-precision training or to save weights in float16 for inference in order to save memory and improve speed.`),rx.forEach(o),Hg=d(Eo),u(co.$$.fragment,Eo),Eo.forEach(o),Rg=d(z),De=s(z,"DIV",{class:!0});var va=r(De);u(Ks.$$.fragment,va),Qg=d(va),se=s(va,"P",{});var Ue=r(se);Yg=c(Ue,"Cast the floating-point "),Cd=s(Ue,"CODE",{});var ax=r(Cd);Gg=c(ax,"params"),ax.forEach(o),Jg=c(Ue," to "),Fd=s(Ue,"CODE",{});var ix=r(Fd);Zg=c(ix,"jax.numpy.float32"),ix.forEach(o),e2=c(Ue,`. This method can be used to explicitly convert the
model parameters to fp32 precision. This returns a new `),Pd=s(Ue,"CODE",{});var dx=r(Pd);t2=c(dx,"params"),dx.forEach(o),o2=c(Ue," tree and does not cast the "),Od=s(Ue,"CODE",{});var lx=r(Od);n2=c(lx,"params"),lx.forEach(o),s2=c(Ue," in place."),Ue.forEach(o),r2=d(va),u(mo.$$.fragment,va),va.forEach(o),z.forEach(o),wc=d(t),lt=s(t,"H2",{class:!0});var Km=r(lt);po=s(Km,"A",{id:!0,class:!0,href:!0});var cx=r(po);Ld=s(cx,"SPAN",{});var mx=r(Ld);u(Ws.$$.fragment,mx),mx.forEach(o),cx.forEach(o),a2=d(Km),qd=s(Km,"SPAN",{});var px=r(qd);i2=c(px,"FlaxUNet2DConditionOutput"),px.forEach(o),Km.forEach(o),Dc=d(t),ct=s(t,"DIV",{class:!0});var Wm=r(ct);u(Xs.$$.fragment,Wm),d2=d(Wm),fo=s(Wm,"DIV",{class:!0});var Xm=r(fo);u(Hs.$$.fragment,Xm),l2=d(Xm),jd=s(Xm,"P",{});var fx=r(jd);c2=c(fx,"\u201CReturns a new object replacing the specified fields with new values."),fx.forEach(o),Xm.forEach(o),Wm.forEach(o),kc=d(t),mt=s(t,"H2",{class:!0});var Hm=r(mt);uo=s(Hm,"A",{id:!0,class:!0,href:!0});var ux=r(uo);Id=s(ux,"SPAN",{});var hx=r(Id);u(Rs.$$.fragment,hx),hx.forEach(o),ux.forEach(o),m2=d(Hm),zd=s(Hm,"SPAN",{});var _x=r(zd);p2=c(_x,"FlaxUNet2DConditionModel"),_x.forEach(o),Hm.forEach(o),Tc=d(t),q=s(t,"DIV",{class:!0});var le=r(q);u(Qs.$$.fragment,le),f2=d(le),Vd=s(le,"P",{});var gx=r(Vd);u2=c(gx,`FlaxUNet2DConditionModel is a conditional 2D UNet model that takes in a noisy sample, conditional state, and a
timestep and returns sample shaped output.`),gx.forEach(o),h2=d(le),Ys=s(le,"P",{});var Rm=r(Ys);_2=c(Rm,"This model inherits from "),ca=s(Rm,"A",{href:!0});var bx=r(ca);g2=c(bx,"FlaxModelMixin"),bx.forEach(o),b2=c(Rm,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),Rm.forEach(o),v2=d(le),Gs=s(le,"P",{});var Qm=r(Gs);y2=c(Qm,"Also, this model is a Flax Linen "),Js=s(Qm,"A",{href:!0,rel:!0});var vx=r(Js);x2=c(vx,"flax.linen.Module"),vx.forEach(o),$2=c(Qm,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),Qm.forEach(o),w2=d(le),Bd=s(le,"P",{});var yx=r(Bd);D2=c(yx,"Finally, this model supports inherent JAX features such as:"),yx.forEach(o),k2=d(le),fe=s(le,"UL",{});var Uo=r(fe);Sd=s(Uo,"LI",{});var xx=r(Sd);Zs=s(xx,"A",{href:!0,rel:!0});var $x=r(Zs);T2=c($x,"Just-In-Time (JIT) compilation"),$x.forEach(o),xx.forEach(o),M2=d(Uo),Kd=s(Uo,"LI",{});var wx=r(Kd);er=s(wx,"A",{href:!0,rel:!0});var Dx=r(er);N2=c(Dx,"Automatic Differentiation"),Dx.forEach(o),wx.forEach(o),A2=d(Uo),Wd=s(Uo,"LI",{});var kx=r(Wd);tr=s(kx,"A",{href:!0,rel:!0});var Tx=r(tr);E2=c(Tx,"Vectorization"),Tx.forEach(o),kx.forEach(o),U2=d(Uo),Xd=s(Uo,"LI",{});var Mx=r(Xd);or=s(Mx,"A",{href:!0,rel:!0});var Nx=r(or);C2=c(Nx,"Parallelization"),Nx.forEach(o),Mx.forEach(o),Uo.forEach(o),le.forEach(o),Mc=d(t),pt=s(t,"H2",{class:!0});var Ym=r(pt);ho=s(Ym,"A",{id:!0,class:!0,href:!0});var Ax=r(ho);Hd=s(Ax,"SPAN",{});var Ex=r(Hd);u(nr.$$.fragment,Ex),Ex.forEach(o),Ax.forEach(o),F2=d(Ym),Rd=s(Ym,"SPAN",{});var Ux=r(Rd);P2=c(Ux,"FlaxDecoderOutput"),Ux.forEach(o),Ym.forEach(o),Nc=d(t),ue=s(t,"DIV",{class:!0});var ya=r(ue);u(sr.$$.fragment,ya),O2=d(ya),Qd=s(ya,"P",{});var Cx=r(Qd);L2=c(Cx,"Output of decoding method."),Cx.forEach(o),q2=d(ya),_o=s(ya,"DIV",{class:!0});var Gm=r(_o);u(rr.$$.fragment,Gm),j2=d(Gm),Yd=s(Gm,"P",{});var Fx=r(Yd);I2=c(Fx,"\u201CReturns a new object replacing the specified fields with new values."),Fx.forEach(o),Gm.forEach(o),ya.forEach(o),Ac=d(t),ft=s(t,"H2",{class:!0});var Jm=r(ft);go=s(Jm,"A",{id:!0,class:!0,href:!0});var Px=r(go);Gd=s(Px,"SPAN",{});var Ox=r(Gd);u(ar.$$.fragment,Ox),Ox.forEach(o),Px.forEach(o),z2=d(Jm),Jd=s(Jm,"SPAN",{});var Lx=r(Jd);V2=c(Lx,"FlaxAutoencoderKLOutput"),Lx.forEach(o),Jm.forEach(o),Ec=d(t),he=s(t,"DIV",{class:!0});var xa=r(he);u(ir.$$.fragment,xa),B2=d(xa),Zd=s(xa,"P",{});var qx=r(Zd);S2=c(qx,"Output of AutoencoderKL encoding method."),qx.forEach(o),K2=d(xa),bo=s(xa,"DIV",{class:!0});var Zm=r(bo);u(dr.$$.fragment,Zm),W2=d(Zm),el=s(Zm,"P",{});var jx=r(el);X2=c(jx,"\u201CReturns a new object replacing the specified fields with new values."),jx.forEach(o),Zm.forEach(o),xa.forEach(o),Uc=d(t),ut=s(t,"H2",{class:!0});var ep=r(ut);vo=s(ep,"A",{id:!0,class:!0,href:!0});var Ix=r(vo);tl=s(Ix,"SPAN",{});var zx=r(tl);u(lr.$$.fragment,zx),zx.forEach(o),Ix.forEach(o),H2=d(ep),ol=s(ep,"SPAN",{});var Vx=r(ol);R2=c(Vx,"FlaxAutoencoderKL"),Vx.forEach(o),ep.forEach(o),Cc=d(t),S=s(t,"DIV",{class:!0});var Ce=r(S);u(cr.$$.fragment,Ce),Q2=d(Ce),nl=s(Ce,"P",{});var Bx=r(nl);Y2=c(Bx,`Flax Implementation of Variational Autoencoder (VAE) model with KL loss from the paper Auto-Encoding Variational
Bayes by Diederik P. Kingma and Max Welling.`),Bx.forEach(o),G2=d(Ce),mr=s(Ce,"P",{});var tp=r(mr);J2=c(tp,"This model is a Flax Linen "),pr=s(tp,"A",{href:!0,rel:!0});var Sx=r(pr);Z2=c(Sx,"flax.linen.Module"),Sx.forEach(o),eb=c(tp,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),tp.forEach(o),tb=d(Ce),sl=s(Ce,"P",{});var Kx=r(sl);ob=c(Kx,"Finally, this model supports inherent JAX features such as:"),Kx.forEach(o),nb=d(Ce),_e=s(Ce,"UL",{});var Co=r(_e);rl=s(Co,"LI",{});var Wx=r(rl);fr=s(Wx,"A",{href:!0,rel:!0});var Xx=r(fr);sb=c(Xx,"Just-In-Time (JIT) compilation"),Xx.forEach(o),Wx.forEach(o),rb=d(Co),al=s(Co,"LI",{});var Hx=r(al);ur=s(Hx,"A",{href:!0,rel:!0});var Rx=r(ur);ab=c(Rx,"Automatic Differentiation"),Rx.forEach(o),Hx.forEach(o),ib=d(Co),il=s(Co,"LI",{});var Qx=r(il);hr=s(Qx,"A",{href:!0,rel:!0});var Yx=r(hr);db=c(Yx,"Vectorization"),Yx.forEach(o),Qx.forEach(o),lb=d(Co),dl=s(Co,"LI",{});var Gx=r(dl);_r=s(Gx,"A",{href:!0,rel:!0});var Jx=r(_r);cb=c(Jx,"Parallelization"),Jx.forEach(o),Gx.forEach(o),Co.forEach(o),Ce.forEach(o),Fc=d(t),ht=s(t,"H2",{class:!0});var op=r(ht);yo=s(op,"A",{id:!0,class:!0,href:!0});var Zx=r(yo);ll=s(Zx,"SPAN",{});var e$=r(ll);u(gr.$$.fragment,e$),e$.forEach(o),Zx.forEach(o),mb=d(op),cl=s(op,"SPAN",{});var t$=r(cl);pb=c(t$,"FlaxControlNetOutput"),t$.forEach(o),op.forEach(o),Pc=d(t),_t=s(t,"DIV",{class:!0});var np=r(_t);u(br.$$.fragment,np),fb=d(np),xo=s(np,"DIV",{class:!0});var sp=r(xo);u(vr.$$.fragment,sp),ub=d(sp),ml=s(sp,"P",{});var o$=r(ml);hb=c(o$,"\u201CReturns a new object replacing the specified fields with new values."),o$.forEach(o),sp.forEach(o),np.forEach(o),Oc=d(t),gt=s(t,"H2",{class:!0});var rp=r(gt);$o=s(rp,"A",{id:!0,class:!0,href:!0});var n$=r($o);pl=s(n$,"SPAN",{});var s$=r(pl);u(yr.$$.fragment,s$),s$.forEach(o),n$.forEach(o),_b=d(rp),fl=s(rp,"SPAN",{});var r$=r(fl);gb=c(r$,"FlaxControlNetModel"),r$.forEach(o),rp.forEach(o),Lc=d(t),j=s(t,"DIV",{class:!0});var ce=r(j);u(xr.$$.fragment,ce),bb=d(ce),$r=s(ce,"P",{});var ap=r($r);vb=c(ap,"Quoting from "),wr=s(ap,"A",{href:!0,rel:!0});var a$=r(wr);yb=c(a$,"https://arxiv.org/abs/2302.05543"),a$.forEach(o),xb=c(ap,`: \u201CStable Diffusion uses a pre-processing method similar to VQ-GAN
[11] to convert the entire dataset of 512 \xD7 512 images into smaller 64 \xD7 64 \u201Clatent images\u201D for stabilized
training. This requires ControlNets to convert image-based conditions to 64 \xD7 64 feature space to match the
convolution size. We use a tiny network E(\xB7) of four convolution layers with 4 \xD7 4 kernels and 2 \xD7 2 strides
(activated by ReLU, channels are 16, 32, 64, 128, initialized with Gaussian weights, trained jointly with the full
model) to encode image-space conditions \u2026 into feature maps \u2026\u201D`),ap.forEach(o),$b=d(ce),Dr=s(ce,"P",{});var ip=r(Dr);wb=c(ip,"This model inherits from "),ma=s(ip,"A",{href:!0});var i$=r(ma);Db=c(i$,"FlaxModelMixin"),i$.forEach(o),kb=c(ip,`. Check the superclass documentation for the generic methods the library
implements for all the models (such as downloading or saving, etc.)`),ip.forEach(o),Tb=d(ce),kr=s(ce,"P",{});var dp=r(kr);Mb=c(dp,"Also, this model is a Flax Linen "),Tr=s(dp,"A",{href:!0,rel:!0});var d$=r(Tr);Nb=c(d$,"flax.linen.Module"),d$.forEach(o),Ab=c(dp,`
subclass. Use it as a regular Flax linen Module and refer to the Flax documentation for all matter related to
general usage and behavior.`),dp.forEach(o),Eb=d(ce),ul=s(ce,"P",{});var l$=r(ul);Ub=c(l$,"Finally, this model supports inherent JAX features such as:"),l$.forEach(o),Cb=d(ce),ge=s(ce,"UL",{});var Fo=r(ge);hl=s(Fo,"LI",{});var c$=r(hl);Mr=s(c$,"A",{href:!0,rel:!0});var m$=r(Mr);Fb=c(m$,"Just-In-Time (JIT) compilation"),m$.forEach(o),c$.forEach(o),Pb=d(Fo),_l=s(Fo,"LI",{});var p$=r(_l);Nr=s(p$,"A",{href:!0,rel:!0});var f$=r(Nr);Ob=c(f$,"Automatic Differentiation"),f$.forEach(o),p$.forEach(o),Lb=d(Fo),gl=s(Fo,"LI",{});var u$=r(gl);Ar=s(u$,"A",{href:!0,rel:!0});var h$=r(Ar);qb=c(h$,"Vectorization"),h$.forEach(o),u$.forEach(o),jb=d(Fo),bl=s(Fo,"LI",{});var _$=r(bl);Er=s(_$,"A",{href:!0,rel:!0});var g$=r(Er);Ib=c(g$,"Parallelization"),g$.forEach(o),_$.forEach(o),Fo.forEach(o),ce.forEach(o),this.h()},h(){a(x,"name","hf:doc:metadata"),a(x,"content",JSON.stringify(C$)),a($,"id","models"),a($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a($,"href","#models"),a(D,"class","relative group"),a(vt,"id","diffusers.ModelMixin"),a(vt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(vt,"href","#diffusers.ModelMixin"),a(Pe,"class","relative group"),a(Or,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(Lr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin.save_pretrained"),a(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Tt,"id","diffusers.models.unet_2d.UNet2DOutput"),a(Tt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Tt,"href","#diffusers.models.unet_2d.UNet2DOutput"),a(Le,"class","relative group"),a(Ho,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Mt,"id","diffusers.UNet2DModel"),a(Mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Mt,"href","#diffusers.UNet2DModel"),a(qe,"class","relative group"),a(qr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(jr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Nt,"id","diffusers.models.unet_1d.UNet1DOutput"),a(Nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Nt,"href","#diffusers.models.unet_1d.UNet1DOutput"),a(je,"class","relative group"),a(en,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(At,"id","diffusers.UNet1DModel"),a(At,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(At,"href","#diffusers.UNet1DModel"),a(Ie,"class","relative group"),a(Ir,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(zr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Et,"id","diffusers.models.unet_2d_condition.UNet2DConditionOutput"),a(Et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Et,"href","#diffusers.models.unet_2d_condition.UNet2DConditionOutput"),a(ze,"class","relative group"),a(dn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ut,"id","diffusers.UNet2DConditionModel"),a(Ut,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ut,"href","#diffusers.UNet2DConditionModel"),a(Ve,"class","relative group"),a(Vr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(Br,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Sr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ft,"id","diffusers.models.unet_3d_condition.UNet3DConditionOutput"),a(Ft,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ft,"href","#diffusers.models.unet_3d_condition.UNet3DConditionOutput"),a(Be,"class","relative group"),a(bn,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Pt,"id","diffusers.UNet3DConditionModel"),a(Pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Pt,"href","#diffusers.UNet3DConditionModel"),a(Se,"class","relative group"),a(Kr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(Wr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Xr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Lt,"id","diffusers.models.vae.DecoderOutput"),a(Lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Lt,"href","#diffusers.models.vae.DecoderOutput"),a(Ke,"class","relative group"),a(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(qt,"id","diffusers.models.vq_model.VQEncoderOutput"),a(qt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(qt,"href","#diffusers.models.vq_model.VQEncoderOutput"),a(Xe,"class","relative group"),a(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(jt,"id","diffusers.VQModel"),a(jt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(jt,"href","#diffusers.VQModel"),a(Re,"class","relative group"),a(Hr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(Rr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(It,"id","diffusers.models.autoencoder_kl.AutoencoderKLOutput"),a(It,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(It,"href","#diffusers.models.autoencoder_kl.AutoencoderKLOutput"),a(Qe,"class","relative group"),a(Ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(zt,"id","diffusers.AutoencoderKL"),a(zt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(zt,"href","#diffusers.AutoencoderKL"),a(Ge,"class","relative group"),a(Qr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(Vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Bt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(St,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Yr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Ht,"id","diffusers.Transformer2DModel"),a(Ht,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Ht,"href","#diffusers.Transformer2DModel"),a(Je,"class","relative group"),a(Gr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Rt,"id","diffusers.models.transformer_2d.Transformer2DModelOutput"),a(Rt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Rt,"href","#diffusers.models.transformer_2d.Transformer2DModelOutput"),a(Ze,"class","relative group"),a(es,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Qt,"id","diffusers.models.transformer_temporal.TransformerTemporalModel"),a(Qt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Qt,"href","#diffusers.models.transformer_temporal.TransformerTemporalModel"),a(et,"class","relative group"),a(Jr,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Yt,"id","diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),a(Yt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Yt,"href","#diffusers.models.transformer_temporal.TransformerTemporalModelOutput"),a(tt,"class","relative group"),a(as,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Gt,"id","diffusers.PriorTransformer"),a(Gt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Gt,"href","#diffusers.PriorTransformer"),a(ot,"class","relative group"),a(Zr,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(ms,"href","https://arxiv.org/abs/2204.06125"),a(ms,"rel","nofollow"),a(ta,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Jt,"id","diffusers.models.prior_transformer.PriorTransformerOutput"),a(Jt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Jt,"href","#diffusers.models.prior_transformer.PriorTransformerOutput"),a(nt,"class","relative group"),a(us,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(Zt,"id","diffusers.models.controlnet.ControlNetOutput"),a(Zt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(Zt,"href","#diffusers.models.controlnet.ControlNetOutput"),a(st,"class","relative group"),a(gs,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(eo,"id","diffusers.ControlNetModel"),a(eo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(eo,"href","#diffusers.ControlNetModel"),a(rt,"class","relative group"),a(to,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(oa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(oo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(no,"id","diffusers.T2IAdapter"),a(no,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(no,"href","#diffusers.T2IAdapter"),a(at,"class","relative group"),a(na,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.UNet2DConditionModel"),a(Ms,"href","https://github.com/TencentARC/T2I-Adapter/blob/686de4681515662c0ac2ffa07bf5dda83af1038a/ldm/modules/encoders/adapter.py#L97"),a(Ms,"rel","nofollow"),a(Ns,"href","https://github.com/TencentARC/T2I-Adapter/blob/686de4681515662c0ac2ffa07bf5dda83af1038a/ldm/modules/encoders/adapter.py#L235"),a(Ns,"rel","nofollow"),a(sa,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(ra,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(so,"id","diffusers.MultiAdapter"),a(so,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(so,"href","#diffusers.MultiAdapter"),a(it,"class","relative group"),a(aa,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.ModelMixin"),a(ia,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ro,"id","diffusers.FlaxModelMixin"),a(ro,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(ro,"href","#diffusers.FlaxModelMixin"),a(dt,"class","relative group"),a(la,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxModelMixin"),a(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(io,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(po,"id","diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput"),a(po,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(po,"href","#diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput"),a(lt,"class","relative group"),a(fo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(uo,"id","diffusers.FlaxUNet2DConditionModel"),a(uo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(uo,"href","#diffusers.FlaxUNet2DConditionModel"),a(mt,"class","relative group"),a(ca,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxModelMixin"),a(Js,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(Js,"rel","nofollow"),a(Zs,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(Zs,"rel","nofollow"),a(er,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(er,"rel","nofollow"),a(tr,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(tr,"rel","nofollow"),a(or,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(or,"rel","nofollow"),a(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ho,"id","diffusers.models.vae_flax.FlaxDecoderOutput"),a(ho,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(ho,"href","#diffusers.models.vae_flax.FlaxDecoderOutput"),a(pt,"class","relative group"),a(_o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(go,"id","diffusers.models.vae_flax.FlaxAutoencoderKLOutput"),a(go,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(go,"href","#diffusers.models.vae_flax.FlaxAutoencoderKLOutput"),a(ft,"class","relative group"),a(bo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(vo,"id","diffusers.FlaxAutoencoderKL"),a(vo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(vo,"href","#diffusers.FlaxAutoencoderKL"),a(ut,"class","relative group"),a(pr,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(pr,"rel","nofollow"),a(fr,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(fr,"rel","nofollow"),a(ur,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(ur,"rel","nofollow"),a(hr,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(hr,"rel","nofollow"),a(_r,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(_r,"rel","nofollow"),a(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(yo,"id","diffusers.models.controlnet_flax.FlaxControlNetOutput"),a(yo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(yo,"href","#diffusers.models.controlnet_flax.FlaxControlNetOutput"),a(ht,"class","relative group"),a(xo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(_t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a($o,"id","diffusers.FlaxControlNetModel"),a($o,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a($o,"href","#diffusers.FlaxControlNetModel"),a(gt,"class","relative group"),a(wr,"href","https://arxiv.org/abs/2302.05543"),a(wr,"rel","nofollow"),a(ma,"href","/docs/diffusers/pr_2555/en/api/models#diffusers.FlaxModelMixin"),a(Tr,"href","https://flax.readthedocs.io/en/latest/flax.linen.html#module"),a(Tr,"rel","nofollow"),a(Mr,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),a(Mr,"rel","nofollow"),a(Nr,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),a(Nr,"rel","nofollow"),a(Ar,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),a(Ar,"rel","nofollow"),a(Er,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),a(Er,"rel","nofollow"),a(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,m){e(document.head,x),p(t,M,m),p(t,D,m),e(D,$),e($,k),h(v,k,null),e(D,w),e(D,re),e(re,Fe),p(t,Q,m),p(t,Y,m),e(Y,Fr),e(Y,$a),e($a,lp),e(Y,cp),e(Y,wa),e(wa,mp),e(Y,pp),p(t,Ml,m),p(t,Pe,m),e(Pe,vt),e(vt,Da),h(Po,Da,null),e(Pe,fp),e(Pe,ka),e(ka,up),p(t,Nl,m),p(t,N,m),h(Oo,N,null),e(N,hp),e(N,Ta),e(Ta,_p),e(N,gp),e(N,Pr),e(Pr,Or),e(Or,bp),e(Pr,vp),e(N,yp),e(N,Ma),e(Ma,be),e(be,Na),e(Na,xp),e(be,$p),e(be,Aa),e(Aa,wp),e(be,Dp),e(be,Lr),e(Lr,kp),e(be,Tp),e(N,Mp),e(N,ve),h(Lo,ve,null),e(ve,Np),e(ve,Ea),e(Ea,Ap),e(ve,Ep),e(ve,Ua),e(Ua,Up),e(N,Cp),e(N,yt),h(qo,yt,null),e(yt,Fp),e(yt,Ca),e(Ca,Pp),e(N,Op),e(N,ye),h(jo,ye,null),e(ye,Lp),e(ye,Fa),e(Fa,qp),e(ye,jp),e(ye,Pa),e(Pa,Ip),e(N,zp),e(N,K),h(Io,K,null),e(K,Vp),e(K,Oa),e(Oa,Bp),e(K,Sp),e(K,La),e(La,Kp),e(K,Wp),e(K,qa),e(qa,Xp),e(K,Hp),h(xt,K,null),e(N,Rp),e(N,O),h(zo,O,null),e(O,Qp),e(O,ja),e(ja,Yp),e(O,Gp),e(O,Oe),e(Oe,Jp),e(Oe,Ia),e(Ia,Zp),e(Oe,ef),e(Oe,za),e(za,tf),e(Oe,of),e(O,nf),e(O,Vo),e(Vo,sf),e(Vo,Va),e(Va,rf),e(Vo,af),e(O,df),e(O,Bo),e(Bo,lf),e(Bo,Ba),e(Ba,cf),e(Bo,mf),e(O,pf),h($t,O,null),e(O,ff),h(wt,O,null),e(N,uf),e(N,Dt),h(So,Dt,null),e(Dt,hf),e(Dt,Sa),e(Sa,_f),e(N,gf),e(N,kt),h(Ko,kt,null),e(kt,bf),e(kt,Wo),e(Wo,vf),e(Wo,Ka),e(Ka,yf),e(Wo,xf),p(t,Al,m),p(t,Le,m),e(Le,Tt),e(Tt,Wa),h(Xo,Wa,null),e(Le,$f),e(Le,Xa),e(Xa,wf),p(t,El,m),p(t,Ho,m),h(Ro,Ho,null),p(t,Ul,m),p(t,qe,m),e(qe,Mt),e(Mt,Ha),h(Qo,Ha,null),e(qe,Df),e(qe,Ra),e(Ra,kf),p(t,Cl,m),p(t,G,m),h(Yo,G,null),e(G,Tf),e(G,Qa),e(Qa,Mf),e(G,Nf),e(G,Go),e(Go,Af),e(Go,qr),e(qr,Ef),e(Go,Uf),e(G,Cf),e(G,jr),h(Jo,jr,null),p(t,Fl,m),p(t,je,m),e(je,Nt),e(Nt,Ya),h(Zo,Ya,null),e(je,Ff),e(je,Ga),e(Ga,Pf),p(t,Pl,m),p(t,en,m),h(tn,en,null),p(t,Ol,m),p(t,Ie,m),e(Ie,At),e(At,Ja),h(on,Ja,null),e(Ie,Of),e(Ie,Za),e(Za,Lf),p(t,Ll,m),p(t,J,m),h(nn,J,null),e(J,qf),e(J,ei),e(ei,jf),e(J,If),e(J,sn),e(sn,zf),e(sn,Ir),e(Ir,Vf),e(sn,Bf),e(J,Sf),e(J,zr),h(rn,zr,null),p(t,ql,m),p(t,ze,m),e(ze,Et),e(Et,ti),h(an,ti,null),e(ze,Kf),e(ze,oi),e(oi,Wf),p(t,jl,m),p(t,dn,m),h(ln,dn,null),p(t,Il,m),p(t,Ve,m),e(Ve,Ut),e(Ut,ni),h(cn,ni,null),e(Ve,Xf),e(Ve,si),e(si,Hf),p(t,zl,m),p(t,F,m),h(mn,F,null),e(F,Rf),e(F,ri),e(ri,Qf),e(F,Yf),e(F,pn),e(pn,Gf),e(pn,Vr),e(Vr,Jf),e(pn,Zf),e(F,eu),e(F,Br),h(fn,Br,null),e(F,tu),e(F,xe),h(un,xe,null),e(xe,ou),e(xe,ai),e(ai,nu),e(xe,su),e(xe,ii),e(ii,ru),e(F,au),e(F,Sr),h(hn,Sr,null),e(F,iu),e(F,Ct),h(_n,Ct,null),e(Ct,du),e(Ct,di),e(di,lu),p(t,Vl,m),p(t,Be,m),e(Be,Ft),e(Ft,li),h(gn,li,null),e(Be,cu),e(Be,ci),e(ci,mu),p(t,Bl,m),p(t,bn,m),h(vn,bn,null),p(t,Sl,m),p(t,Se,m),e(Se,Pt),e(Pt,mi),h(yn,mi,null),e(Se,pu),e(Se,pi),e(pi,fu),p(t,Kl,m),p(t,P,m),h(xn,P,null),e(P,uu),e(P,fi),e(fi,hu),e(P,_u),e(P,$n),e($n,gu),e($n,Kr),e(Kr,bu),e($n,vu),e(P,yu),e(P,Wr),h(wn,Wr,null),e(P,xu),e(P,$e),h(Dn,$e,null),e($e,$u),e($e,ui),e(ui,wu),e($e,Du),e($e,hi),e(hi,ku),e(P,Tu),e(P,Xr),h(kn,Xr,null),e(P,Mu),e(P,Ot),h(Tn,Ot,null),e(Ot,Nu),e(Ot,_i),e(_i,Au),p(t,Wl,m),p(t,Ke,m),e(Ke,Lt),e(Lt,gi),h(Mn,gi,null),e(Ke,Eu),e(Ke,bi),e(bi,Uu),p(t,Xl,m),p(t,We,m),h(Nn,We,null),e(We,Cu),e(We,vi),e(vi,Fu),p(t,Hl,m),p(t,Xe,m),e(Xe,qt),e(qt,yi),h(An,yi,null),e(Xe,Pu),e(Xe,xi),e(xi,Ou),p(t,Rl,m),p(t,He,m),h(En,He,null),e(He,Lu),e(He,$i),e($i,qu),p(t,Ql,m),p(t,Re,m),e(Re,jt),e(jt,wi),h(Un,wi,null),e(Re,ju),e(Re,Di),e(Di,Iu),p(t,Yl,m),p(t,Z,m),h(Cn,Z,null),e(Z,zu),e(Z,ki),e(ki,Vu),e(Z,Bu),e(Z,Fn),e(Fn,Su),e(Fn,Hr),e(Hr,Ku),e(Fn,Wu),e(Z,Xu),e(Z,Rr),h(Pn,Rr,null),p(t,Gl,m),p(t,Qe,m),e(Qe,It),e(It,Ti),h(On,Ti,null),e(Qe,Hu),e(Qe,Mi),e(Mi,Ru),p(t,Jl,m),p(t,Ye,m),h(Ln,Ye,null),e(Ye,Qu),e(Ye,Ni),e(Ni,Yu),p(t,Zl,m),p(t,Ge,m),e(Ge,zt),e(zt,Ai),h(qn,Ai,null),e(Ge,Gu),e(Ge,Ei),e(Ei,Ju),p(t,ec,m),p(t,A,m),h(jn,A,null),e(A,Zu),e(A,Ui),e(Ui,eh),e(A,th),e(A,In),e(In,oh),e(In,Qr),e(Qr,nh),e(In,sh),e(A,rh),e(A,Vt),h(zn,Vt,null),e(Vt,ah),e(Vt,Vn),e(Vn,ih),e(Vn,Ci),e(Ci,dh),e(Vn,lh),e(A,ch),e(A,Bt),h(Bn,Bt,null),e(Bt,mh),e(Bt,Sn),e(Sn,ph),e(Sn,Fi),e(Fi,fh),e(Sn,uh),e(A,hh),e(A,St),h(Kn,St,null),e(St,_h),e(St,Pi),e(Pi,gh),e(A,bh),e(A,Kt),h(Wn,Kt,null),e(Kt,vh),e(Kt,Oi),e(Oi,yh),e(A,xh),e(A,Yr),h(Xn,Yr,null),e(A,$h),e(A,Wt),h(Hn,Wt,null),e(Wt,wh),e(Wt,Li),e(Li,Dh),e(A,kh),e(A,Xt),h(Rn,Xt,null),e(Xt,Th),e(Xt,qi),e(qi,Mh),p(t,tc,m),p(t,Je,m),e(Je,Ht),e(Ht,ji),h(Qn,ji,null),e(Je,Nh),e(Je,Ii),e(Ii,Ah),p(t,oc,m),p(t,L,m),h(Yn,L,null),e(L,Eh),e(L,zi),e(zi,Uh),e(L,Ch),e(L,Vi),e(Vi,Fh),e(L,Ph),e(L,Gn),e(Gn,Oh),e(Gn,Bi),e(Bi,Lh),e(Gn,qh),e(L,jh),e(L,Si),e(Si,Ih),e(L,zh),e(L,Gr),h(Jn,Gr,null),p(t,nc,m),p(t,Ze,m),e(Ze,Rt),e(Rt,Ki),h(Zn,Ki,null),e(Ze,Vh),e(Ze,Wi),e(Wi,Bh),p(t,sc,m),p(t,es,m),h(ts,es,null),p(t,rc,m),p(t,et,m),e(et,Qt),e(Qt,Xi),h(os,Xi,null),e(et,Sh),e(et,Hi),e(Hi,Kh),p(t,ac,m),p(t,me,m),h(ns,me,null),e(me,Wh),e(me,Ri),e(Ri,Xh),e(me,Hh),e(me,Jr),h(ss,Jr,null),p(t,ic,m),p(t,tt,m),e(tt,Yt),e(Yt,Qi),h(rs,Qi,null),e(tt,Rh),e(tt,Yi),e(Yi,Qh),p(t,dc,m),p(t,as,m),h(is,as,null),p(t,lc,m),p(t,ot,m),e(ot,Gt),e(Gt,Gi),h(ds,Gi,null),e(ot,Yh),e(ot,Ji),e(Ji,Gh),p(t,cc,m),p(t,V,m),h(ls,V,null),e(V,Jh),e(V,Zi),e(Zi,Zh),e(V,e_),e(V,cs),e(cs,t_),e(cs,Zr),e(Zr,o_),e(cs,n_),e(V,s_),e(V,ea),e(ea,r_),e(ea,ms),e(ms,a_),e(V,i_),e(V,ta),h(ps,ta,null),p(t,mc,m),p(t,nt,m),e(nt,Jt),e(Jt,ed),h(fs,ed,null),e(nt,d_),e(nt,td),e(td,l_),p(t,pc,m),p(t,us,m),h(hs,us,null),p(t,fc,m),p(t,st,m),e(st,Zt),e(Zt,od),h(_s,od,null),e(st,c_),e(st,nd),e(nd,m_),p(t,uc,m),p(t,gs,m),h(bs,gs,null),p(t,hc,m),p(t,rt,m),e(rt,eo),e(eo,sd),h(vs,sd,null),e(rt,p_),e(rt,rd),e(rd,f_),p(t,_c,m),p(t,B,m),h(ys,B,null),e(B,u_),e(B,to),h(xs,to,null),e(to,h_),e(to,ad),e(ad,__),e(B,g_),e(B,we),h($s,we,null),e(we,b_),e(we,id),e(id,v_),e(we,y_),e(we,dd),e(dd,x_),e(B,$_),e(B,oa),h(ws,oa,null),e(B,w_),e(B,oo),h(Ds,oo,null),e(oo,D_),e(oo,ld),e(ld,k_),p(t,gc,m),p(t,at,m),e(at,no),e(no,cd),h(ks,cd,null),e(at,T_),e(at,md),e(md,M_),p(t,bc,m),p(t,ee,m),h(Ts,ee,null),e(ee,N_),e(ee,pe),e(pe,A_),e(pe,na),e(na,E_),e(pe,U_),e(pe,Ms),e(Ms,C_),e(pe,F_),e(pe,Ns),e(Ns,P_),e(pe,O_),e(ee,L_),e(ee,As),e(As,q_),e(As,sa),e(sa,j_),e(As,I_),e(ee,z_),e(ee,ra),h(Es,ra,null),p(t,vc,m),p(t,it,m),e(it,so),e(so,pd),h(Us,pd,null),e(it,V_),e(it,fd),e(fd,B_),p(t,yc,m),p(t,te,m),h(Cs,te,null),e(te,S_),e(te,ud),e(ud,K_),e(te,W_),e(te,Fs),e(Fs,X_),e(Fs,aa),e(aa,H_),e(Fs,R_),e(te,Q_),e(te,ia),h(Ps,ia,null),p(t,xc,m),p(t,dt,m),e(dt,ro),e(ro,hd),h(Os,hd,null),e(dt,Y_),e(dt,_d),e(_d,G_),p(t,$c,m),p(t,U,m),h(Ls,U,null),e(U,J_),e(U,gd),e(gd,Z_),e(U,eg),e(U,da),e(da,la),e(la,tg),e(da,og),e(U,ng),e(U,W),h(qs,W,null),e(W,sg),e(W,bd),e(bd,rg),e(W,ag),e(W,js),e(js,ig),e(js,vd),e(vd,dg),e(js,lg),e(W,cg),e(W,Is),e(Is,mg),e(Is,yd),e(yd,pg),e(Is,fg),e(W,ug),h(ao,W,null),e(U,hg),e(U,io),h(zs,io,null),e(io,_g),e(io,Vs),e(Vs,gg),e(Vs,xd),e(xd,bg),e(Vs,vg),e(U,yg),e(U,ae),h(Bs,ae,null),e(ae,xg),e(ae,oe),e(oe,$g),e(oe,$d),e($d,wg),e(oe,Dg),e(oe,wd),e(wd,kg),e(oe,Tg),e(oe,Dd),e(Dd,Mg),e(oe,Ng),e(oe,kd),e(kd,Ag),e(oe,Eg),e(ae,Ug),e(ae,Td),e(Td,Cg),e(ae,Fg),h(lo,ae,null),e(U,Pg),e(U,ie),h(Ss,ie,null),e(ie,Og),e(ie,ne),e(ne,Lg),e(ne,Md),e(Md,qg),e(ne,jg),e(ne,Nd),e(Nd,Ig),e(ne,zg),e(ne,Ad),e(Ad,Vg),e(ne,Bg),e(ne,Ed),e(Ed,Sg),e(ne,Kg),e(ie,Wg),e(ie,Ud),e(Ud,Xg),e(ie,Hg),h(co,ie,null),e(U,Rg),e(U,De),h(Ks,De,null),e(De,Qg),e(De,se),e(se,Yg),e(se,Cd),e(Cd,Gg),e(se,Jg),e(se,Fd),e(Fd,Zg),e(se,e2),e(se,Pd),e(Pd,t2),e(se,o2),e(se,Od),e(Od,n2),e(se,s2),e(De,r2),h(mo,De,null),p(t,wc,m),p(t,lt,m),e(lt,po),e(po,Ld),h(Ws,Ld,null),e(lt,a2),e(lt,qd),e(qd,i2),p(t,Dc,m),p(t,ct,m),h(Xs,ct,null),e(ct,d2),e(ct,fo),h(Hs,fo,null),e(fo,l2),e(fo,jd),e(jd,c2),p(t,kc,m),p(t,mt,m),e(mt,uo),e(uo,Id),h(Rs,Id,null),e(mt,m2),e(mt,zd),e(zd,p2),p(t,Tc,m),p(t,q,m),h(Qs,q,null),e(q,f2),e(q,Vd),e(Vd,u2),e(q,h2),e(q,Ys),e(Ys,_2),e(Ys,ca),e(ca,g2),e(Ys,b2),e(q,v2),e(q,Gs),e(Gs,y2),e(Gs,Js),e(Js,x2),e(Gs,$2),e(q,w2),e(q,Bd),e(Bd,D2),e(q,k2),e(q,fe),e(fe,Sd),e(Sd,Zs),e(Zs,T2),e(fe,M2),e(fe,Kd),e(Kd,er),e(er,N2),e(fe,A2),e(fe,Wd),e(Wd,tr),e(tr,E2),e(fe,U2),e(fe,Xd),e(Xd,or),e(or,C2),p(t,Mc,m),p(t,pt,m),e(pt,ho),e(ho,Hd),h(nr,Hd,null),e(pt,F2),e(pt,Rd),e(Rd,P2),p(t,Nc,m),p(t,ue,m),h(sr,ue,null),e(ue,O2),e(ue,Qd),e(Qd,L2),e(ue,q2),e(ue,_o),h(rr,_o,null),e(_o,j2),e(_o,Yd),e(Yd,I2),p(t,Ac,m),p(t,ft,m),e(ft,go),e(go,Gd),h(ar,Gd,null),e(ft,z2),e(ft,Jd),e(Jd,V2),p(t,Ec,m),p(t,he,m),h(ir,he,null),e(he,B2),e(he,Zd),e(Zd,S2),e(he,K2),e(he,bo),h(dr,bo,null),e(bo,W2),e(bo,el),e(el,X2),p(t,Uc,m),p(t,ut,m),e(ut,vo),e(vo,tl),h(lr,tl,null),e(ut,H2),e(ut,ol),e(ol,R2),p(t,Cc,m),p(t,S,m),h(cr,S,null),e(S,Q2),e(S,nl),e(nl,Y2),e(S,G2),e(S,mr),e(mr,J2),e(mr,pr),e(pr,Z2),e(mr,eb),e(S,tb),e(S,sl),e(sl,ob),e(S,nb),e(S,_e),e(_e,rl),e(rl,fr),e(fr,sb),e(_e,rb),e(_e,al),e(al,ur),e(ur,ab),e(_e,ib),e(_e,il),e(il,hr),e(hr,db),e(_e,lb),e(_e,dl),e(dl,_r),e(_r,cb),p(t,Fc,m),p(t,ht,m),e(ht,yo),e(yo,ll),h(gr,ll,null),e(ht,mb),e(ht,cl),e(cl,pb),p(t,Pc,m),p(t,_t,m),h(br,_t,null),e(_t,fb),e(_t,xo),h(vr,xo,null),e(xo,ub),e(xo,ml),e(ml,hb),p(t,Oc,m),p(t,gt,m),e(gt,$o),e($o,pl),h(yr,pl,null),e(gt,_b),e(gt,fl),e(fl,gb),p(t,Lc,m),p(t,j,m),h(xr,j,null),e(j,bb),e(j,$r),e($r,vb),e($r,wr),e(wr,yb),e($r,xb),e(j,$b),e(j,Dr),e(Dr,wb),e(Dr,ma),e(ma,Db),e(Dr,kb),e(j,Tb),e(j,kr),e(kr,Mb),e(kr,Tr),e(Tr,Nb),e(kr,Ab),e(j,Eb),e(j,ul),e(ul,Ub),e(j,Cb),e(j,ge),e(ge,hl),e(hl,Mr),e(Mr,Fb),e(ge,Pb),e(ge,_l),e(_l,Nr),e(Nr,Ob),e(ge,Lb),e(ge,gl),e(gl,Ar),e(Ar,qb),e(ge,jb),e(ge,bl),e(bl,Er),e(Er,Ib),qc=!0},p(t,[m]){const Ur={};m&2&&(Ur.$$scope={dirty:m,ctx:t}),xt.$set(Ur);const vl={};m&2&&(vl.$$scope={dirty:m,ctx:t}),$t.$set(vl);const yl={};m&2&&(yl.$$scope={dirty:m,ctx:t}),wt.$set(yl);const xl={};m&2&&(xl.$$scope={dirty:m,ctx:t}),ao.$set(xl);const bt={};m&2&&(bt.$$scope={dirty:m,ctx:t}),lo.$set(bt);const $l={};m&2&&($l.$$scope={dirty:m,ctx:t}),co.$set($l);const wl={};m&2&&(wl.$$scope={dirty:m,ctx:t}),mo.$set(wl)},i(t){qc||(_(v.$$.fragment,t),_(Po.$$.fragment,t),_(Oo.$$.fragment,t),_(Lo.$$.fragment,t),_(qo.$$.fragment,t),_(jo.$$.fragment,t),_(Io.$$.fragment,t),_(xt.$$.fragment,t),_(zo.$$.fragment,t),_($t.$$.fragment,t),_(wt.$$.fragment,t),_(So.$$.fragment,t),_(Ko.$$.fragment,t),_(Xo.$$.fragment,t),_(Ro.$$.fragment,t),_(Qo.$$.fragment,t),_(Yo.$$.fragment,t),_(Jo.$$.fragment,t),_(Zo.$$.fragment,t),_(tn.$$.fragment,t),_(on.$$.fragment,t),_(nn.$$.fragment,t),_(rn.$$.fragment,t),_(an.$$.fragment,t),_(ln.$$.fragment,t),_(cn.$$.fragment,t),_(mn.$$.fragment,t),_(fn.$$.fragment,t),_(un.$$.fragment,t),_(hn.$$.fragment,t),_(_n.$$.fragment,t),_(gn.$$.fragment,t),_(vn.$$.fragment,t),_(yn.$$.fragment,t),_(xn.$$.fragment,t),_(wn.$$.fragment,t),_(Dn.$$.fragment,t),_(kn.$$.fragment,t),_(Tn.$$.fragment,t),_(Mn.$$.fragment,t),_(Nn.$$.fragment,t),_(An.$$.fragment,t),_(En.$$.fragment,t),_(Un.$$.fragment,t),_(Cn.$$.fragment,t),_(Pn.$$.fragment,t),_(On.$$.fragment,t),_(Ln.$$.fragment,t),_(qn.$$.fragment,t),_(jn.$$.fragment,t),_(zn.$$.fragment,t),_(Bn.$$.fragment,t),_(Kn.$$.fragment,t),_(Wn.$$.fragment,t),_(Xn.$$.fragment,t),_(Hn.$$.fragment,t),_(Rn.$$.fragment,t),_(Qn.$$.fragment,t),_(Yn.$$.fragment,t),_(Jn.$$.fragment,t),_(Zn.$$.fragment,t),_(ts.$$.fragment,t),_(os.$$.fragment,t),_(ns.$$.fragment,t),_(ss.$$.fragment,t),_(rs.$$.fragment,t),_(is.$$.fragment,t),_(ds.$$.fragment,t),_(ls.$$.fragment,t),_(ps.$$.fragment,t),_(fs.$$.fragment,t),_(hs.$$.fragment,t),_(_s.$$.fragment,t),_(bs.$$.fragment,t),_(vs.$$.fragment,t),_(ys.$$.fragment,t),_(xs.$$.fragment,t),_($s.$$.fragment,t),_(ws.$$.fragment,t),_(Ds.$$.fragment,t),_(ks.$$.fragment,t),_(Ts.$$.fragment,t),_(Es.$$.fragment,t),_(Us.$$.fragment,t),_(Cs.$$.fragment,t),_(Ps.$$.fragment,t),_(Os.$$.fragment,t),_(Ls.$$.fragment,t),_(qs.$$.fragment,t),_(ao.$$.fragment,t),_(zs.$$.fragment,t),_(Bs.$$.fragment,t),_(lo.$$.fragment,t),_(Ss.$$.fragment,t),_(co.$$.fragment,t),_(Ks.$$.fragment,t),_(mo.$$.fragment,t),_(Ws.$$.fragment,t),_(Xs.$$.fragment,t),_(Hs.$$.fragment,t),_(Rs.$$.fragment,t),_(Qs.$$.fragment,t),_(nr.$$.fragment,t),_(sr.$$.fragment,t),_(rr.$$.fragment,t),_(ar.$$.fragment,t),_(ir.$$.fragment,t),_(dr.$$.fragment,t),_(lr.$$.fragment,t),_(cr.$$.fragment,t),_(gr.$$.fragment,t),_(br.$$.fragment,t),_(vr.$$.fragment,t),_(yr.$$.fragment,t),_(xr.$$.fragment,t),qc=!0)},o(t){g(v.$$.fragment,t),g(Po.$$.fragment,t),g(Oo.$$.fragment,t),g(Lo.$$.fragment,t),g(qo.$$.fragment,t),g(jo.$$.fragment,t),g(Io.$$.fragment,t),g(xt.$$.fragment,t),g(zo.$$.fragment,t),g($t.$$.fragment,t),g(wt.$$.fragment,t),g(So.$$.fragment,t),g(Ko.$$.fragment,t),g(Xo.$$.fragment,t),g(Ro.$$.fragment,t),g(Qo.$$.fragment,t),g(Yo.$$.fragment,t),g(Jo.$$.fragment,t),g(Zo.$$.fragment,t),g(tn.$$.fragment,t),g(on.$$.fragment,t),g(nn.$$.fragment,t),g(rn.$$.fragment,t),g(an.$$.fragment,t),g(ln.$$.fragment,t),g(cn.$$.fragment,t),g(mn.$$.fragment,t),g(fn.$$.fragment,t),g(un.$$.fragment,t),g(hn.$$.fragment,t),g(_n.$$.fragment,t),g(gn.$$.fragment,t),g(vn.$$.fragment,t),g(yn.$$.fragment,t),g(xn.$$.fragment,t),g(wn.$$.fragment,t),g(Dn.$$.fragment,t),g(kn.$$.fragment,t),g(Tn.$$.fragment,t),g(Mn.$$.fragment,t),g(Nn.$$.fragment,t),g(An.$$.fragment,t),g(En.$$.fragment,t),g(Un.$$.fragment,t),g(Cn.$$.fragment,t),g(Pn.$$.fragment,t),g(On.$$.fragment,t),g(Ln.$$.fragment,t),g(qn.$$.fragment,t),g(jn.$$.fragment,t),g(zn.$$.fragment,t),g(Bn.$$.fragment,t),g(Kn.$$.fragment,t),g(Wn.$$.fragment,t),g(Xn.$$.fragment,t),g(Hn.$$.fragment,t),g(Rn.$$.fragment,t),g(Qn.$$.fragment,t),g(Yn.$$.fragment,t),g(Jn.$$.fragment,t),g(Zn.$$.fragment,t),g(ts.$$.fragment,t),g(os.$$.fragment,t),g(ns.$$.fragment,t),g(ss.$$.fragment,t),g(rs.$$.fragment,t),g(is.$$.fragment,t),g(ds.$$.fragment,t),g(ls.$$.fragment,t),g(ps.$$.fragment,t),g(fs.$$.fragment,t),g(hs.$$.fragment,t),g(_s.$$.fragment,t),g(bs.$$.fragment,t),g(vs.$$.fragment,t),g(ys.$$.fragment,t),g(xs.$$.fragment,t),g($s.$$.fragment,t),g(ws.$$.fragment,t),g(Ds.$$.fragment,t),g(ks.$$.fragment,t),g(Ts.$$.fragment,t),g(Es.$$.fragment,t),g(Us.$$.fragment,t),g(Cs.$$.fragment,t),g(Ps.$$.fragment,t),g(Os.$$.fragment,t),g(Ls.$$.fragment,t),g(qs.$$.fragment,t),g(ao.$$.fragment,t),g(zs.$$.fragment,t),g(Bs.$$.fragment,t),g(lo.$$.fragment,t),g(Ss.$$.fragment,t),g(co.$$.fragment,t),g(Ks.$$.fragment,t),g(mo.$$.fragment,t),g(Ws.$$.fragment,t),g(Xs.$$.fragment,t),g(Hs.$$.fragment,t),g(Rs.$$.fragment,t),g(Qs.$$.fragment,t),g(nr.$$.fragment,t),g(sr.$$.fragment,t),g(rr.$$.fragment,t),g(ar.$$.fragment,t),g(ir.$$.fragment,t),g(dr.$$.fragment,t),g(lr.$$.fragment,t),g(cr.$$.fragment,t),g(gr.$$.fragment,t),g(br.$$.fragment,t),g(vr.$$.fragment,t),g(yr.$$.fragment,t),g(xr.$$.fragment,t),qc=!1},d(t){o(x),t&&o(M),t&&o(D),b(v),t&&o(Q),t&&o(Y),t&&o(Ml),t&&o(Pe),b(Po),t&&o(Nl),t&&o(N),b(Oo),b(Lo),b(qo),b(jo),b(Io),b(xt),b(zo),b($t),b(wt),b(So),b(Ko),t&&o(Al),t&&o(Le),b(Xo),t&&o(El),t&&o(Ho),b(Ro),t&&o(Ul),t&&o(qe),b(Qo),t&&o(Cl),t&&o(G),b(Yo),b(Jo),t&&o(Fl),t&&o(je),b(Zo),t&&o(Pl),t&&o(en),b(tn),t&&o(Ol),t&&o(Ie),b(on),t&&o(Ll),t&&o(J),b(nn),b(rn),t&&o(ql),t&&o(ze),b(an),t&&o(jl),t&&o(dn),b(ln),t&&o(Il),t&&o(Ve),b(cn),t&&o(zl),t&&o(F),b(mn),b(fn),b(un),b(hn),b(_n),t&&o(Vl),t&&o(Be),b(gn),t&&o(Bl),t&&o(bn),b(vn),t&&o(Sl),t&&o(Se),b(yn),t&&o(Kl),t&&o(P),b(xn),b(wn),b(Dn),b(kn),b(Tn),t&&o(Wl),t&&o(Ke),b(Mn),t&&o(Xl),t&&o(We),b(Nn),t&&o(Hl),t&&o(Xe),b(An),t&&o(Rl),t&&o(He),b(En),t&&o(Ql),t&&o(Re),b(Un),t&&o(Yl),t&&o(Z),b(Cn),b(Pn),t&&o(Gl),t&&o(Qe),b(On),t&&o(Jl),t&&o(Ye),b(Ln),t&&o(Zl),t&&o(Ge),b(qn),t&&o(ec),t&&o(A),b(jn),b(zn),b(Bn),b(Kn),b(Wn),b(Xn),b(Hn),b(Rn),t&&o(tc),t&&o(Je),b(Qn),t&&o(oc),t&&o(L),b(Yn),b(Jn),t&&o(nc),t&&o(Ze),b(Zn),t&&o(sc),t&&o(es),b(ts),t&&o(rc),t&&o(et),b(os),t&&o(ac),t&&o(me),b(ns),b(ss),t&&o(ic),t&&o(tt),b(rs),t&&o(dc),t&&o(as),b(is),t&&o(lc),t&&o(ot),b(ds),t&&o(cc),t&&o(V),b(ls),b(ps),t&&o(mc),t&&o(nt),b(fs),t&&o(pc),t&&o(us),b(hs),t&&o(fc),t&&o(st),b(_s),t&&o(uc),t&&o(gs),b(bs),t&&o(hc),t&&o(rt),b(vs),t&&o(_c),t&&o(B),b(ys),b(xs),b($s),b(ws),b(Ds),t&&o(gc),t&&o(at),b(ks),t&&o(bc),t&&o(ee),b(Ts),b(Es),t&&o(vc),t&&o(it),b(Us),t&&o(yc),t&&o(te),b(Cs),b(Ps),t&&o(xc),t&&o(dt),b(Os),t&&o($c),t&&o(U),b(Ls),b(qs),b(ao),b(zs),b(Bs),b(lo),b(Ss),b(co),b(Ks),b(mo),t&&o(wc),t&&o(lt),b(Ws),t&&o(Dc),t&&o(ct),b(Xs),b(Hs),t&&o(kc),t&&o(mt),b(Rs),t&&o(Tc),t&&o(q),b(Qs),t&&o(Mc),t&&o(pt),b(nr),t&&o(Nc),t&&o(ue),b(sr),b(rr),t&&o(Ac),t&&o(ft),b(ar),t&&o(Ec),t&&o(he),b(ir),b(dr),t&&o(Uc),t&&o(ut),b(lr),t&&o(Cc),t&&o(S),b(cr),t&&o(Fc),t&&o(ht),b(gr),t&&o(Pc),t&&o(_t),b(br),b(vr),t&&o(Oc),t&&o(gt),b(yr),t&&o(Lc),t&&o(j),b(xr)}}}const C$={local:"models",sections:[{local:"diffusers.ModelMixin",title:"ModelMixin"},{local:"diffusers.models.unet_2d.UNet2DOutput",title:"UNet2DOutput"},{local:"diffusers.UNet2DModel",title:"UNet2DModel"},{local:"diffusers.models.unet_1d.UNet1DOutput",title:"UNet1DOutput"},{local:"diffusers.UNet1DModel",title:"UNet1DModel"},{local:"diffusers.models.unet_2d_condition.UNet2DConditionOutput",title:"UNet2DConditionOutput"},{local:"diffusers.UNet2DConditionModel",title:"UNet2DConditionModel"},{local:"diffusers.models.unet_3d_condition.UNet3DConditionOutput",title:"UNet3DConditionOutput"},{local:"diffusers.UNet3DConditionModel",title:"UNet3DConditionModel"},{local:"diffusers.models.vae.DecoderOutput",title:"DecoderOutput"},{local:"diffusers.models.vq_model.VQEncoderOutput",title:"VQEncoderOutput"},{local:"diffusers.VQModel",title:"VQModel"},{local:"diffusers.models.autoencoder_kl.AutoencoderKLOutput",title:"AutoencoderKLOutput"},{local:"diffusers.AutoencoderKL",title:"AutoencoderKL"},{local:"diffusers.Transformer2DModel",title:"Transformer2DModel"},{local:"diffusers.models.transformer_2d.Transformer2DModelOutput",title:"Transformer2DModelOutput"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModel",title:"TransformerTemporalModel"},{local:"diffusers.models.transformer_temporal.TransformerTemporalModelOutput",title:"Transformer2DModelOutput"},{local:"diffusers.PriorTransformer",title:"PriorTransformer"},{local:"diffusers.models.prior_transformer.PriorTransformerOutput",title:"PriorTransformerOutput"},{local:"diffusers.models.controlnet.ControlNetOutput",title:"ControlNetOutput"},{local:"diffusers.ControlNetModel",title:"ControlNetModel"},{local:"diffusers.T2IAdapter",title:"T2IAdapter"},{local:"diffusers.MultiAdapter",title:"MultiAdapter"},{local:"diffusers.FlaxModelMixin",title:"FlaxModelMixin"},{local:"diffusers.models.unet_2d_condition_flax.FlaxUNet2DConditionOutput",title:"FlaxUNet2DConditionOutput"},{local:"diffusers.FlaxUNet2DConditionModel",title:"FlaxUNet2DConditionModel"},{local:"diffusers.models.vae_flax.FlaxDecoderOutput",title:"FlaxDecoderOutput"},{local:"diffusers.models.vae_flax.FlaxAutoencoderKLOutput",title:"FlaxAutoencoderKLOutput"},{local:"diffusers.FlaxAutoencoderKL",title:"FlaxAutoencoderKL"},{local:"diffusers.models.controlnet_flax.FlaxControlNetOutput",title:"FlaxControlNetOutput"},{local:"diffusers.FlaxControlNetModel",title:"FlaxControlNetModel"}],title:"Models"};function F$(I){return w$(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class z$ extends v${constructor(x){super();y$(this,x,F$,U$,x$,{})}}export{z$ as default,C$ as metadata};
